2018-07-01  Ludovic Courtès  <ludo@gnu.org>

	Bump version for Guile 2.2.4.
	* GUILE-VERSION (GUILE_MICRO_VERSION): Increment.
	(LIBGUILE_INTERFACE_REVISION): Increment.

2018-07-01  Ludovic Courtès  <ludo@gnu.org>

	build: Really build srfi/srfi-71.scm.
	Commit eb90831ce81bcb85ae96d27011ebe71955cdf75d added it to the wrong
	makefile.

	* module/Makefile.am (SOURCES): Add srfi/srfi-71.scm.
	* module/srfi/Makefile.am: Remove.  It's a leftover from the 2009 build
	system rework in commit 3bb299b3f0d5b31957a6447d095ed723268019be.

2018-07-01  Ludovic Courtès  <ludo@gnu.org>

	Update NEWS.
	* NEWS: Update.

	Update copyright years in '--version' and the manual.
	* module/ice-9/command-line.scm (version-etc): Change #:copyright-year
	to 2018.
	* doc/ref/guile.texi: Add 2017 and 2018 to the copyright years.
	* configure.ac (GUILE_CONFIGURE_COPYRIGHT): Add 2018.

2018-07-01  Ludovic Courtès  <ludo@gnu.org>

	Serialize accesses to submodule hash tables.
	Fixes <https://bugs.gnu.org/30602>.

	Previously, when compiling files in parallel like Guix does, threads
	would be concurrently inserting, rehashing, and reading the submodule
	hash table of module ().  Thus, some threads would sometimes see an
	inconsistent state, leading to errors such as:

	  Module named (system repl debug) does not exist

	* module/ice-9/boot-9.scm (call-with-module-autoload-lock): Move higher
	in the file.
	(module-name): Use it around call to 'nested-define-module!'.
	(resolve-module): Wrap the whole thing in 'call-with-module-autoload-lock'.

2018-06-29  Ludovic Courtès  <ludo@gnu.org>

	vm: Fix stack-marking bug in multi-threaded programs.
	Fixes <https://bugs.gnu.org/28211>.

	* libguile/vm-engine.c (call, call_label, handle_interrupts): Add
	'new_fp' variable; set the dynamic link and return address of the frame
	at NEW_FP before setting 'vp->fp'.  This fixes a bug whereby, in a
	multi-threaded context, the stack-marking code could run after vp->fp
	has been set but before its dynamic link has been set, leading the
	stack-walking code in 'scm_i_vm_mark_stack' to exit early on.

2018-06-28  Ludovic Courtès  <ludo@gnu.org>

	linker: Don't rely on out-of-range bv-ref exceptions.
	* module/system/vm/linker.scm (find-shstrndx): Check whether NAME is
	lower than the length of BV; remove 'false-if-exception' around
	'string-table-ref' call.

2018-06-24  Ludovic Courtès  <ludo@gnu.org>

	GDB support: Add 'guile-backtrace' command.
	* libguile/libguile-2.2-gdb.scm <top level>: Add 'register-command!' call.

	GDB support: Add note about (gdb frame-filters).
	* libguile/libguile-2.2-gdb.scm <top level>: Add comment.

2018-06-24  Ludovic Courtès  <ludo@gnu.org>

	GDB support: Fix 'display-vm-frames'.
	Previously 'vm-frame-older' would fail to traverse the chain of frames.

	* libguile/libguile-2.2-gdb.scm (uint-type): New variable
	(vm-frame): Fix "saved ip" and "saved fp" computation.  The latter had
	been broken roughly since commit
	72353de77d0a06f158d8af66a2540015658e2574.
	(vm-frame-older): Return #f when IP is zero, not when FP is zero.
	(vm-frame-function-name): Wrap 'vm-frame-program-debug-info' in
	'false-if-exception'

2018-06-24  Ludovic Courtès  <ludo@gnu.org>

	types: Recognize 'scm_t_port_type' and decode port type name.
	* module/system/base/types.scm (read-c-string, inferior-port-type): New
	procedures.
	(inferior-port): Use 'inferior-port-type' to determine the port type.
	(cell->object): Rename 'flags+type' to 'flags' in the '%tc7-port' case.
	* test-suite/tests/types.test ("opaque objects"): Adjust port testse.
	(test-inferior-ports): New macro.
	("ports"): New test prefix.

2018-06-24  Ludovic Courtès  <ludo@gnu.org>

	vm: Fix another typo.
	Fix typo introduced in efc33cd1497c00c5ebf961e834efc1d85f3e28ac.

	* libguile/vm.c (return_unused_stack_to_os): Remove extra 'while'.

2018-06-23  Arun Isaac  <arunisaac@systemreboot.net>

	web: Export http-request.
	* module/web/client.scm (request): Rename to http-request, add a
	docstring, and export it.
	(http-get, http-head, http-post, http-put, http-delete, http-trace,
	http-options): Update docstring.
	* doc/ref/web.texi (Web Client): Document http-request.

2018-06-19  Ludovic Courtès  <ludo@gnu.org>

	Add 'scm_to_stringn' shortcut when converting to UTF-8.
	* libguile/strings.c (scm_to_stringn): Call 'scm_to_utf8_stringn' when
	ENCODING == "UTF-8".

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	Module import obarrays are accessed in a critical section.
	Fixes <https://bugs.gnu.org/31879>.

	* libguile/modules.c (import_obarray_mutex): New variable.
	(resolve_duplicate_binding, module_imported_variable): Acquire it before
	accessing an obarray.

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	tests: Adjust i18n.test to 'fr_FR.utf8' locale in glibc 2.27.
	* test-suite/tests/i18n.test (french-number-string=?): New procedure.
	("number->locale-string")["French"]("integer", "negative integer")
	("fraction", "fraction, 1 digit"): Use it.
	("format ~h")["French"]("12345.678"): Likewise.
	("monetary-amount->locale-string")["French"]("integer", "fraction"):
	Check for both SPACE and NO-BREAK SPACE.

2018-06-18  Arun Isaac  <arunisaac@systemreboot.net>

	doc: Document (ice-9 match) macros.
	* doc/ref/match.texi: Document match-lambda, match-lambda*, match-let,
	  match-let* and match-letrec.

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	doc: Fix typo.
	Fixes <https://bugs.gnu.org/30941>.
	Reported by Fis Trivial <ybbs.daans@hotmail.com>.

	* doc/ref/libguile-foreign-objects.texi (Defining Foreign Object Types):
	Remove extraneous 'image_type' in example.

2018-06-18  Jan Smydke  <jan.smydke@gmail.com>

	get-bytevector-n and get-bytevector-n! can now read more than 4 GB
	* libguile/r6rs-ports.c (scm_get_bytevector_n, scm_get_bytevector_n_x):
	Turn 'c_count' and related variables into a 'size_t', and use
	'scm_to_size_t' instead of 'scm_to_uint'.

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	vm: Fix typo when checking for 'madvise' error code.
	* libguile/vm.c (return_unused_stack_to_os): Check for EAGAIN, not -EAGAIN.

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	Make module autoloading thread-safe.
	Fixes <https://bugs.gnu.org/31878>.

	* module/ice-9/boot-9.scm (call-with-module-autoload-lock): New procedure.
	(try-module-autoload): Wrap body in 'call-with-module-autoload-lock'.
	* module/ice-9/threads.scm: Set (@ (guile) call-with-module-autoload-lock).

2018-06-18  Ludovic Courtès  <ludo@gnu.org>

	tests: Add SRFI-71 test.
	* test-suite/tests/srfi-71.test: New file.
	* test-suite/Makefile.am (SCM_TESTS): Add it.

2018-06-18  Christopher Allan Webber  <cwebber@dustycloud.org>

	Add SRFI 71: Extended LET-syntax for multiple values.
	* module/srfi/srfi-71.scm: New file.
	* module/srfi/Makefile.am: Add it.
	* doc/ref/srfi-modules.texi: Document it.
	* NEWS: Update.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Add copyright header for (language elisp falias), and fix typo.
	* module/language/elisp/falias.scm: Add copyright header.
	* module/language/elisp/spec.scm: Fix typo in header.

	elisp: Fix cross-compilation support.
	* module/system/base/target.scm (with-native-target): New exported
	procedure.
	* module/language/elisp/spec.scm: In the top-level body expression, call
	'compile-and-load' within 'with-native-target' to compile native code.
	* module/language/elisp/compile-tree-il.scm
	(eval-when-compile, defmacro): Compile native code.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Fix error reporting in 'load-thunk-from-memory'.
	Previously 'load-thunk-from-memory' would often throw to 'system-error'
	based on a stale value in 'errno', leading to incorrect error messages.

	* libguile/loader.c (load_thunk_from_memory): Set 'errno' to 0 before
	jumping to cleanup in the ABORT preprocessor macro, and also in the case
	when 'process_dynamic_segment' reports an error.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	goops: Fix 'instance?' to work on objects that aren't structs.
	Fixes <https://bugs.gnu.org/31606>
	Reported by Tommi Höynälänmaa <tommi.hoynalanmaa@gmail.com>

	* module/oop/goops.scm (instance?): Check that OBJ is a struct
	before applying 'struct-vtable' to it.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Avoid inexact arithmetic in the type inferrer for 'sqrt'.
	* module/language/cps/types.scm: Use 'exact-integer-sqrt' and avoid
	inexact arithmetic in the range analysis of the type inferrer for
	'sqrt'.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Fix type inference for bitwise logical operators.
	Fixes <https://bugs.gnu.org/31474> and related bugs.
	Reported by Jan Nieuwenhuizen <janneke@gnu.org>.

	* module/language/cps/types.scm (next-power-of-two): Remove procedure.
	(non-negative?, lognot*, saturate+, saturate-, logand-bounds)
	(logsub-bounds, logior-bounds, logxor-bounds): New procedures.  Use them
	to improve and fix bugs in the range analysis of the type inferrers for
	'logand', 'logsub', 'logior', 'ulogior', 'logxor', 'ulogxor', and
	'lognot'.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Revert "Minor CSE run-time optimization"
	Fixes <https://bugs.gnu.org/30020>.
	Reported by David Thompson <dthompson2@worcester.edu>.

	This reverts commit d4883307ca64a7028b9a6cd072974437306c19d3.

2018-06-11  Mark H Weaver  <mhw@netris.org>

	Fix typo in comment within numbers.c

2018-05-09  Andy Wingo  <wingo@pobox.com>

	VM syncs IP in pop-fluid
	* libguile/vm-engine.c (pop-fluid): Sync IP before popping, as setting a
	  fluid may allocate.

2018-03-16  Arun Isaac  <arunisaac@systemreboot.net>

	Fix minor typo in the PEG documentation.
	* doc/ref/api-peg.texi (PEG Internals): Fix minor typo.

2018-03-16  Mark H Weaver  <mhw@netris.org>

	Fix a few typos in the manual.
	Fixes <https://bugs.gnu.org/30276>.
	Reported by Matt Wette <matt.wette@gmail.com>.

	* doc/ref/api-macros.texi (Macro Expansion)
	doc/ref/vm.texi (Procedure Call and Return Instructions): Fix typos.

2018-03-16  Mark H Weaver  <mhw@netris.org>

	Fix eta-conversion edge cases in peval.
	Fixes <https://bugs.gnu.org/29520>.
	Reported by Stefan Israelsson Tampe <stefan.itampe@gmail.com>.

	* module/language/tree-il/peval.scm (peval)[lift-applied-lambda]: Before
	performing eta-conversion, check that the variable(s) passed to the
	inner 'apply' are not referenced from the inner lambda, and that the
	number of required arguments would not be reduced by the conversion.

2018-03-16  Shea Levy  <shea@shealevy.com>

	Recognize RISC-V compilation targets.
	* module/system/base/target.scm (cpu-endianness): Add case for "riscv" variants.

2018-02-16  Ludovic Courtès  <ludo@gnu.org>

	srfi-18: 'thread-sleep!' timeout-as-a-number is relative.
	This is a followup to <https://bugs.gnu.org/29704>.

	* module/srfi/srfi-18.scm (thread-sleep!): When TIMEOUT is a number,
	keep it as-is.
	* test-suite/tests/srfi-18.test ("thread sleep with number"): Pass 0 as
	the timeout.
	("thread sleeps fractions of a second"): Pass 0.5 as the timeout.

2018-02-16  Ludovic Courtès  <ludo@gnu.org>

	srfi-18: When timeout is a number, it's a relative number of seconds.
	Fixes <https://bugs.gnu.org/29704>.
	Reported by David Beswick <dlbeswick@gmail.com>.

	* module/srfi/srfi-18.scm (timeout->absolute-time): New procedure.
	(mutex-lock!): Use it in 'thread:lock-mutex' call.
	(mutex-unlock!): Use it.
	* test-suite/tests/srfi-18.test ("mutex-lock! returns false on timeout")
	("mutex-lock! returns true when lock obtained within timeout")
	("recursive lock waits")
	("mutex unlock is false when condition times out"): Adjust cases where
	the 'timeout' parameter is a number so that it's a relative number.

2018-02-16  Ludovic Courtès  <ludo@gnu.org>

	doc: Fix typo about SRFI-4 syntax.
	Reported by Matt Wette <matt.wette@gmail.com>.
	Fixes <https://bugs.gnu.org/29910>.

	* doc/ref/api-data.texi (Array Syntax): Fix typo.

2018-02-16  Ludovic Courtès  <ludo@gnu.org>

	build: Use 'sed' invocation compatible with BSD sed.
	Fixes <https://bugs.gnu.org/30011>.
	Reported by ilove zfs <ilovezfs@icloud.com>.

	* libguile/Makefile.am (INSTANTIATE): Move '-i' first.

2018-02-16  Ludovic Courtès  <ludo@gnu.org>

	'select' returns empty sets upon EINTR and EAGAIN.
	Fixes <https://bugs.gnu.org/30368>.

	* libguile/filesys.c (scm_select): Clear READ_SET, WRITE_SET, and
	EXCEPT_SET when RV < 0.

2018-01-26  Andy Wingo  <wingo@pobox.com>

	Sync IP before allocating closures
	* libguile/vm-engine.c (vm_engine): Sync IP before allocating closures.

2018-01-15  Ludovic Courtès  <ludo@gnu.org>

	Revert "Honor '%fresh-auto-compile'."
	This reverts commit 83d4c4d622b406ec0bc9d8139ec8182fa72b5720,
	which came from a misunderstanding.

2018-01-11  Ludovic Courtès  <ludo@gnu.org>

	No tabs in C code.
	* .dir-locals.el (c-mode): Set 'indent-tabs-mode' to nil in C.

2018-01-10  Ludovic Courtès  <ludo@gnu.org>

	Make sure the return value of 'scm_crypt' is always initialized.
	* libguile/posix.c (scm_crypt): Always initialize 'ret'; error out even
	when ERR is zero.

2017-12-22  Ludovic Courtès  <ludo@gnu.org>

	compile: Load language modules upfront.
	Fixes a bug whereby "guild compile --target=arm-linux-gnueabihf
	--from=elisp ... language/elisp/boot.el" would fail with an exception
	from 'load-thunk-from-memory' while trying to load (language elisp spec)
	from the guile-being-compiled instead of using that of the
	guile-for-build.

	The problem did not manifest with --from=scheme because (language scheme
	spec) happened to be already loaded before we had changed %load-path.

	* module/scripts/compile.scm (compile): Add calls to 'lookup-language'.

2017-12-22  Ludovic Courtès  <ludo@gnu.org>

	'load-thunk-from-memory' reports the correct error.
	Previously 'load-thunk-from-memory' would often throw to 'system-error'
	when passed an incorrect ELF file, leading to incorrect error messages.

	* libguile/loader.c (load_thunk_from_memory): Reset 'errno' when
	'check_elf_header' returns non-NULL.
	* test-suite/tests/vm.test: New file.
	* test-suite/Makefile.am (SCM_TESTS): Add it.

2017-12-22  Ludovic Courtès  <ludo@gnu.org>

	Fix 'crypt' deadlock upon error.
	* libguile/posix.c (scm_crypt): Take 'scm_i_misc_mutex' right before
	calling 'crypt'.  Move 'SCM_SYSERROR' call after 'scm_dynwind_end'.
	* test-suite/tests/posix.test ("crypt"): New test prefix.

2017-12-14  Ludovic Courtès  <ludo@gnu.org>

	doc: Update LALR URL.
	Reported by Chris Vine <vine35792468@gmail.com>.

	* doc/ref/api-lalr.texi (LALR(1) Parsing): Update URL.

2017-12-01  Andy Wingo  <wingo@igalia.com>

	Bump version for Guile 2.2.3.
	* GUILE-VERSION (GUILE_MICRO_VERSION, LIBGUILE_INTERFACE_CURRENT)
	  (LIBGUILE_INTERFACE_AGE): Increment.

	Update NEWS for 2.2.3
	* NEWS: Update.

	Avoid generating arity-adapting zero-value conts where possible
	* module/language/tree-il/compile-cps.scm (adapt-arity, convert): Avoid
	  generating arity-adapting continuations for nullary continuations.

2017-11-30  Andy Wingo  <wingo@igalia.com>

	Avoid generating arity-adapting continuations if not needed
	* module/language/tree-il/compile-cps.scm (adapt-arity): Allow k to be
	  $kargs for the 1-valued case.
	  (convert): For single-valued continuations where the definition is
	  clearly single-valued, avoid making a needless $kreceive and extra
	  "rest" binding that will just be filled with () and have to be
	  eliminated later.

2017-11-30  Andy Wingo  <wingo@pobox.com>

	-O1 disables call precoloring
	* module/language/cps/compile-bytecode.scm (compile-function)
	  (emit-bytecode):
	* module/language/cps/slot-allocation.scm (allocate-slots):
	* module/language/cps/optimize.scm (cps-default-optimization-options):
	  Allow the "lazy vars" optimization, a form of slot precoloring, to be
	  disabled.  It will be disabled at -O0 or -O1, to speed compilation
	  times.

	Improve CSE complexity
	* module/language/cps/cse.scm (compute-available-expressions):
	  (compute-equivalent-subexpressions): Improve algorithmic complexity of
	  CSE by pre-computing the labels whose reads are clobbered by a label's
	  writes.

	Add compute-clobber-map to effect analysis
	* module/language/cps/effects-analysis.scm (compute-clobber-map): New
	  public function.

	Minor CSE run-time optimization
	* module/language/cps/cse.scm (compute-equivalent-subexpressions): Minor
	  optimization to reduce the size of equivalent expression keys, and to
	  avoid some work if an expression has no key.

2017-11-29  Andy Wingo  <wingo@pobox.com>

	Simplify live variable computation for graphs without loops
	* module/language/cps/slot-allocation.scm
	  (compute-reverse-control-flow-order): For graphs without back-edges,
	  use a simplified computation of reverse control flow order.

	Add nullary intmap and intset folders
	* module/language/cps/intmap.scm (intmap-fold, intmap-fold-right):
	* module/language/cps/intset.scm (intset-fold, intset-fold-right): Add
	  nullary folders.

	Fix logand type inference
	* module/language/cps/types.scm (logand): We were computing the wrong
	  ranges when either argument was negative; a terrible bug!
	  (logsub): Also fix range when A is negative and B is non-negative.
	  (ulogand): Tighten up range.

2017-11-22  Ludovic Courtès  <ludo@gnu.org>

	ltdl wrappers now use a recursive mutex.
	Fixes <https://bugs.gnu.org/29275>.
	Reported by noxdafox <noxdafox@gmail.com>.

	* libguile/dynl.c (scm_init_dynamic_linking): Add call to
	'scm_i_pthread_mutex_init'.

2017-11-22  Matt Wette  <matt.wette@gmail.com>
	    Ludovic Courtès  <ludo@gnu.org>

	foreign: Add 'uintptr_t' and 'intptr_t'.
	* libguile/foreign.c (scm_uintptr_t, scm_intptr_t): New variables.
	(scm_init_foreign): Define them.
	* module/system/foreign.scm: Export 'intptr_t' and 'uintptr_t'.
	* doc/ref/api-foreign.texi (Foreign Types): Document them.

2017-11-22  Maxim Cournoyer  <maxim.cournoyer@gmail.com>

	scripts: help: Fix reference to the "Using Guile Tools" node.
	Fixes <https://bugs.gnu.org/28835>.

	* module/scripts/help.scm (list-commands): Fix reference to the "Using
	Guile Tools" node.

2017-11-22  Sergei Trofimovich  <slyfox@gentoo.org>

	ia64: Fix crash in thread context switch.
	Fixes <https://bugs.gnu.org/29151> and <https://bugs.gentoo.org/613986>.

	Backtrace looks like that:

	  Program terminated with signal SIGSEGV, Segmentation fault.
	  #0  0x200000000014a5c0 in scm_ia64_longjmp (JB=0x6000000000817020, VAL=1) at continuations.c:372
	  372                   t->pending_rbs_continuation->backing_store,
	  [Current thread is 1 (Thread 0x2000000000049340 (LWP 8190))]
	  (gdb) bt
	  #0  0x200000000014a5c0 in scm_ia64_longjmp (JB=0x6000000000817020, VAL=1) at continuations.c:372
	  #1  0x2000000000148e00 in scm_c_abort (vm=0x60000000000edea0, tag=0x6000000000795ba0, n=0, argv=0x60000fffff7f0ce0, cookie=-1) at control.c:239
	  #2  0x2000000000149070 in scm_at_abort (tag=0x6000000000795ba0, args=0x304) at control.c:258
	  (gdb) print t
	  $2 = (scm_i_thread *) 0x6000000000068000
	  (gdb) print t->pending_rbs_continuation
	  $3 = (scm_t_contregs *) 0xffeb

	The problem here is the value of 't->pending_rbs_continuation' pointer.
	It's supposed to poin to a register stack pointer or be NULL if not yet
	backed up.

	The problem is it is never initialized to NULL at creation time and
	contained garbage on stack. Sometimes people are lucky and have zeros
	on stack and guile works. But sometimes there is something and guile
	crashes.

	The fix is trivial: initialize 'pending_rbs_continuation = NULL'
	at thread registration time (the same way other threads are registered).

	Reported-by: Matt Turner

	* libguile/threads.c (guilify_self_1): Initialize pending_rbs_continuation
	to avoid crash on ia64.

2017-11-22  Arun Isaac  <arunisaac@systemreboot.net>

	Mention (ice-9 peg) module path.
	* doc/ref/api-peg.texi (PEG Parsing): Mention (ice-9 peg) module path.

	Convert `close' ref to xref.
	* doc/ref/api-io.texi (Ports): Convert `close' ref to xref.

2017-11-22  Ludovic Courtès  <ludo@gnu.org>

	Honor '%fresh-auto-compile'.
	Fixes <https://bugs.gnu.org/29226>.

	* libguile/load.c (scm_primitive_load_path): Set 'compiled_thunk' to
	SCM_BOOL_F when *scm_loc_fresh_auto_compile is true.
	* module/ice-9/boot-9.scm (load-in-vicinity)[load-absolute]: Call
	'pre-compiled' only when %FRESH-AUTO-COMPILE is false.

2017-11-18  Ludovic Courtès  <ludo@gnu.org>

	Destroy the mutex associated with a dirstream.
	This is a followup to 187655cedb42cc4b01088179649b02295cd35260.

	* libguile/filesys.c (scm_dir_free): Add call to
	'scm_i_pthread_mutex_destroy'.

2017-11-17  Ludovic Courtès  <ludo@gnu.org>

	'readdir' no longer deadlocks upon error.
	If 'readdir' returned an error, we'd call SCM_SYSERROR, which would try
	to acquire 'scm_i_misc_mutex' and sit there forever because it was
	already taken.

	Reported at <https://bugs.gnu.org/29335>.

	* libguile/filesys.c (scm_opendir): Allocate storage for a mutex and
	store it as the third word of the SMOB.
	(scm_readdir): Use that mutex instead of 'scm_i_misc_mutex'.  Fixes the
	deadlock upon error.
	(scm_rewindir): Lock the mutex around the 'rewinddir' call.

2017-11-11  Ludovic Courtès  <ludo@gnu.org>

	http: Fix typo in proxy handling in 'write-request-line'.
	Reported by Mark H Weaver <mhw@netris.org>
	at <https://lists.gnu.org/archive/html/guix-devel/2017-11/msg00190.html>.

	* module/web/http.scm (write-request-line): Fix more typos introduced in
	96b994b6f815747ce2548123cc996d8132bd4781.

2017-11-10  Ludovic Courtès  <ludo@gnu.org>

	http: Fix typo in proxy handling in 'write-request-line'.
	Reported by Konrad Hinsen <konrad.hinsen@fastmail.net>
	at <https://lists.gnu.org/archive/html/guix-devel/2017-11/msg00070.html>.

	* module/web/http.scm (write-request-line): Move 'string-index' first in
	'cond' clause.  Fixes a regression introduced in
	96b994b6f815747ce2548123cc996d8132bd4781.

2017-11-09  Ludovic Courtès  <ludo@gnu.org>

	Print exception location only once.
	Fixes a regression introduced in commit
	39090e677eed54761e0952f2575ddef1504545d3.

	* module/ice-9/boot-9.scm (exception-printers)[print-exception]: Remove
	extraneous 'print-location' call.

2017-11-05  Ludovic Courtès  <ludo@gnu.org>

	Allow GDB support to be used with GDB-linked-against-Guile-2.0.
	* libguile/Makefile.am (INSTANTIATE): New variable.
	(install-data-hook): Use it.
	* libguile/libguile-2.2-gdb.scm: Autoload (system vm debug).
	Augment %load-path and %load-compiled-path, and reload (system base
	types).
	* module/system/base/types.scm: Remove #:hide to be 2.0-compatible.
	Use (system syntax internal) conditionally when on 2.2.

2017-11-01  Andy Wingo  <wingo@pobox.com>

	More robust vacuuming of in-use weak tables
	* libguile/weak-table.c (scm_t_weak_table); Add last_gc_no member.
	* libguile/weak-table.c (vacuum_weak_table): Only vacuum if we haven't
	  done so since the last GC.
	  (scm_c_weak_table_ref, scm_c_weak_table_put_x, scm_c_weak_table_remove_x)
	  (scm_c_weak_table_fold): Vacuum the weak table if needed.
	  (scm_weak_table_clear_x): Update last_gc_no flag, as no more vacuuming
	  will be needed.

	Refactor weak table to use bitmaps for weak entries

2017-11-01  Andy Wingo  <wingo@pobox.com>

	Weak tables are now bucket-and-chain tables
	This change should make weak tables work better with libgc, as the weak
	components that need mark functions are smaller, so they don't overflow
	the mark queue.  Also this prevents the need to move disappearing
	links.

	* libguile/weak-table.c (scm_t_weak_entry): Change to be a hash table
	  chain entry.
	  (struct weak_entry_data, do_read_weak_entry, read_weak_entry): Read
	  out the key and value directly.
	  (GC_move_disappearing_link, move_disappearing_links, move_weak_entry):
	  Remove.
	  (scm_t_weak_table): Rename "entries" member to "buckets", and "size" to
	  "n_buckets".
	  (hash_to_index, entry_distance, rob_from_rich, give_to_poor): Remove.
	  (mark_weak_key_entry, mark_weak_value_entry): Mark a single link, and
	  the next link.
	  (mark_doubly_weak_entry): New kind.
	  (allocate_entry): Allocate a single entry.
	  (add_entry): New helper.
	  (resize_table): Reimplement more like normal hash tables.
	  (vacuum_weak_table): Adapt to new implementation.
	  (weak_table_ref, weak_table_put_x, weak_table_remove_x): Adapt.
	  (make_weak_table): Adapt.
	  (scm_weak_table_clear_x): Actually unregister the links to prevent a
	  memory leak.
	  (scm_c_weak_table_fold): Collect items in an alist, then fold outside
	  the lock.
	  (scm_weak_table_prehistory): Initialize doubly_weak_gc_kind.

2017-10-31  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Support general arrays in random:hollow-sphere!
	* libguile/random.c (vector_scale_x, vector_sum_squares): Handle general
	  rank-1 #t or 'f64 arrays.
	* test-suite/tests/random.test: Add tests for random:hollow-sphere!.

	Fix bitvectors and non-zero lower bound arrays in truncated-print
	* module/ice-9/arrays.scm (array-print-prefix): New private function.
	* libguile/arrays.c (scm_i_print_array): Reuse (array-print-prefix) from
	  (ice-9 arrays). Make sure to release the array handle.
	* module/ice-9/pretty-print.scm (truncated-print): Support
	  bitvectors.
	  Don't try to guess the array prefix but call array-print-prefix from
	  (ice-9 arrays) instead.
	  Fix call to print-sequence to support non-zero lower bound arrays.
	* test-suite/tests/arrays.test: Test that arrays print properly.
	* test-suite/tests/print.test: Test truncated-print with bitvectors,
	  non-zero lower bound arrays.

	Support non-zero lower bounds in array-slice-for-each
	* libguile/array-handle.c (scm_array_handle_writable_elements): Fix
	  error message.
	* libguile/array-map.c (scm_array_slice_for_each): Support non-zero
	  lower bounds. Fix error messages.
	* test-suite/tests/array-map.test: Test scm_array_slice_for_each with
	  non-zero lower bound argument.

	Fix sort, sort! for arrays with nonzero lower bound
	* module/ice-9/arrays.scm (array-copy): New function, export.
	* module/Makefile.am: Install (ice-9 arrays).
	* doc/ref/api-data.texi: Add documentation for (ice-9 arrays).
	* libguile/quicksort.i.c: Use signed bounds throughout.
	* libguile/sort.c (scm_restricted_vector_sort_x): Fix error calls. Fix
	  calls to quicksort.
	* test-suite/tests/sort.test: Actually test that the sorted results
	  match the original data. Test cases for non-zero base index arrays for
	  sort, sort!, and stable-sort!.

	Remove documentation on uniform-vector-read!, uniform-vector-write
	* NEWS: Add specific removal notice.
	* doc/ref/api-data.texi: Remove documentation on uniform-vector-read!,
	  uniform-vector-write.

	Replace uniform-vector-read benchmark with bytevector-io benchmark
	* benchmark-suite/benchmarks/uniform-vector-read.bm:
	  Remove; uniform-vector-read! and uniform-vector-write were deprecated
	  in 2.0 and are have been removed in 2.1.
	* benchmark-suite/benchmarks/bytevector-io.bm: New benchmark.
	* benchmark-suite/Makefile.am: Run the new benchmark.

	Allow scm_XXX_writable_elements on empty vectors, even if immutable
	* libguile/array-handle.c (initialize_vector_handle): Set both element
	  pointers to NULL if the vector is empty.
	* libguile/array-map.c (racp): Ignore immutability if destination is
	  empty.
	* test-suite/tests/sort.test: Check empty/mutable/immutable vectors with
	  sort!.
	* test-suite/tests/array-map.test: Check array-copy! with
	  empty/immutable destination.

2017-10-25  Ludovic Courtès  <ludo@gnu.org>

	Allow garbage collection of revealed file ports.
	Reported at <https://bugs.gnu.org/28784>.
	Discussed at
	<https://lists.gnu.org/archive/html/guile-devel/2017-10/msg00003.html>.

	* libguile/fports.c (revealed_ports, revealed_lock): Remove.
	(scm_revealed_count): Just return 'SCM_REVEALED (port)'.
	(scm_set_port_revealed_x, scm_adjust_port_revealed_x): Remove
	REVEALED_PORTS manipulation.
	(fport_close): Do nothing when SCM_REVEALED (port) > 0.
	* libguile/fports.h (scm_t_fport): Adjust comment; make 'revealed'
	unsigned.
	* libguile/ports.c (do_close): Call 'close_port' instead of
	'scm_close_port'.
	(scm_close_port): Rename to...
	(close_port): ... this.  Add 'explicit' parameter.  Clear 'revealed'
	field when PORT is a file port and EXPLICIT is true.
	(scm_close_port): Call 'close_port'.
	* test-suite/tests/ports.test ("close-port & revealed port")
	("revealed port fdes not closed"): New tests.

2017-10-25  Ludovic Courtès  <ludo@gnu.org>

	'frame-matcher' doesn't crash when the last IP is unknown.
	This fixes a bug when using ",break":

	  system/vm/traps.scm:127:31: system/vm/traps.scm:127:31: In procedure <: Wrong type: #f

	* module/system/vm/traps.scm (frame-matcher): Check whether END is
	true.

2017-09-25  Andy Wingo  <wingo@pobox.com>

	Add struct-ref/unboxed, struct-set!/unboxed
	* NEWS: Add news entry.
	* doc/ref/api-data.texi (Vtables, Structure Basics): Update
	  documentation.
	* libguile/struct.c (scm_i_struct_equalp): Avoid using struct-ref on
	  unboxed fields.
	  (scm_struct_ref, scm_struct_set_x_unboxed): Issue deprecation warning
	  when accessing unboxed fields.
	  (scm_struct_ref_unboxed, scm_struct_set_x_unboxed): New functions.
	* libguile/struct.h (scm_struct_ref_unboxed, scm_struct_set_x_unboxed):
	  New functions.
	* module/oop/goops.scm (class-add-flags!, class-clear-flags!):
	  (class-has-flags?, <class>, %allocate-instance, <slot>):
	  (compute-get-n-set, unboxed-get, unboxed-set, unboxed-slot?):
	  (allocate-slots, %prep-layout!, make-standard-class, initialize):
	  Adapt to access unboxed nfields and flags fields via the new
	  accessors.

2017-09-23  Andy Wingo  <wingo@pobox.com>

	GOOPS slot access protected via slot accessors, not struct perms
	* module/oop/goops.scm (opaque-slot?, read-only-slot?): New helpers.
	  (allocate-slots): Protect opaque and read-only slots by wrapping the
	  slot accessors instead of relying on struct permissions.
	  (%compute-layout): Remove opaque-slot case.

	Deprecate opaque struct fields
	* NEWS: Add entry.
	* doc/ref/api-data.texi (Vtables, Structure Basics): Remove mention of
	  opaque field protection.
	* libguile/struct.c (scm_make_struct_layout, scm_make_struct_no_tail):
	  Remove discussion of opaque fields.
	  (set_vtable_layout_flags): Issue a deprecation warning when opaque
	  fields are used.

2017-09-22  Andy Wingo  <wingo@pobox.com>

	Remove needless static variables from goops.c
	* libguile/goops.c: Remove many static SCM variables that were not
	  used on the C level, like class_protected for <protected-slot> and so
	  on.

	Fix up make-struct-layout and make-struct/no-tail docstrings
	* libguile/struct.c (scm_make_struct_layout, scm_make_struct_no_tail):
	  Fix up docstrings for self and tail deprecation.

	Deprecate struct "self" slots
	* libguile/print.h (SCM_PRINT_STATE_LAYOUT): Use a normal slot instead
	  of a self slot.
	* libguile/print.c (make_print_state): Initialize "handle" slot
	  manually.
	* libguile/struct.c (issue_deprecation_warning_for_self_slots): New
	  helper, called when making vtables to issue deprecation warnings for
	  "self" slots.  Avoids warning for the "self" slot that's part of the
	  fixed vtable slots.
	  (scm_i_struct_inherit_vtable_magic): Call
	  issue_deprecation_warning_for_self_slots.
	* doc/ref/api-data.texi (Vtables, Structure Basics): Remove references
	  to self slots.
	* NEWS: Add entry.

	Remove unused code in struct.c
	* libguile/struct.c (scm_make_struct_layout, scm_struct-ref)
	  (scm_struct_set_x): Remove commented-out support for signed and double
	  raw fields.

	Deprecate make-struct
	* libguile/struct.c: Replace uses of scm_make_struct with
	  scm_make_struct_no_tail or scm_c_make_struct.
	  (scm_make_struct_no_tail): Move this function to C instead of Scheme
	  to be able to deprecate scm_make_struct.
	* libguile/struct.h (scm_make_struct_no_tail): New public declaration.
	* libguile/deprecated.h:
	* libguile/deprecated.c (scm_make_struct): Deprecate.
	* libguile/print.c:
	* libguile/procs.c:
	* libguile/stacks.c: Replace uses of scm_make_struct with
	  scm_make_struct_no_tail.
	* test-suite/tests/coverage.test:
	* test-suite/tests/structs.test: Use make-struct/no-tail instead of
	  make-struct.
	* NEWS: Add entry.

2017-09-20  Andy Wingo  <wingo@pobox.com>

	Remove references to tail arrays in the documentation
	* doc/ref/api-data.texi (Vtables, Structure Basics): Update to remove
	  references to tail arrays, in preparation for deprecation.

	Use make-struct/no-tail instead of make-struct
	* module/ice-9/boot-9.scm:
	* module/language/cps/effects-analysis.scm:
	* module/language/elisp/falias.scm:
	* module/language/tree-il.scm:
	* module/language/tree-il/primitives.scm:
	* module/rnrs/records/procedural.scm:
	* module/srfi/srfi-35.scm:
	* module/system/base/syntax.scm: Change uses of make-struct to
	  make-struct/no-tail.

	psyntax generates calls to make-struct/no-tail
	* module/ice-9/psyntax.scm (define-expansion-constructors): Expand to
	  make-struct/no-tail.
	* module/ice-9/psyntax-pp.scm: Regenerate.

2017-07-31  Mark H Weaver  <mhw@netris.org>

	put-bytevector, unget-bytevector: Allow start == bytevector length.
	* libguile/r6rs-ports.c (scm_put_bytevector, scm_unget_bytevector): When
	three arguments (port bv start) are provided, allow start to be equal to
	the length of the bytevector, resulting in a zero-length write.

2017-06-15  Ludovic Courtès  <ludo@gnu.org>

	Correctly relativize file names in the presence of common prefixes.
	* libguile/filesys.c (scm_i_relativize_path): When DIR is a prefix of
	SCANON, make sure DIR ends with a separator or SCANON starts with a
	separator.
	* test-suite/tests/ports.test (%temporary-directory): New variable.
	("%file-port-name-canonicalization")["relative canonicalization with
	common prefixes"]: New test.

2017-06-12  Mark H Weaver  <mhw@netris.org>

	doc: Document 'short' and 'unsigned-short' foreign types.
	This is a followup to commit 42f7c01e0a1d1c139ec8b835429a80ab15ac4007.
	Reported by Adriano Peluso <catonano@gmail.com>.

	* doc/ref/api-foreign.texi (Foreign Types): Add missing entries for
	'short' and 'unsigned-short'.

2017-05-31  Andy Wingo  <wingo@pobox.com>

	Update guile.m4 to check for 2.2 by default
	* meta/guile.m4 (GUILE_PKG): Update default Guile versions to 2.2.

	guile.m4 fix for 3.0 prereleases
	* meta/guile.m4 (GUILE_PROGS): Allow prereleases of Guile with a new
	  major version.

2017-05-22  Andy Wingo  <wingo@pobox.com>

	Minor updates of README.
	* README: Minor updates.

	Remove legacy NEWS.guile-vm.
	* NEWS.guile-vm: Remove.

	Minor updates to HACKING.
	* HACKING: Minor updates.

	Remove outdated ANNOUNCE.
	* ANNOUNCE: Remove outdated file.

	Remove outdated README.guile-vm.
	* README.guile-vm: Remove.

2017-05-21  Andy Wingo  <wingo@pobox.com>

	web: add support for URI-reference
	Based on a patch by Daniel Hartwig <mandyke@gmail.com>.

	* NEWS: Update.
	* doc/ref/web.texi (URIs): Fragments are properly part of a URI, so
	  remove the incorrect note.  Add documentation on URI subtypes.
	* module/web/uri.scm (uri-reference?): New base type predicate.
	  (uri?, relative-ref?): Specific predicates.
	  (validate-uri-reference): Strict validation.
	  (validate-uri, validate-relative-ref): Specific validators.
	  (build-uri-reference, build-relative-ref): New constructors.
	  (string->uri-reference): Rename from string->uri.
	  (string->uri, string->relative-ref): Specific constructors.
	  (uri->string): Add #:include-fragment? keyword argument.
	* module/web/http.scm (parse-request-uri): Use `build-uri-reference',
	  and result is a URI-reference, not URI, object.  No longer infer an
	  absent `uri-scheme' is `http'.
	  (write-uri): Just use `uri->string'.
	  (declare-uri-header!): Remove unused function.
	  (declare-uri-reference-header!): Update.  Rename from
	  `declare-relative-uri-header!'.
	* test-suite/tests/web-uri.test ("build-uri-reference"):
	  ("string->uri-reference"): Add.
	  ("uri->string"): Also tests for relative-refs.
	* test-suite/tests/web-http.test ("read-request-line"):
	  ("write-request-line"): Update for no scheme in some URIs.
	  ("entity headers", "request headers"): Content-location, Referer, and
	  Location should also parse relative-URIs.
	* test-suite/tests/web-request.test ("example-1"): Expect URI-reference
	  with no scheme.

2017-05-17  Andy Wingo  <wingo@pobox.com>

	readline: Avoid interpreting control characters in pastes.
	* NEWS: Update.
	* doc/ref/repl-modules.texi (Readline Options): Update for
	  bracketed-paste.
	* guile-readline/readline.h (SCM_READLINE_BRACKETED_PASTE): Add
	  bracketed-paste option.
	* guile-readline/readline.c (scm_readline_opts): Add bracketed-paste.
	  (scm_init_readline): Wire up the logic.

2017-05-16  Manolis Ragkousis  <manolis837@gmail.com>

	On Hurd, skip tests that require working setrlimits for memory
	On Hurd, setrlimits are not yet implemented. See
	<https://lists.gnu.org/archive/html/bug-hurd/2017-05/msg00013.html>.

	* test-suite/standalone/test-out-of-memory: skip for Hurd.
	* test-suite/standalone/test-stack-overflow: skip for Hurd.

2017-04-28  Andy Wingo  <wingo@pobox.com>

	Fix reading of HTTPS responses that are smaller than port buffer
	* module/web/client.scm (tls-wrap): Use get-bytevector-some instead of
	  get-bytevector-n, to prevent Guile from attempting to read more bytes
	  than are available.  Normally trying to read data on a shut-down
	  socket is fine, but but gnutls issues an error if you attempt to read
	  data from a shut-down socket, and that appears to be a security
	  property.  Fixes HTTPS requests whose responses are smaller than the
	  port buffer.

2017-04-25  Zefram  <zefram@fysh.org>

	Correct note about Gregorian reform in SRFI-19
	* doc/ref/srfi-modules.texi (SRFI-19): SRFI-19 specifies proleptic use
	of the Gregorian calendar, so it was incorrect of the documentation to
	describe the code as erroneous in doing so.  Rewrite the caution more
	neutrally, and move it to the section about the "date" structure, where
	it seems most relevant.

2017-04-22  Ludovic Courtès  <ludo@gnu.org>

	SRFI-19: Swap seconds and nanoseconds in 'current-time-monotonic'.
	* module/srfi/srfi-19.scm (current-time-monotonic): Swap the 2nd and 3rd
	arguments.  Fixes a regression introduced in
	commit b11e2922c36c4105797c269c7e616535b702698a.

2017-04-21  Andy Wingo  <wingo@pobox.com>

	Bump version to 2.2.2.
	* GUILE-VERSION: Bump to 2.2.2.

	Update NEWS some more
	* NEWS: More updates.

	Update NEWS.
	* NEWS: Update.

	Syntax objects are comparable with equal?
	* libguile/eq.c (scm_equal_p, scm_raw_ihash): Add cases for syntax
	  objects, which should be comparable with equal?.
	* test-suite/tests/syntax.test ("syntax objects"): Add tests.

2017-04-20  Thomas Danckaert  <thomas.danckaert@gmail.com>

	SRFI-37: Account for zero-length arguments.
	* module/srfi/srfi-37.scm (args-fold): When checking if an argument is
	an option (starts with #\-), first check if the length is non-zero.

2017-04-20  Andy Wingo  <wingo@pobox.com>

	Restore libgc 7.2 compatibility
	* configure.ac: Check for GC_is_heap_ptr, added after libgc 7.2.
	* libguile/pairs.h (GC_is_heap_ptr): Define a shim for GC_is_heap_ptr,
	  inside BUILDING_LIBGUILE so as not to expose it to users.

2017-04-19  Andy Wingo  <wingo@pobox.com>

	GNU Guile 2.2.1.
	* GUILE-VERSION (GUILE_MICRO_VERSION, LIBGUILE_INTERFACE_CURRENT):
	  (LIBGUILE_INTERFACE_AGE): Increment version.

	Update release docs
	* doc/release.org: Update for 2.2.

	Update NEWS
	* NEWS: Update.

2017-04-19  Sergei Trofimovich  <slyfox@gentoo.org>

	guile-snarf: skip -g* arguments to avoid build failure
	* libguile/guile-snarf.in: skip -g* arguments to avoid failure on
	  -ggdb3.

	Bug: https://bugs.gentoo.org/608190
	Bug: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25803

2017-04-19  Sergei Trofimovich  <slyfox@gentoo.org>

	api-procedures.texi: typo: 'an' -> 'on'
	* doc/ref/api-procedures.texi: Fix typo.

	Documentation typo tweak
	* doc/ref/api-data.texi: Tweak 'u+0007' to 'U+0007' (as in the rest of
	  the table).

2017-04-19  Andy Wingo  <wingo@pobox.com>

	Fix spurious warnings in net_db.c
	* libguile/guile-func-name-check (/^SCM_DEFINE /): Fix pattern to not
	  produce spurious warnings.  Thanks to Dale Smith for the suggestion.
	  Fixes https://bugs.gnu.org/26123.

2017-04-19  Freja Nordsiek  <fnordsie@gmail.com>

	Fixed bug: statprof flat display wasn't writing summary lines to port
	* module/statprof.scm (statprof-display/flat): fixed bug where summary lines
	  were written to (current-output-port) instead of the provided port.

2017-04-19  Andy Wingo  <wingo@pobox.com>

	Document guile-2.2 cond-expand feature.
	* doc/ref/srfi-modules.texi (SRFI-0): Mention guile-2.2 feature.

	Add --with-bdw-gc and update README
	* README: Update to 2.2.  Add instructions for FreeBSD based on notes
	  from Matt Wette.
	* configure.ac: Add --with-bdw-gc argument.

	Fix typo in fold-layout documentation
	* doc/ref/sxml.texi (SXML Tree Fold): Fix minor typo.  Fixes
	  https://bugs.gnu.org/26188.

	Add srfi-19 ~f regression test
	* test-suite/tests/srfi-19.test ("SRFI date/time library"): Add test for
	  https://bugs.gnu.org/26259.

	Fix date->string ~f operator to not emit leading zeros
	* module/srfi/srfi-19.scm (directives): Format ~f without leading
	  zeroes.  Fixes https://bugs.gnu.org/26260.
	* test-suite/tests/srfi-19.test ("SRFI date/time library"): Add test.

2017-04-19  Andrew Moss  <andrewmoss@pobox.com>

	Fixed bug: ~N mishandles small nanoseconds value
	Fixes <http://bugs.gnu.org/26261>.
	Reported by Zefram <zefram@fysh.org>.

	* module/srfi/srfi-19.scm ("define directives"): N padding increased from 7 to 9

	* test-suite/tests/srfi-19.test ("date->string"): New test.

2017-04-19  Andy Wingo  <wingo@pobox.com>

	SRFI-19 current-time-monotonic returns time of right type
	* module/srfi/srfi-19.scm (current-time-monotonic): Actually return a
	  time with the correct type.  Fixes #26329.

	Avoid causing GC when lookup up exception handler
	* libguile/fluids.c (scm_fluid_ref_star): Avoid causing GC.  Possibly
	  fixes some crashes during out-of-memory conditions (#26351).

	Fix test suite for constant literals change
	* test-suite/tests/elisp-compiler.test ("List Built-Ins"): Avoid
	  mutating a literal pair.  If this turns out to be necessary for elisp,
	  the compiler will have to compile literals to calls to run-time heap
	  allocations rather than constants.

2017-04-18  Andy Wingo  <wingo@pobox.com>

	Bump objcode version in a compatible way
	* libguile/_scm.h (SCM_OBJCODE_MINIMUM_MINOR_VERSION): New definition,
	  indicating the oldest objcode version that we support.
	  (SCM_OBJCODE_MINOR_VERSION): Bump.
	* libguile/loader.c (process_dynamic_segment): Support a range of
	  versions.
	* module/system/vm/assembler.scm (*bytecode-minor-version*): Bump.

	Add sandboxed evaluation facility
	* module/ice-9/sandbox.scm: New file.
	* module/Makefile.am (SOURCES): Add new file.
	* doc/ref/api-evaluation.texi (Sandboxed Evaluation): New section.
	* NEWS: Update.
	* test-suite/tests/sandbox.test: New file.
	* test-suite/Makefile.am: Add new file.

	Update NEWS
	* NEWS: Add note about constants and mutation.

	All literal constants are read-only
	* libguile/array-handle.c (initialize_vector_handle): Add mutable_p
	  argument.  Unless the vector handle is mutable, null out its
	  writable_elements member.
	  (scm_array_get_handle): Adapt to determine mutability of the various
	  arrays.
	  (scm_array_handle_elements, scm_array_handle_writable_elements):
	  Reverse the sense: instead of implementing read-only in terms of
	  read-write, go the other way around, adding an assertion in the
	  read-write case that the array handle is mutable.
	* libguile/array-map.c (racp): Assert that the destination is mutable.
	* libguile/bitvectors.c (SCM_F_BITVECTOR_IMMUTABLE, IS_BITVECTOR):
	  (IS_MUTABLE_BITVECTOR): Add a flag to indicate immutability.
	  (scm_i_bitvector_bits): Fix indentation.
	  (scm_i_is_mutable_bitvector): New helper.
	  (scm_array_handle_bit_elements)
	  ((scm_array_handle_bit_writable_elements): Build writable_elements in
	  terms of elements.
	  (scm_bitvector_elements, scm_bitvector_writable_elements): Likewise.
	  (scm_c_bitvector_set_x): Require a mutable bitvector for the
	  fast-path.
	  (scm_bitvector_to_list, scm_bit_count): Use read-only elements()
	  function.
	* libguile/bitvectors.h (scm_i_is_mutable_bitvector): New decl.
	* libguile/bytevectors.c (INTEGER_ACCESSOR_PROLOGUE):
	  (INTEGER_GETTER_PROLOGUE, INTEGER_SETTER_PROLOGUE):
	  (INTEGER_REF, INTEGER_NATIVE_REF, INTEGER_SET, INTEGER_NATIVE_SET):
	  (GENERIC_INTEGER_ACCESSOR_PROLOGUE):
	  (GENERIC_INTEGER_GETTER_PROLOGUE, GENERIC_INTEGER_SETTER_PROLOGUE):
	  (LARGE_INTEGER_NATIVE_REF, LARGE_INTEGER_NATIVE_SET):
	  (IEEE754_GETTER_PROLOGUE, IEEE754_SETTER_PROLOGUE):
	  (IEEE754_REF, IEEE754_NATIVE_REF, IEEE754_SET, IEEE754_NATIVE_SET):
	  Setters require a mutable bytevector.
	  (SCM_BYTEVECTOR_SET_FLAG): New helper.
	  (SCM_BYTEVECTOR_SET_CONTIGUOUS_P, SCM_BYTEVECTOR_SET_ELEMENT_TYPE):
	  Remove helpers.
	  (SCM_VALIDATE_MUTABLE_BYTEVECTOR): New helper.
	  (make_bytevector, make_bytevector_from_buffer): Use
	  SCM_SET_BYTEVECTOR_FLAGS.
	  (scm_c_bytevector_set_x, scm_bytevector_fill_x)
	  (scm_bytevector_copy_x): Require a mutable bytevector.
	* libguile/bytevectors.h (SCM_F_BYTEVECTOR_CONTIGUOUS)
	  (SCM_F_BYTEVECTOR_IMMUTABLE, SCM_MUTABLE_BYTEVECTOR_P): New
	  definitions.
	* libguile/bytevectors.h (SCM_BYTEVECTOR_CONTIGUOUS_P): Just access one
	  bit.
	* libguile/srfi-4.c (DEFINE_SRFI_4_C_FUNCS): Implement
	  writable_elements() in terms of elements().
	* libguile/strings.c (scm_i_string_is_mutable): New helper.
	* libguile/uniform.c (scm_array_handle_uniform_elements):
	  (scm_array_handle_uniform_writable_elements): Implement
	  writable_elements in terms of elements.
	* libguile/vectors.c (SCM_VALIDATE_MUTABLE_VECTOR): New helper.
	  (scm_vector_elements, scm_vector_writable_elements): Implement
	  writable_elements in terms of elements.
	  (scm_c_vector_set_x): Require a mutable vector.
	* libguile/vectors.h (SCM_F_VECTOR_IMMUTABLE, SCM_I_IS_MUTABLE_VECTOR):
	  New definitions.
	* libguile/vm-engine.c (VM_VALIDATE_MUTABLE_BYTEVECTOR):
	  (VM_VALIDATE_MUTABLE_VECTOR, vector-set!, vector-set!/immediate)
	  (BV_BOUNDED_SET, BV_SET): Require mutable bytevector/vector.
	* libguile/vm.c (vm_error_not_a_mutable_bytevector):
	  (vm_error_not_a_mutable_vector): New definitions.
	* module/system/vm/assembler.scm (link-data): Mark residualized vectors,
	  bytevectors, and bitvectors as being read-only.

	Attempt to mutate residualized literal pair throws exception
	* libguile/validate.h (SCM_VALIDATE_MUTABLE_PAIR):
	* libguile/pairs.h (scm_is_mutable_pair): New internal definitions.
	* libguile/pairs.c (scm_set_car_x, scm_set_cdr_x): Validate mutable
	  pairs.
	* libguile/alist.c (scm_assq_set_x, scm_assv_set_x, scm_assoc_set_x):
	* libguile/list.c (scm_reverse_x, scm_list_set_x, scm_list_cdr_set_x):
	* libguile/srcprop.c (scm_make_srcprops):
	* libguile/srfi-1.c (scm_srfi1_append_reverse_x)
	  (scm_srfi1_delete_duplicates_x):
	* libguile/symbols.c (scm_symbol_fset_x, scm_symbol_pset_x):
	* libguile/sort.c (scm_merge_list_x): Use scm_set_car_x / scm_set_cdr_x
	  instead of the macros, so as to check for mutable pairs.
	  (SCM_VALIDATE_MUTABLE_LIST): New internal helper macro.
	  (scm_sort_x, scm_stable_sort_x, scm_sort_list_x): Use
	  SCM_VALIDATE_MUTABLE_LIST.
	* libguile/vm-engine.c (VM_VALIDATE_MUTABLE_PAIR): New definition.
	  (set-car!, set-cdr!): Use VM_VALIDATE_MUTABLE_PAIR.  Fix error message
	  for set-cdr!.

2017-04-14  Ludovic Courtès  <ludo@gnu.org>

	types: Hide one of the 'bytevector->string' procedures.
	* module/system/base/types.scm: Hide 'bytevector->string' from (rnrs io
	ports).

2017-04-04  Michael Gran  <spk121@yahoo.com>

	Only run tests that require fork if it is provided
	* test-suite/tests/00-repl-server.test (call-with-repl-server): throw if no fork provided
	* test-suite/tests/00-socket.test (primitive-fork-if-available): new help procedure
	  (bind/sockaddr, AF_UNIX/SOCK_STREAM): use helper func
	* test-suite/tests/ports.test ("pipe, fdopen, and line buffering"): throw if no fork provided

2017-04-03  Andy Wingo  <wingo@pobox.com>

	Speed up procedure-minimum-arity for fixed arity
	* libguile/programs.c (try_parse_arity): Add a case for
	  assert-nargs-ee/locals.

2017-04-01  Mike Gran  <spk121@yahoo.com>

	fix repl server test to allow for ECONNABORTED
	For some systems, ECONNABORTED is a failure condition for reading from closed sockets.

	* test-suite/tests/00-repl-server.test (HTTP inter-protocol attack): modified

2017-03-28  Andy Wingo  <wingo@pobox.com>

	Add allow-legacy-syntax-objects? parameter
	* module/ice-9/psyntax.scm (syntax?): Only recognize legacy syntax
	  objects if the new allow-legacy-syntax-objects? parameter is true.
	* module/ice-9/boot-9.scm (allow-legacy-syntax-objects?): New
	  parameter.
	* doc/ref/api-macros.texi (Syntax Transformer Helpers): Document the
	  horrible situation with legacy syntax objects.
	* NEWS: Add entry.

	Psyntax generates new syntax objects
	* module/ice-9/psyntax.scm (make-syntax-object): Change to make
	  new-style syntax objects.
	* module/ice-9/psyntax-pp.scm: Regenerate.
	* module/ice-9/compile-psyntax.scm (squeeze-syntax-object): Change to be
	  functional.
	  (squeeze-constant): Likewise.
	  (squeeze-tree-il): Likewise.
	  (translate-literal-syntax-objects): New pass.  The compiler can embed
	  literal syntax objects into compiled objects, but syntax can no longer
	  be read/written; otherwise users could forge syntax objects.  So for
	  the bootstrap phase, rewrite literal constants to calls to
	  make-syntax.

	Beginnings of psyntax switch to new syntax objects
	* module/ice-9/psyntax.scm: Baby steps towards support of a new
	  representation of syntax objects.
	* module/ice-9/psyntax-pp.scm: Regenerate.

	Add disjoint syntax object type
	* libguile/Makefile.am (libguile_@GUILE_EFFECTIVE_VERSION@_la_SOURCES):
	  (DOT_X_FILES, DOT_DOC_FILES, noinst_HEADERS): Add syntax.c and
	  syntax.h.
	* libguile/evalext.c (scm_self_evaluating_p):
	* libguile/goops.c (class_syntax, scm_class_of, scm_goops_early_init):
	* libguile/init.c (scm_init_guile):
	* libguile/print.c (iprin1):
	* libguile/tags.h (scm_tc7_syntax):
	* module/oop/goops.scm (<syntax>):
	* module/system/base/types.scm (%tc7-syntax, cell->object):
	* module/system/vm/disassembler.scm (code-annotation): Wire up the new
	  data type.
	* libguile/syntax.c:
	* libguile/syntax.h: New files.
	* module/ice-9/boot-9.scm: Move new definitions to (system syntax
	  internal).
	* module/system/syntax.scm (print-syntax): New helper.
	* module/system/vm/assembler.scm (statically-allocatable?)
	  (intern-constant, link-data): Arrange to be able to write syntax
	  objects into images.
	* module/language/cps/types.scm (&syntax): New type.  Remove
	  &hash-table; it was never detected, an internal binding, and we need
	  the bit to avoid going into bignum territory.

	Plumbing changes to rename "syntax-module"
	* module/ice-9/psyntax.scm (%syntax-module): Rename from syntax-module
	  in order to make room for a new syntax-module primitive binding.
	* module/ice-9/psyntax-pp.scm: Regenerate.
	* module/ice-9/boot-9.scm: Push syntax bindings into an internal
	  module.
	* module/system/syntax.scm: New file.
	* module/Makefile.am (SOURCES): Add system/syntax.scm.

2017-03-23  Mike Gran  <spk121@yahoo.com>

	Git ignore .exe files
	* .gitignore: add *.exe

2017-03-21  Mike Gran  <spk121@yahoo.com>

	i18n: add international sign positions to %locale-dump
	* module/ice-9/i18n.scm (%locale-dump): modified

	i18n: locale-positive-separated-by-space? should return bool, not string
	* libguile/i18n.c (scm_nl_langinfo): unpack INT_P_SEP_BY_SPACE as bool
	* test-suite/tests/i18n.test (nl-langinfo et al.): new tests

	i18n: add debugging helper procedure for locales
	* module/ice-9/i18n.scm (%locale-dump): new procedure

2017-03-20  Mike Gran  <spk121@yahoo.com>

	i18n: add tests for locale-digit-grouping
	* test-suite/tests/i18n.test ("nl-langinfo et al."): new tests

	i18n: add tests for locale AM/PM
	* test-suite/tests/i18n.test ("nl-langinfo et al."): new tests

	i18n: rename locale-monetary-digit-grouping to locale-monetary-grouping
	* module/ice-9/i18n.scm (locale-monetary-digit-grouping): renamed to locale-monetary grouping
	  (monetary-amount->locale-string): use renamed procedure
	* test-suite/tests/i18n.test (%french-locale): add LC_MONETARY
	  (%french-utf8-locale): add LC_MONETARY
	  ("nl-langinfo et al."): tests for locale-monetary-grouping

2017-03-17  Ludovic Courtès  <ludo@gnu.org>

	web: Avoid deprecated '_IOFBF'.
	* module/web/client.scm (open-socket-for-uri): Use 'block instead of
	_IOFBF.

	web: Remove export of nonexistent 'open-connection-for-uri'.
	* module/web/client.scm: Don't export 'open-connection-for-uri', which
	doesn't exist.

2017-03-15  Andy Wingo  <wingo@pobox.com>

	Add generic prebuilt links to dist.
	* prebuilt/Makefile.am (EXTRA_DIST): Add generic prebuilt links.

	Update --version and REPL copyright years
	* module/ice-9/command-line.scm (version-etc):
	* module/system/repl/common.scm (*version*): Update release year.

	GNU Guile 2.2.0.
	* GUILE-VERSION (GUILE_MINOR_VERSION, GUILE_MICRO_VERSION): Bump.
	  (LIBGUILE_INTERFACE_CURRENT): Incrememt to indicate that we now have a
	  defined libtool ABI "interface" of 1, that we support no other
	  interface (yet), and that this is the 0th revision of that interface.

2017-03-15  Freja Nordsiek  <fnordsie@gmail.com>

	GUILE_SITE_DIR: Update to find compiled site directories
	* meta/guile.m4 (GUILE_SITE_DIR): Update to find compiled site
	  directories.
	* meta/guile-2.2.pc.in: Add entry for site-ccache directory.

2017-03-14  Andy Wingo  <wingo@pobox.com>

	Better eval+promise+gc test
	* test-suite/tests/eval.test ("promises"): Increase clear pass rate on
	  this test.

	Resolve unresolved alist test cases
	* test-suite/tests/alist.test: Update unresolved cases to match current
	  behavior.  Bogus but stable :/

2017-03-14  Ludovic Courtès  <ludo@gnu.org>

	build: Compress with lzip too.
	* configure.ac: Add 'dist-lzip' Automake option.

2017-03-14  Freja Nordsiek  <fnordsie@gmail.com>

	Fixed reversed version order bug in GUILE_PROGS Autoconf macro.
	* meta/guile.m4 (GUILE_PROGS): Build version in correct order.

2017-03-14  Andy Wingo  <wingo@pobox.com>

	Update NEWS
	* NEWS: Update for 2.2.0.

	configure detects which set of prebuilt binaries to use
	* configure.ac: Use detected endianness and word size to automatically
	  select which set of prebuilt binaries to use.
	* meta/build-env.in (top_builddir):
	* meta/uninstalled-env.in (top_builddir): Update to use
	  SCM_PREBUILT_BINARIES for prebuilt entry in GUILE_LOAD_COMPILED_PATH.
	* prebuilt/32-bit-big-endian:
	* prebuilt/32-bit-little-endian:
	* prebuilt/64-bit-little-endian: New links.
	* prebuilt/x86_64-pc-linux-gnu: Remove this link now that it's unneeded.

2017-03-13  Andy Wingo  <wingo@pobox.com>

	Nonlocal prompt returns cause all effects
	* module/language/cps/effects-analysis.scm (expression-effects): Prompts
	  cause &all-effects.  I tried to limit this change to CSE but it was
	  actually LICM that was borked, so better to be conservative
	* test-suite/tests/control.test ("escape-only continuations"): Add
	  test.

2017-03-13  Andy Wingo  <wingo@pobox.com>

	Fix finalizer resuscitation causing excessive GC
	* libguile/finalizers.c (async_gc_finalizer):
	  (scm_i_register_async_gc_callback): Replace "weak gc callback"
	  mechanism with "async gc callback" mechanism.  Very similar but the
	  new API is designed to be called a bounded number of times, to avoid
	  running afoul of libgc heuristics.
	* libguile/weak-list.h: New internal header.
	* libguile/Makefile.am (noinst_HEADERS): Add weak-list.h.
	* libguile/weak-set.c (vacuum_all_weak_sets):
	  (scm_c_make_weak_set, scm_init_weak_set):
	* libguile/weak-table.c (vacuum_all_weak_tables):
	  (scm_c_make_weak_table, scm_init_weak_table): Arrange to vacuum all
	  weak sets from a single async GC callback, and likewise for weak
	  tables.

	Thanks to Ludovic Courtès for tracking this bug down!

2017-03-10  Andy Wingo  <wingo@pobox.com>

	Guile 2.1.8.
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump.

	Revert "Fix "Scheme Syntax" info rendering"
	This reverts commit 62f08b8f38990c1849ea61cd622f84b3d2611cd9, which was
	causing failing texi2dvi runs.

	Update NEWS
	* NEWS: Update for 2.1.8.

	Fix atomics compilation on clang
	* libguile/atomics-internal.h (scm_atomic_subtract_uint32):
	  (scm_atomic_compare_and_swap_uint32, scm_atomic_set_pointer):
	  (scm_atomic_ref_pointer, scm_atomic_set_scm):
	  (scm_atomic_ref_scm, scm_atomic_swap_scm):
	  (scm_atomic_compare_and_swap_scm): Use C11 atomic types if we have
	  loaded C11 stdatomic.h.

2017-03-09  Vladislav Ivanishin  <vladislav.ivanishin@gmail.com>

	Fix a couple of typos in the docs
	* doc/ref/scheme-ideas.texi: the some way -> the same way
	* doc/ref/scheme-intro.texi: Use @math inside a texinfo command (turns out
	  $math$ is not processed in this context and thus is not rendered correctly).

2017-03-09  Andy Wingo  <wingo@pobox.com>

	VM support for string-set!; slimmer read-string
	* doc/ref/vm.texi (Inlined Scheme Instructions): Add string-set!.
	* libguile/vm-engine.c (string-set!): New opcode.
	* module/ice-9/rdelim.scm (read-string): Reimplement in terms of a
	  geometrically growing list of strings, to reduce total heap usage when
	  reading big files.
	* module/language/cps/compile-bytecode.scm (compile-function): Add
	  string-set! support.
	* module/language/cps/types.scm (string-set!): Update for &u64 index.
	* module/language/tree-il/compile-cps.scm (convert): Unbox index to
	  string-set!.
	* module/system/vm/assembler.scm (system): Export string-set!.

	Micro-optimize update-port-position.
	* libguile/ports.c (update_port_position): Only fetch line if we need to
	  increment it.

2017-03-09  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Fix bug in comparison between real and complex
	This bug was introduced by 35a90592501ebde7e7ddbf2486ca9d315e317d09.

	* module/language/cps/specialize-numbers.scm (specialize-operations):
	  Check that both operands are real as a condition for
	  specialize-f64-comparison.
	* test-suite/tests/numbers.test: Add test.

2017-03-09  Andy Wingo  <wingo@pobox.com>

	Remove contification restriction in case-lambda
	* module/language/cps/compile-bytecode.scm (compile-function): Check for
	  fallthrough after $kclause too; possible to need to jump if clause
	  tails are contified.
	* module/language/cps/contification.scm (compute-contification-candidates):
	  Enable inter-clause contification.

	All clauses of function have same nlocals
	* module/language/cps/compile-bytecode.scm (compile-function):
	* module/language/cps/slot-allocation.scm ($allocation)
	  (lookup-nlocals, compute-frame-size, allocate-slots): Adapt to
	  have one frame size per function, for all clauses.

	Adapt gcprof to preemptive interrupts
	* module/statprof.scm (gcprof): Remove handle-interrupts trampoline from
	  captured stacks.

	Adapt statprof to new preemptive interrupts
	* module/statprof.scm (profile-signal-handler): Cut an additional stack
	  frame, corresponding to the handle-interrupts trampoline added
	  recently.

2017-03-09  Ludovic Courtès  <ludo@gnu.org>

	statprof: 'with-statprof' honors #:display-style.
	* module/statprof.scm (with-statprof): Pass #:display-style to 'statprof'.

2017-03-08  Andy Wingo  <wingo@pobox.com>

	64KB segment alignment
	* module/system/vm/linker.scm (*lcm-page-size*): Rename
	  from *page-size*, change to 64 KB.
	* libguile/loader.c (load_thunk_from_memory): Only require page size
	  alignment, knowing that although Guile might emit ELF with 64k
	  alignment, it only really needs page alignment.

2017-03-07  Andy Wingo  <wingo@pobox.com>

	Fix new thread-local fluids test
	* test-suite/tests/fluids.test ("dynamic states"): Fix test.

	Fix documentation build
	* doc/ref/api-control.texi (Fluids and Dynamic States): Fix link.

	Add thread local fluids
	* libguile/fluids.h (struct scm_dynamic_state): Add thread_local_values
	  table.  Thread locals are flushed to a separate thread-local table.
	  The references are strong references since the table never escapes the
	  thread.
	  (scm_make_thread_local_fluid, scm_fluid_thread_local_p): New
	  functions.
	* libguile/fluids.c (FLUID_F_THREAD_LOCAL):
	  (SCM_I_FLUID_THREAD_LOCAL_P): New macros.
	  (restore_dynamic_state): Add comment about precondition.
	  (save_dynamic_state): Flush thread locals.
	  (scm_i_fluid_print): Print thread locals nicely.
	  (new_fluid): Add flags arg.
	  (scm_make_fluid, scm_make_fluid_with_default, scm_make_unbound_fluid):
	  Adapt.
	  (scm_make_thread_local_fluid, scm_fluid_thread_local_p): New
	  functions.
	  (fluid_set_x): Special flushing logic for thread-locals.
	  (fluid_ref): Special cache miss logic for thread locals.
	* libguile/stacks.c (scm_init_stacks):
	* libguile/throw.c (scm_init_throw): %stacks and %exception-handler are
	  thread-locals.
	* libguile/threads.c (guilify_self_2): Init thread locals table.
	* test-suite/tests/fluids.test ("dynamic states"): Add test.
	* doc/ref/api-control.texi (Fluids and Dynamic States): Add link to
	  Thread-Local Variables.
	* doc/ref/api-scheduling.texi (Thread Local Variables): Update with real
	  thread-locals.
	* NEWS: Update.

2017-03-07  Mark H Weaver  <mhw@netris.org>
	    Ludovic Courtès  <ludo@gnu.org>

	psyntax: Generate identifiers in a deterministic fashion.
	Fixes <http://bugs.gnu.org/20272>.

	* module/ice-9/boot-9.scm (module-generate-unique-id!)
	(module-gensym): New procedures.
	(module): Add 'next-unique-id' field.
	(the-root-module): Inherit 'next-unique-id' value from early stub.
	(make-module, make-autoload-interface): Adjust calls to
	module-constructor.
	* module/ice-9/psyntax.scm (gen-label, new-mark): Generate unique
	identifiers from the module name and the per-module unique-id.
	(build-lexical-var, generate-temporaries): Use
	'module-gensym' instead of 'gensym'.
	* module/ice-9/psyntax-pp.scm: Regenerate.
	* module/language/tree-il/fix-letrec.scm (fix-letrec!): Use
	'module-gensym' instead of 'gensym'.
	* module/system/base/syntax.scm (define-record): Likewise.
	(transform-record): Likewise.

2017-03-07  Mike Gran  <spk121@yahoo.com>

	Check for working profiling and virtual itimers
	* configure.ac (HAVE_USABLE_GETITIMER_PROF, HAVE_USABLE_GETITIMER_VIRTUAL): new tests
	* doc/ref/posix.texi (setitimer, getitimer): document provided? 'ITIMER_VIRTUAL and 'ITIMER_PROF
	* doc/ref/statprof.texi (statprof): document ITIMER_PROF requirements
	* libguile/scmsigs.c (scm_setitimer, scm_getitimer): document (provided? 'ITIMER_VIRTUAL) and (provided? 'ITIMER_PROF)
	  (scm_init_scmsigs): add features ITIMER_VIRTUAL and ITIMER_PROF
	* test-suite/tests/asyncs.test ("prevention via sigprof"): throw when unsupported
	* test-suite/tests/signals.test: throw when not supported
	* test-suite/tests/statprof.test: throw when not supported

2017-03-05  Mike Gran  <spk121@yahoo.com>

	Can't recursively search DLLs with FFI on Cygwin
	* doc/ref/api-foreign.text (dynamic-link): document problems with recursive DLLs.
	* test-suite/standalone/test-ffi (global): with Cygwin, dynamic-link C library explicitly
	* test-suite/standalone/test-foreign-object-scm (libc-ptr): with Cygwin, link C library explicitly
	* test-suite/tests/foreign.test (qsort): with Cygwin, link C library explicitly

2017-03-05  Mike Gran  <spk121@yahoo.com>

	Disable Turkish locale tests on Cygwin
	Cygwin's support of Turkish casing rules is broken.

	* test-suite/tests/i18n.test (under-turkish-utf8-locale-or-unresolved): modified

2017-03-03  Mike Gran  <spk121@yahoo.com>

	Fix regression in non-mmap fallback elf loader
	* libguile/loader.c [!HAVE_SYS_MMAN_H] (map_file_contents): updated
	  variables and function calls to the current names

2017-03-03  Mike Gran  <spk121@yahoo.com>

	Cygwin: skip tests that require working setrlimits for memory
	On Cygwin, setrlimits cannot be used to set total memory availabe
	for a process.

	* test-suite/standalone/test-out-of-memory: skip for cygwin
	* test-suite/standalone/test-stack-overflow: skip for cygwin

2017-03-02  Andy Wingo  <wingo@pobox.com>

	Revert "build: Compress with lzip too."
	This reverts commit 89ce9fb31b00f1f243fe6f2450db50372cc0b86d.  It was
	causing the hydra builds to fail.

2017-03-01  Andy Wingo  <wingo@pobox.com>

	Fix makeinfo warnings
	* doc/ref/api-languages.texi (Nil):
	* doc/ref/statprof.texi (Statprof): Use headings instead of sections to
	  avoid makeinfo warnings.

	Remove useless subsection from hooks documentation
	* doc/ref/api-utility.texi (Hook Reference): Remove useless "handling
	  hooks from C" section that was also generating warnings.

	Fix scheme-scripts markup.
	* doc/ref/scheme-scripts.texi (Scripting Examples): Fix $@ rendering in
	  texinfo.

	Update NEWS for prerelease.
	* NEWS: Update for next prerelease.

	Update NEWS
	* NEWS: Update 2.0.x NEWS.  Fold 2.1.7 NEWS into main 2.2 body.

2017-03-01  Arne Babenhauserheide  <arne_bab@web.de>
	    Ludovic Courtès  <ludo@gnu.org>

	doc: Describe -e (module) on equal footing with (@ ...).
	* doc/ref/guile-invoke.texi, doc/ref/scheme-scripts.texi:
	describe the -e (module) shorthand as on equal footing with (@ ...)

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	i18n: 'number->locale-string' guesses the minimum number of decimals.
	This feature was removed by 4aead68cdb86ca60cc372f0cd558cadda90ddec5.

	* module/ice-9/i18n.scm (number-decimal-string): Rewrite the case where
	DIGIT-COUNT is not an integer.
	(number->locale-string): Always pass FRACTION-DIGITS to
	'number-decimal-string'.
	* test-suite/tests/format.test ("~h localized number")["1234.5"]
	["padding", "padchar"]: Remove decimal specifier.
	* test-suite/tests/i18n.test ("number->locale-string")
	["fraction",
	* test-suite/tests/i18n.test ("format ~h")["12 345,678"]: Remove decimal
	specifier.  Remove one decimal.
	* doc/ref/api-i18n.texi (Number Input and Output): Update
	'number->locale-string' doc to mention the number of decimals.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	i18n: Fix corner cases for monetary and number string conversions.
	Fixes <http://bugs.gnu.org/24990>.
	Reported by Martin Michel <dev@famic.de>.

	* module/ice-9/i18n.scm (integer->string, number-decimal-string): New
	procedures.
	(monetary-amount->locale-string): Use them instead of 'number->string'
	followed by 'string-split'.
	(number->locale-string): Likewise.
	* test-suite/tests/i18n.test ("number->locale-string")["fraction"]: Add
	second argument to 'number->locale-string'.
	["fraction, 1 digit"]: Round up.
	["fraction, 10 digits", "trailing zeros", "negative integer"]: New
	tests.
	* test-suite/tests/i18n.test ("format ~h"): Pass the number of decimals
	for ~h.
	("monetary-amount->locale-string")["French"]: Always expect two decimals
	after the comma.
	["one cent", "very little money"]: New tests.
	* test-suite/tests/format.test ("~h localized number")["1234.5"]:
	Specify the number of decimals explicitly.
	["padding"]: Expect zero decimals.
	["padchar"]: Ask for one decimal.
	["decimals", "locale"]: Adjust rounding.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Choose a more plausible US English locale name.
	* test-suite/tests/i18n.test (%american-english-locale-name): Change to
	en_US.utf8".

	tests: Use 'pass-if-equal' for (ice-9 i18n) tests.
	* test-suite/tests/i18n.test ("number->locale-string")
	("format ~h", "monetary-amount->locale-string"): Use 'pass-if-equal'
	instead of 'pass-if'.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	i18n: Do not represent zero as "-0".
	Partly fixes <http://bugs.gnu.org/24990>.
	Reported by Martin Michel <dev@famic.de>.

	* module/ice-9/i18n.scm (monetary-amount->locale-string): Don't negate
	AMOUNT when it's zero.
	(number->locale-string): Likewise.
	* test-suite/tests/i18n.test ("number->locale-string")["positive inexact
	zero, 1 digit"]: New test.
	("monetary-amount->locale-string")["positive inexact zero"]: New test.

2017-03-01  John Paul Adrian Glaubitz  <glaubitz@physik.fu-berlin.de>

	Recognize sh3 as compilation targets
	* module/system/base/target.scm (cpu-endianness, triplet-pointer-size):
	  Add case for "sh3".

2017-03-01  Georgi Kirilov  <kirilov.georgi.s@gmail.com>

	doc: Fix typo in site packages documentation.
	* doc/ref/scheme-using.texi (Installing Site Packages): Fix typo

	doc: Fix typo in keywords documentation.
	* doc/ref/api-data.texi (Keyword Read Syntax): Fix typo

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Avoid statprof test failure on systems without 'setitimer'.
	Partly fixes <http://bugs.gnu.org/25463>.
	Reported by rennes@openmailbox.org.

	* test-suite/tests/statprof.test ("return values"): Wrap in
	'when-implemented'.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	build: Honor $SOURCE_DATE_EPOCH for the recorded timestamp.
	Reported by Jan Nieuwenhuizen <janneke@gnu.org>
	at <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=20272#36>.

	* libguile/Makefile.am (libpath.h): Honor 'SOURCE_DATE_EPOCH'.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	scandir: Avoid 'stat' calls on each entry.
	* module/ice-9/ftw.scm (scandir): Rewrite in terms of 'readdir'.

	build: Compress with lzip too.
	* configure.ac: Add 'dist-lzip' Automake option.

	build: Check for /gnu/store file names upon "make dist".
	* Makefile.am (assert-no-store-file-names): New rule, taken from Guix.
	(dist-hook): Depend on it.

2017-03-01  Andy Wingo  <wingo@pobox.com>

	Disable REPL server tests if no threads
	* test-suite/tests/00-repl-server.test (call-with-repl-server): The REPL
	  server needs threads so don't bother testing if we have no threads.
	  Also, prevent SIGPIPE from killing the parent process.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Avoid race condition in REPL server test.
	Fixes <http://bugs.gnu.org/24769>.
	Reported by Rob Browning <rlb@defaultvalue.org>.

	* test-suite/tests/00-repl-server.test ("simple expression"): Add call
	to 'select' before 'display'.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Throw 'unresolved when the REPL server is too slow.
	* test-suite/tests/00-repl-server.test (call-with-repl-server):
	Use (usleep 100) instead of (sleep 1).  Throw 'unresolved when TRIES is
	too high.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Add REPL server test for CVE-2016-8606.
	This is a followup to 08c021916dbd3a235a9f9cc33df4c418c0724e03.

	* test-suite/tests/00-repl-server.test: New file.
	* test-suite/Makefile.am (SCM_TESTS): Add it.

2017-03-01  Mark H Weaver  <mhw@netris.org>
	    Ludovic Courtès  <ludo@gnu.org>

	REPL Server: Guard against HTTP inter-protocol exploitation attacks.
	Reported by Christopher Allan Webber <cwebber@dustycloud.org>

	This commit adds protection to Guile's REPL servers against HTTP
	inter-protocol exploitation attacks, a scenario whereby an attacker can,
	via an HTML page, cause a web browser to send data to TCP servers
	listening on a loopback interface or private network.  See
	<https://en.wikipedia.org/wiki/Inter-protocol_exploitation> and
	<https://www.jochentopf.com/hfpa/hfpa.pdf>, The HTML Form Protocol
	Attack (2001) by Tochen Topf <jochen@remote.org>.

	Here we add a procedure to 'before-read-hook' that looks for a possible
	HTTP request-line in the first line of input from the client socket.  If
	present, the socket is drained and closed, and a loud warning is written
	to stderr (POSIX file descriptor 2).

	* module/system/repl/server.scm: Add 'maybe-check-for-http-request'
	to 'before-read-hook' when this module is loaded.
	(with-temporary-port-encoding, with-saved-port-line+column)
	(drain-input-and-close, permissive-http-request-line?)
	(check-for-http-request, guard-against-http-request)
	(maybe-check-for-http-request): New procedures.
	(serve-client): Use 'guard-against-http-request'.
	* module/system/repl/coop-server.scm (start-repl-client): Use
	'guard-against-http-request'.
	* doc/ref/guile-invoke.texi (Command-line Options): In the description
	of the --listen option, make the security warning more prominent.
	Mention the new protection added here.  Recommend using UNIX domain
	sockets for REPL servers.  "a path to" => "the file name of".

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	tests: Use the "normalized codeset" in locale names.
	* test-suite/tests/i18n.test (%french-locale-name)
	(%french-utf8-locale-name, %turkish-utf8-locale-name)
	(%german-utf8-locale-name, %greek-utf8-locale-name): Use the normalized
	codeset for ISO-8859-1 and UTF-8.

	Treat 'SIG_IGN' as a pointer.
	* libguile/posix.c (scm_system_star): Cast 'SIG_IGN' to
	'scm_t_uintptr_t' and use 'scm_from_uintptr_t'.  This fixes an
	'int-conversion' warning with GCC 6.2.

	Document 'scm_to_uintptr_t' and 'scm_from_uintptr_t'.
	* doc/ref/api-data.texi (Integers): Document them.

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	Remove 'umask' calls from 'mkdir'.
	Fixes <http://bugs.gnu.org/24659>.

	* libguile/filesys.c (SCM_DEFINE): Remove calls to 'umask' when MODE is
	unbound; instead, use 0777 as the mode.  Update docstring to clarify
	this.
	* doc/ref/posix.texi (File System): Adjust accordingly.
	* NEWS: Mention it.

2017-03-01  Andy Wingo  <wingo@pobox.com>

	%port-encoding requires an open port
	* libguile/ports.c (scm_sys_port_encoding)
	  (scm_sys_set_port_encoding_x): Require an open port, to match 2.0
	  behavior.

2017-03-01  Mark H Weaver  <mhw@netris.org>

	http: Do not use 'eq?' to compare characters in parse-request-uri.
	* module/web/http.scm (parse-request-uri): Use 'eqv?' to compare
	characters.

2017-03-01  Mark H Weaver  <mhw@netris.org>

	build: .x and .doc files depend on generated includes.
	Fixes <https://bugs.gentoo.org/show_bug.cgi?id=590528>.

	* libguile/Makefile.am (BUILT_INCLUDES): New variable.
	(BUILT_SOURCES): Put generated .h to BUILT_INCLUDES.
	(DOT_X_FILES, EXTRA_DOT_X_FILES, DOT_DOC_FILES, EXTRA_DOT_DOC_FILES):
	Depend on $(BUILT_INCLUDES), in place of scmconfig.h which is included
	in $(BUILT_INCLUDES).

2017-03-01  Ludovic Courtès  <ludo@gnu.org>

	texinfo: Remove unnecessary (oop goops) dependency.
	* module/texinfo/string-utils.scm: Remove #:use-module (oop goops).

2017-03-01  Mark H Weaver  <mhw@netris.org>

	Do not assume that sizeof (long) == sizeof (void *) == sizeof (SCM).
	This assumption does not hold on systems that use the LLP64 data model.

	Partially fixes <https://debbugs.gnu.org/22406>.
	Reported by Peter TB Brett <peter@peter-b.co.uk>.

	* libguile/numbers.h (scm_t_inum): Move here from numbers.c, and change
	  to be equivalent to 'long' (formerly 'scm_t_signed_bits').
	  (SCM_MOST_POSITIVE_FIXNUM, SCM_MOST_NEGATIVE_FIXNUM): Define based on
	  SCM_I_FIXNUM_BIT instead of SCM_T_SIGNED_BITS_MAX.
	  (SCM_I_INUM): Adjust definitions to return a 'scm_t_inum', and avoiding
	  the assumption that SCM_UNPACK returns a 'long'.
	* libguile/numbers.c (scm_t_inum): Move definition to numbers.h.
	  Verify that 'scm_t_inum' fits within a SCM value.
	  (scm_i_inum2big): Remove preprocessor code that forced a compile error
	  unless sizeof (long) == sizeof (void *).

2017-03-01  Mark H Weaver  <mhw@netris.org>

	Avoid signed integer overflows in numeric conversions.
	Reported by Miroslav Lichvar <mlichvar@redhat.com>
	in <https://lists.gnu.org/archive/html/guile-devel/2016-02/msg00045.html>

	* libguile/conv-integer.i.c: Avoid signed overflow.
	* libguile/numbers.c (scm_is_signed_integer): Avoid signed overflow.

2017-03-01  Andy Wingo  <wingo@pobox.com>

	Remove extraneous debugging output in test
	* test-suite/standalone/test-scm-c-bind-keyword-arguments.c
	  (missing_value_error_handler): Remove debugging write.

	Fix open-file mode misinterpretation
	* libguile/fports.c (scm_i_mode_to_open_flags): Validate that argument
	  is string.  Fixes #25498.

	"select" no longer throws exception on EINTR
	* doc/ref/posix.texi (Ports and File Descriptors): Update.
	* libguile/filesys.c (scm_select): Use scm_std_select so that pending
	  interrupts can be delivered.  On EINTR or EAGAIN, just return directly
	  so that calling Scheme code can run asyncs.

	scm_std_select doesn't tick itself
	* libguile/threads.c (scm_std_select): If there are unblocked asyncs
	  pending, return directly instead of ticking ourselves.

	Cosmetic REPL server improvements
	* module/system/repl/server.scm (run-server*): Cosmetic improvements.

	Fix trap frame matching
	* module/system/vm/traps.scm (program-last-ip): Actually return an
	  absolute IP.  Fixes traps!

	Fix class slot allocation since GOOPS rewrite
	* module/oop/goops.scm (%compute-layout): Fix class slot layout.
	  Before, a #:class that was an argument to #:allocation was getting
	  interpreted as a keyword with a value.
	* test-suite/tests/goops.test ("#:class slot allocation"): Add test.

	Fix (mkstemp! "XX" 0) errors
	* libguile/filesys.c (scm_i_mkstemp): Validate "mode" argument as a
	  string, and validate writability of template string early too.  Thanks
	  to Jean Louis for the bug report.

	Flush when getting string from r6rs string output port
	* module/rnrs/io/ports.scm (open-string-output-port): Calling the
	  get-string proc should flush the buffer and reset the file position.
	* test-suite/tests/r6rs-ports.test ("8.2.10 Output ports"): Add tests.
	  Thanks to Freja Nordsiek for the report.

	String ports can be truncated
	* libguile/strports.c (string_port_truncate):
	  (scm_make_string_port_type): Support truncate-file on string ports.
	* test-suite/tests/ports.test ("string ports"): Add tests.

	Minor expansion of guile-test comments
	* test-suite/guile-test: Add -L to example.

2017-03-01  Wilfred Hughes  <me@wilfred.me.uk>

	Favor docstrings for describing the purpose of functions.
	* module/ice-9/boot-9.scm: Where functions have docstring-style
	  comments, make them proper docstrings.

2017-03-01  Andy Wingo  <wingo@pobox.com>

	Fix "Scheme Syntax" info rendering
	* doc/ref/api-evaluation.texi (Expression Syntax): Fix quote and
	  quasiquote so that they actually look different in Info.

2017-02-28  Andy Wingo  <wingo@pobox.com>

	Better errors for odd-length keyword args
	* libguile/vm-engine.c (bind-kwargs):
	* libguile/vm.c (vm_error_kwargs_missing_value):
	* libguile/eval.c (error_missing_value)
	  (prepare_boot_closure_env_for_apply): Adapt to mirror VM behavior.
	* libguile/keywords.c (scm_c_bind_keyword_arguments): Likewise.
	* module/ice-9/eval.scm (primitive-eval): Update to error on (foo #:kw)
	  with a "Keyword argument has no value" instead of the horrible "odd
	  argument list length".  Also adapts to the expected args format for
	  the keyword-argument-error exception printer in all cases.  Matches
	  1.8 optargs behavior also.
	* test-suite/standalone/test-scm-c-bind-keyword-arguments.c (test_missing_value):
	  (missing_value_error_handler): Update test.
	* test-suite/tests/optargs.test: Add tests.

	Fix segfault introduced with R6RS port commit
	* libguile/init.c (scm_i_init_guile): Move scm_register_r6rs_ports
	  later, so that defining port types hsa the SCM trampoline subrs
	  defined.
	* libguile/bytevectors.c (scm_bootstrap_bytevectors): Cosmetic changes.

	"Scripting Examples" update.
	* doc/ref/scheme-scripts.texi (Scripting Examples): Mention system* and
	  open-pipe.

	Register R6RS port and bytevector internals early
	* libguile/bytevectors.c (sym_big, sym_little): Rename from scm_sym_big
	  and scm_sym_little, and don't use the snarf mechanism as we need to
	  initialize this value eagerly in case the C API is used before the
	  Scheme module is loaded.
	  (scm_bootstrap_bytevectors): Initialize the endianness symbols here.
	* libguile/r6rs-ports.c (scm_register_r6rs_ports): Register the R6RS
	  port kinds here, for the same reason.

2017-02-28  Andy Wingo  <wingo@pobox.com>

	Fix support for threads already known to GC
	* libguile/threads.h (scm_i_thread): Add bool tracking whether the
	  thread needs to be unregistered from libgc.
	* libguile/threads.c (guilify_self_1): Add needs_unregister arg.
	  (on_thread_exit): Only unregister thread if the thread needs it.
	  (scm_i_init_thread_for_guile): A thread needs unregistering if
	  GC_register_my_thread succeeded.
	  (scm_threads_prehistory): Don't unregister initial thread.

	  Fixes #19523.  Thanks to Anthonin Bonnefoy for the report.

2017-02-28  Andy Wingo  <wingo@pobox.com>

	Declare module exports before loading imports
	* module/ice-9/boot-9.scm (define-module*): Process module imports after
	  module exports.  Allows for an additional kind of circular module
	  imports (see https://bugs.gnu.org/15540).
	* test-suite/tests/modules.test ("circular imports"): Add test.

	Revert "futures: Limit the number of nested futures on the same stack."
	This reverts commit 8a177d316c0062afe74f9a761ef460e297435e59, though
	keeping the additional tests.  (Guile 2.2 doesn't have a fixed stack
	limit).

	Fix (* x -1) for GOOPS types
	* libguile/numbers.c (scm_product): Only reduce (* x -1) to (- x) when X
	  is a bignum.  Fixes weirdness when X is not a number and instead
	  multiplication should dispatch to GOOPS.  Thanks to Alejandro Sanchez
	  for the report.

2017-02-27  Diogo F. S. Ramos  <dfsr@riseup.net>

	Explain why no native accessors for `s8' and `u8' exist
	* doc/ref/api-data.texi: Instead of saying it is obvious, explain why
	  no native endianness accessors exist for the `s8' and `u8' variants.

2017-02-23  Andy Wingo  <wingo@pobox.com>

	Fix guild compile --to=cps / --from=cps
	* module/language/cps/spec.scm (read-cps, write-cps): Fix CPS
	  serialization and parsing, so that "guild compile" works with --to=cps
	  and --from=cps.

	Fix kfun parse-cps bug
	* module/language/cps.scm (parse-cps): Fix bug parsing kfun.

2017-02-23  Freja Nordsiek  <fnordsie@gmail.com>

	Fixed specific version of guile search in autoconf macro GUILE_PROGS.
	* meta/guile.m4 (GUILE_PROGS): Search for guile with suffixes
	  first ('-X.Y' and 'X.Y' where X.Y denotes the version) before
	  searching for guile with no suffix.  Patch co-authored by Andy Wingo.

2017-02-23  Andy Wingo  <wingo@pobox.com>

	Fix typo in old NEWS.
	* NEWS: Fix typo.

2017-02-22  Andy Wingo  <wingo@pobox.com>

	Fix multi-arity dispatch in GOOPS
	* module/oop/goops.scm (multiple-arity-dispatcher): Fix dispatch for
	  max-arity+1 when a generic is already in multiple-arity dispatch.
	  Fixes #24454.
	* test-suite/tests/goops.test ("dispatch"): Add test.

	Fix compute-frame-sizes for case-lambda jumps
	* module/system/vm/frame.scm (compute-frame-sizes): Fix for jumps to the
	  next arity.

2017-02-21  Andy Wingo  <wingo@pobox.com>

	Use labs instead of abs where needed
	* libguile/numbers.c (log_of_fraction): Use labs instead of abs on
	  longs.  Thanks to Matt Wette for the tip.

2017-02-21  Matt Wette  <matt.wette@gmail.com>

	Fix make-polar signedness of zeros on macOS
	* configure.ac: Check for __sincos.
	* libguile/numbers.c (scm_c_make_polar): Fall back to __sincos if
	  possible.  Fixes zero signedness of make-polar on macOS.

2017-02-21  Andy Wingo  <wingo@pobox.com>

	Conditionally define SOCK_CLOEXEC, SOCK_NONBLOCK
	* libguile/socket.c (scm_init_socket): Conditionally define SOCK_CLOEXEC
	  and SOCK_NONBLOCK.  Fixes compilation on macOS.

2017-02-19  Andy Wingo  <wingo@pobox.com>

	Fix flonum/complex type inference.
	* module/language/cps/types.scm (define-binary-result!): Arithmetic
	  where one argument is a flonum may produce a complex.
	* test-suite/tests/compiler.test: Add test.

2017-02-18  Andy Wingo  <wingo@pobox.com>

	Guile 2.1.7.
	* GUILE-VERSION: Bump to 2.1.7.

	Update NEWS for 2.1.7.
	* NEWS: Update.

	Fold 2.1.6 NEWS changes
	* NEWS: Fold 2.1.6 changes into main 2.2 NEWS.

2017-02-17  Andy Wingo  <wingo@pobox.com>

	Speed up number->string
	* libguile/numbers.c (scm_number_to_string): Use scm_from_latin1_string
	  where appropriate.  Avoids mucking about with iconv.

	Minor make-string optimization
	* libguile/strings.c (STRINGBUF_SET_MUTABLE): New helper.
	  (scm_i_string_ensure_mutable_x): Use new helper.
	  (scm_make_string): Mark stringbuf as mutable.

	Bump fluid cache size to 16 entries
	* libguile/cache-internal.h (SCM_CACHE_SIZE): Bump to 16.  It seems that
	  a thread accesses more than 8 fluids by default (%stacks, the
	  exception handler, current ports, current-fiber, port read/write
	  waiters) which leads every fiber to cause cache eviction and copying
	  the value table, which is a bottleneck.  Instead just bump this cache
	  size.
	  (scm_cache_lookup): Update unrolled search.

	Revert "Cheaper fluid-ref cache"
	This reverts commit cd3ff33a31c51612f2247bdb15ecbe92d7da1310.

2017-02-16  Andy Wingo  <wingo@pobox.com>

	Stringbufs immutable by default
	* libguile/snarf.h (SCM_IMMUTABLE_STRINGBUF): Remove shared flag.
	  Stringbufs are immutable by default.
	* libguile/strings.c: Rewrite blurb.  Change to have stringbufs be
	  immutable by default and mutable only when marked as such.  Going
	  mutable means making a private copy.
	  (STRINGBUF_MUTABLE, STRINGBUF_F_MUTABLE): New definitions.
	  (SET_STRINGBUF_SHARED): Remove.
	  (scm_i_print_stringbuf): Simplify to just alias the stringbuf as-is.
	  (substring_with_immutable_stringbuf): New helper.
	  (scm_i_substring, scm_i_substring_read_only, scm_i_substring_copy):
	  use new helper.
	  (scm_i_string_ensure_mutable_x): New helper.
	  (scm_i_substring_shared): Use scm_i_string_ensure_mutable_x.
	  (stringbuf_write_mutex): Remove; yaaaaaaaay.
	  (scm_i_string_start_writing): Use scm_i_string_ensure_mutable_x.  No
	  more mutex.
	  (scm_i_string_stop_writing): Now a no-op.
	  (scm_i_make_symbol): Use substring/copy.
	  (scm_sys_string_dump, scm_sys_symbol_dump): Update.
	* libguile/strings.h (SCM_I_STRINGBUF_F_SHARED): Remove.
	  (SCM_I_STRINGBUF_F_MUTABLE): Add.
	* module/system/vm/assembler.scm (link-data): Don't add shared flag any
	  more.  Existing compiled flags are harmless tho.
	* test-suite/tests/strings.test ("string internals"): Update.

	Remove unnecessary scm_i_string_start_writing calls
	* libguile/strings.c (scm_string, scm_c_make_string):
	* libguile/srfi-13.c (scm_reverse_list_to_string, scm_string_map)
	  (scm_string_unfold, scm_string_unfold_right, scm_xsubstring)
	  (scm_string_filter, scm_string_delete): Remove
	  scm_i_string_start_writing / scm_i_string_stop_writing calls around
	  fresh strings that aren't visible to other threads.

	Cheaper fluid-ref cache
	* libguile/cache-internal.h (struct scm_cache_entry): Add needs_flush
	  member.
	  (scm_cache_evict_1): Clear needs_flush on newly evicted entry.
	  (scm_cache_insert): Propagate needs_flush to new entry.
	* libguile/fluids.c (restore_dynamic_state): Mark all restored entries
	  as needing a flush.
	  (save_dynamic_state): Only cons on "needs_flush" entries to the
	  resulting dynamic state.  The result is the same as before but
	  avoiding the refq on the weak table.
	  (fluid_set_x): Propagate needs_flush down to the cache.
	  (fluid_ref): When adding entry to cache, use needs_flush==0.
	  (scm_fluid_set_x, scm_fluid_unset_x, scm_swap_fluid, swap_fluid): Use
	  needs_flush==1.

2017-02-15  Andy Wingo  <wingo@pobox.com>

	Fix accept4 gnulib update.
	* m4/accept4.m4: Add missing file.
	* lib/accept4.c: Add missing file.
	* .gitignore: Update.

	Add accept4 support
	* doc/ref/posix.texi (Network Sockets and Communication): Add
	  documentation.
	* libguile/socket.c (scm_accept4): New function, replaces accept
	  implementation.
	  (scm_accept): Call scm_accept4.
	  (scm_init_socket): Define SOCK_CLOEXEC and SOCK_NONBLOCK.
	* libguile/socket.h: Add private scm_accept4 decl.
	* module/ice-9/suspendable-ports.scm (accept): Update.

	Switch to accept4
	* lib/Makefile.am:
	* m4/gnulib-cache.m4:
	* m4/gnulib-comp.m4: Switch from accept gnulib module to accept4.
	* libguile/socket.c (scm_accept): Use accept4.

	Update Gnulib to v0.1-1157-gb03f418.

2017-02-14  Andy Wingo  <wingo@pobox.com>

	Elide syscalls in fdes->port
	* libguile/fports.h (scm_t_fport): Add options field.
	  (SCM_FDES_RANDOM_P): Deprecate.
	  (scm_i_fdes_to_port): Add options argument.
	* libguile/fports.c (scm_i_fdes_to_port): Add options argument.  Only
	  verify FD if SCM_FPORT_OPTION_VERIFY is there.
	  (scm_fdes_to_port, scm_open_file_with_encoding): Adapt to
	  scm_i_fdes_to_port changes.
	  (fport_random_access_p): Don't try to seek if NOT_SEEKABLE option is
	  set.
	* libguile/deprecated.h:
	* libguile/deprecated.c (SCM_FDES_RANDOM_P): Deprecate.
	* NEWS: Add deprecation.
	* libguile/filesys.c:
	* libguile/ioext.c:
	* libguile/posix.c:
	* libguile/read.c:
	* libguile/socket.c: Adapt callers.

2017-02-13  Andy Wingo  <wingo@pobox.com>

	Fix compilation of continuations.c
	* libguile/continuations.c (scm_i_continuation_to_frame): Remove unused
	  assignment.  The previous commit removed the declaration in order to
	  silence an unused-assignment warning, but forgot to remove the
	  assignment :/

2017-02-12  Andy Wingo  <wingo@pobox.com>

	Remove unused variable in continuations.c
	* libguile/continuations.c (scm_i_continuation_to_frame): Remove unused
	  variable.

	VM continuations store FP/SP by offset
	* libguile/continuations.c (scm_i_continuation_to_frame):
	* libguile/stacks.c (scm_make_stack):
	* libguile/vm.c (scm_i_vm_cont_to_frame, scm_i_vm_capture_stack):
	  (vm_return_to_continuation_inner)
	  (struct vm_reinstate_partial_continuation_data):
	  (vm_reinstate_partial_continuation_inner):
	  (vm_reinstate_partial_continuation):
	* libguile/vm.h (sstruct scm_vm_cont): Simplify VM continuations by
	  recording the top FP by offset, not value + reloc.
	* libguile/frames.c (frame_offset, scm_i_vm_frame_offset): Remove unused
	  functions.
	* libguile/frames.h (SCM_VALIDATE_VM_FRAME, scm_i_vm_frame_offset):
	  Remove.
	* libguile/control.c (reify_partial_continuation): Once we know the
	  base_fp, relocate the dynamic stack.
	* libguile/dynstack.h:
	* libguile/dynstack.c (scm_dynstack_relocate_prompts): New function.
	  (scm_dynstack_wind_prompt): Adapt to add new fp offset.

	Avoid reading garbage from dynstack
	* libguile/dynstack.c (push_dynstack_entry_unchecked): Reset top
	  dynstack tag to prevent garbage.

2017-02-08  Andy Wingo  <wingo@pobox.com>

	Web server and client use suspendable ports
	* module/web/request.scm (write-request):
	* module/web/response.scm (write-response): Use put-string instead of
	  display.

	Prevent TOCTTOU bugs in C ports
	* libguile/ports-internal.h (scm_port_buffer_can_take):
	  (scm_port_buffer_can_put): Add cur/end output arguments so that when a
	  caller asks the buffer room, it can be relative to a fixed point in
	  the buffer and not whatever point it's at when we go to fill it.
	  (scm_port_buffer_did_take, scm_port_buffer_did_put): Similarly,
	  require that the caller knows where they took/put data in the buffer.
	  Prevents overflow.
	  (scm_port_buffer_take_pointer, scm_port_buffer_put_pointer): Likewise,
	  require that the caller has already checked and knows a position in
	  the buffer and therefore how much data is available.
	  (scm_port_buffer_take, scm_port_buffer_put, scm_port_buffer_putback):
	  Adapt.
	* libguile/ports.h (scm_fill_input): Add cur/avail output arguments.
	* libguile/filesys.c:
	* libguile/poll.c:
	* libguile/ports.c:
	* libguile/r6rs-ports.c:
	* libguile/read.c:
	* libguile/rw.c: Adapt all callers.  Gnarly work!

	Prevent TOCTTOU bugs in suspendable ports
	* module/ice-9/suspendable-ports.scm: Prevent TOCTTOU bugs by
	  additionally returning the buffer and offset when we compute an
	  amount-buffered.

	Remove remaining "display" uses in (web http)
	* module/web/http.scm (header-writer): Default to calling put-string.
	  (put-list): Rename from write-list, take the port first, and call the
	  put-item function with port then value.  Adapt all callers.
	  (write-date): Rename display-digits to put-digits.
	  (put-challenge): Rename from write-challenge, adapt arguments to put
	  convention, and adapt callers.
	  (declare-symbol-list-header!): Use put-symbol.
	  (declare-integer-header!): Use put-non-negative-integer.o
	  (declare-entity-tag-list-header!): Use put-entity-tag-list.
	  ("If-Range", "Etag"): Adapt to put-entity-tag.
	  (make-chunked-output-port): Use put-char.

	Beginnings of suspendable HTTP
	* module/web/http.scm: Use put-string and other routines from (ice-9
	  textual-ports) in preference to `display'.  The goal is for these
	  operations to be suspendable.

	Modernize (web http) a bit
	* module/web/http.scm: Modernize the Guile Scheme by using more match,
	  when, unless, and non-tail conversion.  No functional change, with the
	  exception of fixing a bug in write-key-value-list for symbols like
	  100-continue that shouldn't print as #{100-continue}#.
	* test-suite/tests/web-http.test (pass-if-only-parse):
	  (pass-if-reparse, pass-if-parse): Arrange to also serialize and
	  reparse values from pass-if-parse.  Apply to all existing tests except
	  fragments where we don't expect fragments to be written out.

2017-02-07  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Fix rank 0 arrays and nested arrays in truncated-print
	* module/ice-9/pretty-print.scm (print): In the array case, pass
	  #:inner? along to (print-sequence), unless we're at the last dimension
	  of the array.
	  Special case for 0-rank arrays, which cannot be empty and have no
	  length.
	* test-suite/tests/print.test: Test some of the cases fixed by this
	  patch.

	Support arrays in truncated-print
	* module/ice-9/pretty-print.scm (print): Handle general arrays.
	* test-suite/tests/print.test: Test truncated-print with general arrays.

	Fix bug #25492
	* libguile/vm-engine.c (BR_F64_ARITHMETIC): Fix type.

2017-02-07  Andy Wingo  <wingo@pobox.com>

	Avoid stacks in dynamically-bound values
	* libguile/dynstack.h:
	* libguile/dynstack.c (scm_dynstack_find_old_fluid_value): New
	  function.
	* libguile/fluids.c (saved_dynamic_state_ref): New helper.
	  (scm_fluid_ref): Fix docstring.
	  (scm_fluid_ref_star): New function allowing access to previous values
	  for a fluid.
	  (scm_dynamic_state_ref): New internal function.
	* libguile/fluids.h: Add scm_fluid_ref_star and scm_dynamic_state_ref.
	* libguile/stacks.c (scm_stack_id): Adapt to %stacks not being a chain.
	* libguile/throw.c (catch, throw_without_pre_unwind): Adapt to
	  %exception-handlers not being a chain.
	* module/ice-9/boot-9.scm (catch, dispatch-exception): Instead of having
	  %exception-handlers be a chain, use fluid-ref* to access the chain
	  that is in place at the time the exception is thrown.  Prevents
	  unintended undelimited capture of the current exception handler stack
	  by a delimited "catch".
	  (%start-stack): Similarly, don't be a chain.
	* module/system/repl/debug.scm (frame->stack-vector):
	* module/system/repl/error-handling.scm (call-with-error-handling):
	* module/ice-9/save-stack.scm (save-stack): Adapt to %stacks not being a
	  chain.
	* test-suite/tests/exceptions.test ("delimited exception handlers"): Add
	  tests.
	* doc/ref/api-control.texi (Fluids and Dynamic States): Add docs.

2017-01-19  Andy Wingo  <wingo@pobox.com>

	Guile 2.1.6.
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump to 2.1.6.

	Update NEWS.
	* NEWS: Update.

	Fix build warning
	* libguile/stime.c (scm_init_stime): Remove unused variable.

2017-01-12  David Thompson  <dthompson2@worcester.edu>

	Add unboxed floating point comparison instructions.
	* libguile/vm-engine.c (BR_F64_ARITHMETIC): New preprocessor macro.
	(br_if_f64_ee, br_if_f64_lt, br_if_f64_le, br_if_f64_gt, br_if_f64_ge):
	New VM instructions.
	* doc/ref/vm.texi ("Unboxed Floating-Point Arithmetic"): Document them.
	* module/language/cps/compile-bytecode.scm (compile-function): Emit f64
	comparison instructions.
	* module/language/cps/effects-analysis.scm: Define effects for f64
	primcalls.
	* module/language/cps/primitives.scm (*branching-primcall-arities*): Add
	arities for f64 primcalls.
	* module/language/cps/specialize-numbers.scm (specialize-f64-comparison):
	New procedure.
	(specialize-operations): Specialize f64 comparisons.
	* module/system/vm/assembler.scm (emit-br-if-f64-=, emit-br-if-f64-<)
	(emit-br-if-f64-<=, emit-br-if-f64->, emit-br-if-f64->=): Export.
	* module/system/vm/disassembler.scm (code-annotation): Add annotations
	for f64 comparison instructions.

2017-01-11  Andy Wingo  <wingo@pobox.com>

	Protect call-with-new-thread data from GC.
	* libguile/threads.c (struct launch_data): Add prev/next pointers.
	  (protected_launch_data, protected_launch_data_lock): New static vars.
	  (protect_launch_data, unprotect_launch_data): New functions.
	  (really_launch, scm_sys_call_with_new_thread): Preserve launch data
	  from GC.  Thanks to Linas Vepstas for the report!

2017-01-09  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Final names for new array functions
	Globally rename (array-from* -> array-slice), (array-from ->
	array-cell-ref), (array-amend! -> array-cell-set!), (array-for-each-cell
	-> array-slice-for-each).

2017-01-08  Andy Wingo  <wingo@pobox.com>

	Fix scm_init_stime for macOS
	* libguile/stime.c (scm_init_stime): Remove needless test of
	  clock_getcpuclockid.  Fixes build on macOS; thanks to Matt Wette for
	  the report and fix.

	Fix alloc_aligned for high allocations
	* libguile/loader.c (alloc_aligned): Widen alignment.  Thanks to Matt
	  Wette for the report and the fix!

	Speed up load-thunk-from-memory for page alignment
	* libguile/loader.c (page_size): New static var.
	  (alloc_aligned): Enable mmap path that was never used in the
	  past (!).  Thanks to Matt Wette for the bug report!
	  (load_thunk_from_memory): Use page_size instead of 4096.
	  (scm_bootstrap_loader): Init page_size.

	Fix mkstemp on macOS
	* libguile/filesys.c (scm_i_mkstemp): Limit flags to mkostemp.  Based on
	  a patch by Matt Wette; thanks!

	Fix close-port race.
	* libguile/ports.c (release_port): Fix race.

	Exited threads retain less memory
	* libguile/threads.c (on_thread_exit): Lessen excess retention.

	Prevent some interrupts of wait-condition-variable
	* libguile/threads.c (timed_wait): Disable interrupts while reacquiring
	  mutex after wait-condition-variable.

	Enable interrupts only when running thread body
	* libguile/threads.c (really_launch): Start threads with asyncs
	  blocked.
	* module/ice-9/threads.scm (call-with-new-thread): Unblock asyncs once
	  we have the bookkeeping sorted out.  Don't use
	  with-continuation-barrier; it's not needed.  Print nice thread
	  backtraces.

	Remove thread-specific admin mutex
	* libguile/threads.c (guilify_self_1):
	* libguile/threads.h (scm_i_thread): Remove unused thread "admin
	  mutex".

	Remove thread-exited? check in sigaction
	* libguile/scmsigs.c (scm_sigaction_for_thread): Remove check that
	  thread hadn't exited.  This check was racy as it's always possible
	  that the other thread exits between checking it or even after the
	  signal handler is installed.

	Thread prepare-to-wait respects block_asyncs
	* libguile/async.c (scm_i_prepare_to_wait): Don't signal interrupt if
	  asyncs are blocked.

2016-12-29  Andy Wingo  <wingo@pobox.com>

	New interfaces to help wait on fd/cond
	* libguile/async.h:
	* libguile/async.c (struct scm_thread_wake_data): Include the cond to
	  signal.  Be a union and include a tag.
	  (scm_i_prepare_to_wait): Rename from scm_i_setup_sleep and take wake
	  data directly.  Also call scm_i_wait_finished as appropriate.
	  (scm_i_wait_finished): Rename from scm_i_reset_sleep.
	  (scm_i_prepare_to_wait_on_fd, scm_c_prepare_to_wait_on_fd):
	  (scm_i_prepare_to_wait_on_cond, scm_c_prepare_to_wait_on_cond): New
	  functions.
	  (scm_c_wait_finished): New function.
	  (scm_system_async_mark_for_thread): Adapt to wake data change.
	* libguile/threads.c (block_self, scm_std_select): Adapt to async
	  interface changes.
	* doc/ref/api-scheduling.texi (Asyncs): Doc new public interfaces.

2016-12-18  Andy Wingo  <wingo@pobox.com>

	Improve handle-interrupts placement
	* module/language/cps/handle-interrupts.scm (compute-safepoints): New
	  function.
	  (add-handle-interrupts): Add safepoints at backedge targets, not
	  backedges.  Gives better register allocation, loop rotation, and code
	  size.

2016-12-18  Mark H Weaver  <mhw@netris.org>

	FFI: Add support for functions that set 'errno'.
	Implements wishlist item <https://debbugs.gnu.org/18592>.
	Requested by Frank Terbeck <ft@bewatermyfriend.org>.
	Based on a proposed patch by Nala Ginrut <nalaginrut@gmail.com>.
	Patch ported to 2.2 by Andy Wingo <wingo@pobox.com>.

	* libguile/foreign.c (cif_to_procedure): Add 'with_errno' argument.
	  If true, truncate result to only one return value.
	  (scm_i_foreign_call): Separate the arguments.  Always return errno.
	  (pointer_to_procedure): New static function.
	  (scm_pointer_to_procedure_with_errno): New C API function, implemented
	  in terms of 'pointer_to_procedure'.
	  (scm_pointer_to_procedure): Reimplement in terms of
	  'pointer_to_procedure', no longer bound to "pointer->procedure".  See
	  below.
	  (scm_i_pointer_to_procedure): New C function bound to
	  "pointer->procedure" which now accepts the optional #:return-errno?
	  keyword argument, implemented in terms of 'pointer_to_procedure'.
	  (k_return_errno): New keyword #:return-errno?.
	* libguile/foreign.h (scm_pointer_to_procedure_with_errno): Add prototype.
	* doc/ref/api-foreign.texi (Dynamic FFI): Adjust documentation.
	* libguile/vm-engine.c (foreign-call): Return two values.

2016-12-15  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Test format ~f with width parameters
	* test-suite/tests/format.test: Additional tests for ~f.

2016-12-14  Andy Wingo  <wingo@pobox.com>

	Fix bug in compute-significant-bits for phi predecessors
	* module/language/cps/specialize-numbers.scm (compute-significant-bits):
	  Always revisit predecessors after first visit.  Avoids situation where
	  predecessor of an unvisited phi var could default to 0 significant
	  bits and never be revisited.  Fixes (format #f "~2f" 9.9).

2016-12-14  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Make scm_gc_warn_proc() write directly to stderr
	This avoids a deadlock due to the lookup of cur_warnport_fluid while an
	allocation is ongoing.

	* libguile/gc.c (scm_gc_warn_proc): Write the warning directly to
	  stderr.

2016-12-12  Andy Wingo  <wingo@pobox.com>

	Add suspendable-continuation?
	* doc/ref/api-control.texi (Prompt Primitives): Document
	  suspendable-continuation?.
	* libguile/control.c (scm_suspendable_continuation_p): New procedure.
	  (scm_init_ice_9_control): New extension procedure, defines
	  suspendable-continuation?.
	  (scm_init_control): Register scm_init_ice_9_control.
	* libguile/eval.c (eval):
	* libguile/throw.c (catch):
	* libguile/continuations.c (scm_i_make_continuation): Restore resumable
	  prompt cookie after continuation invocation.
	* libguile/vm.c (scm_call_n): Arrange to set resumable_prompt_cookie
	  during invocation of VM.
	* libguile/vm.h (struct scm_vm): Add resumable_prompt_cookie member.
	* module/ice-9/control.scm: Export suspendable-continuation?.
	* test-suite/tests/control.test ("suspendable-continuation?"): New
	  test.

2016-12-07  Andy Wingo  <wingo@pobox.com>

	Bump version to 2.1.5.
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump.

	Fix --without-threads
	* libguile/dynl.c:
	* libguile/gc.c:
	* libguile/keywords.c:
	* libguile/scmsigs.c:
	* libguile/stime.c: Use scm_i_dynamic_link instead of scm_dynamic_link
	  so that things compile in without-threads configurations.

2016-12-06  Andy Wingo  <wingo@pobox.com>

	Refine check for when atomics are available.
	* configure.ac:
	* libguile/atomics-internal.h: Use HAVE_STDATOMIC_H to know when to use
	  atomics.

	Use readdir instead of readdir_r
	* libguile/filesys.c:
	* configure.ac: Remove readdir_r / readdir64_r checks and usage.
	  glibc's impls are thread-safe, the _r variants are squirrely and now
	  deprecated in glibc, and it is expected that POSIX will mandate that
	  readdir{,64} be thread-safe already.  See
	  https://sourceware.org/ml/libc-alpha/2016-02/msg00093.html.

	Update NEWS.
	* NEWS: Update.

	Add thread-local variables manual section.
	* doc/ref/api-scheduling.texi (Thread Local Variables): New subsection.

	Minor parameters doc change
	* doc/ref/api-control.texi (Parameters): Make the opening a bit less
	  abrupt.

	Update fluids / dynstate docs
	* doc/ref/api-control.texi (Fluids and Dynamic States): Update
	  documentation.

	Move fluids, parameters docs nearer to dynamic-wind
	* doc/ref/api-control.texi:
	* doc/ref/api-scheduling.texi: Move fluids and parameters docs.

2016-12-06  Christopher Allan Webber  <cwebber@dustycloud.org>

	Fix small typo in suspendable-ports documentation.
	* doc/ref/api-io.texi (Non-Blocking I/O): Fix example to call use-modules
	  rather than use-module.

2016-12-05  Andy Wingo  <wingo@pobox.com>

	with-dynamic-state compiler and VM support
	* libguile/dynstack.h (SCM_DYNSTACK_TYPE_DYNAMIC_STATE):
	* libguile/dynstack.c (DYNAMIC_STATE_WORDS, DYNAMIC_STATE_STATE_BOX):
	  (scm_dynstack_push_dynamic_state):
	  (scm_dynstack_unwind_dynamic_state): New definitions.
	  (scm_dynstack_unwind_1, scm_dynstack_wind_1): Add with-dynamic-state
	  cases.
	* libguile/memoize.c (push_dynamic_state, pop_dynamic_state)
	  (do_push_dynamic_state, do_pop_dynamic_state): New definitions.
	  (memoize, scm_init_memoize): Handle push-dynamic-state and
	  pop-dynamic-state.
	* libguile/vm-engine.c (push-dynamic-state, pop-dynamic-state): New
	  opcodes.
	* module/ice-9/boot-9.scm (with-dynamic-state): New definition in Scheme
	  so that the push-dynamic-state and pop-dynamic-state always run in the
	  VM.
	* module/language/cps/compile-bytecode.scm (compile-function):
	* module/language/cps/effects-analysis.scm:
	* module/language/cps/types.scm:
	* module/language/tree-il/effects.scm (make-effects-analyzer):
	* module/language/tree-il/peval.scm (peval):
	* module/language/tree-il/primitives.scm (*interesting-primitive-names*):
	* module/system/vm/assembler.scm: Add support for with-dynamic-state to
	  the compiler.
	* test-suite/tests/fluids.test ("dynamic states"): Add basic tests.
	* doc/ref/vm.texi (Dynamic Environment Instructions): Update.

2016-12-05  Andy Wingo  <wingo@pobox.com>

	Reimplement dynamic states
	There are two goals: one, to use less memory per dynamic state in order
	to allow millions of dynamic states to be allocated in light-weight
	threading scenarios.  The second goal is to prevent dynamic states from
	being actively mutated in two threads at once.  This second goal does
	mean that dynamic states object that escape into scheme are now copies
	that won't receive further updates; an incompatible change, but one
	which we hope doesn't affect anyone.

	* libguile/cache-internal.h: New file.
	* libguile/fluids.c (is_dynamic_state, get_dynamic_state)
	  (save_dynamic_state, restore_dynamic_state, add_entry)
	  (copy_value_table): New functions.
	  (scm_i_fluid_print, scm_i_dynamic_state_print): Move up.
	  (new_fluid): No need for a number.
	  (scm_fluid_p: scm_is_fluid): Inline IS_FLUID uses.
	  (fluid_set_x, fluid_ref): Adapt to dynamic state changes.
	  (scm_fluid_set_x, scm_fluid_unset_x): Call fluid_set_x.
	  (scm_swap_fluid): Rewrite in terms of fluid_ref and fluid_set.
	  (swap_fluid): Use internal fluid_set_x.
	  (scm_i_make_initial_dynamic_state): Adapt to dynamic state
	  representation change.
	  (scm_dynamic_state_p, scm_is_dynamic_state): Use new accessors.
	  (scm_current_dynamic_state): Use make_dynamic_state.
	  (scm_dynwind_current_dynamic_state): Use new accessor.
	* libguile/fluids.h: Remove internal definitions.  Add new struct
	  definition.
	* libguile/threads.h (scm_i_thread): Use scm_t_dynamic_state for dynamic
	  state.
	* libguile/threads.c (guilify_self_1, guilify_self_2):
	  (scm_i_init_thread_for_guile, scm_init_guile):
	  (scm_call_with_new_thread):
	  (scm_init_threads, scm_init_threads_default_dynamic_state): Adapt to
	  scm_i_thread change.
	  (scm_i_with_guile, with_guile): Remove "and parent" suffix.
	  (scm_i_reset_fluid): Remove unneeded function.
	* doc/ref/api-scheduling.texi (Fluids and Dynamic States): Remove
	  scm_make_dynamic_state docs.  Update current-dynamic-state docs.
	* libguile/vm-engine.c (vm_engine): Update fluid-ref and fluid-set!
	  inlined fast paths for dynamic state changes.
	* libguile/vm.c (vm_error_unbound_fluid): Remove now-unused function.
	* NEWS: Update.
	* module/ice-9/deprecated.scm (make-dynamic-state): New definition.
	* libguile/deprecated.h:
	* libguile/deprecated.c (scm_make_dynamic_state): Move here.
	* libguile/__scm.h (scm_t_dynamic_state): New typedef.
	* libguile/dynstack.h:
	* libguile/dynstack.c (scm_dynstack_push_fluid):
	  (scm_dynstack_unwind_fluid): Take raw dynstate in these internal
	  functions.
	* libguile/throw.c (catch): Adapt to dynstack changes.

2016-11-30  Andy Wingo  <wingo@pobox.com>

	Fix two wait-condition-variable race conditions
	* libguile/threads.c (timed_wait): When looping to reacquire mutex,
	  check if mutex owner after dropping mutex to run asyncs when the
	  reacquire is interrupted.

	  Also for asyncs that interrupted the initial wait, just return #t
	  directly, and allow the caller to loop.  Fixes a deadlock in which a
	  thread could have pending asyncs after dropping a mutex and which
	  prevent it from going to wait on a cond, but then the broadcast comes
	  while nobody is waiting and the mutex is dropped, then after
	  reacquiring the mutex when we go to wait again, we wait forever.

	  The correct thing to do is after reacquiring the mutex, to allow the
	  application to check if waiting is appropriate.

2016-11-27  Andy Wingo  <wingo@pobox.com>

	Compile fluid-set! to VM opcode
	* libguile/vm-engine.c (fluid-set!): Fix name of opcode to correspond
	  with name of Tree-IL primitive.  Fixes compilation of fluid-set! to
	  actually use the fluid-set! opcode.
	* doc/ref/vm.texi (Dynamic Environment Instructions): Update.
	* module/language/cps/compile-bytecode.scm (compile-function): Add
	  fluid-set! case.
	* module/system/vm/assembler.scm: Update export name for
	  emit-fluid-set!.

	Ensure autoconf doesn't downgrade us to C99
	* configure.ac: Add -std=gnu11 if the compiler is GCC (or clang).  This
	  prevents AC_PROG_CC_C99 from downgrading us by adding -std=gnu99.
	  Fixes regression whereby we were always using the fallback
	  implementation of atomics.

2016-11-26  Andy Wingo  <wingo@pobox.com>

	Add weak-table fast path for update
	* libguile/weak-table.c (weak_table_put_x): If the key is the same and
	  the table is weak-key, avoid re-setting disappearing links.

	Fix scm_weak_table_refq for undefined default
	* libguile/weak-table.c (scm_weak_table_refq): No need to default weak
	  table result to #f; just use whatever was passed in.

	Remove special support for fluids in GDB interface
	* module/system/base/types.scm (inferior-fluid?, inferior-fluid-number)
	  (<inferior-fluid>): Remove.  Fluids won't have numbers in the future.
	  (cell->object): Adapt.
	* test-suite/tests/types.test ("opaque objects"): Update.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Deprecate scm_from_contiguous_array
	scm_from_contiguous_array() was undocumented, unused within Guile, and
	can be replaced by make-array + array-copy! without requiring contiguity
	and without loss of performance.

	* libguile/arrays.c (scm_array_contents): Do not rely on
	  SCM_I_ARRAY_CONTP.
	* test-suite/tests/arrays.test: Test array-contents with 0-rank array.
	* libguile/arrays.h: Declare scm_i_shap2ra(),
	  SCM_SET_ARRAY_CONTIGUOUS_FLAG, SCM_CLR_ARRAY_CONTIGUOUS_FLAG so that
	  scm_from_contiguous_array() can keep using them.
	* libguile/deprecated.c (scm_from_contiguous_array): Move here from
	  arrays.c.
	* libguile/deprecated.h (scm_from_contiguous_array): Deprecate.
	* NEWS: Add deprecation notice.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Document new array functions, with provisional names
	* doc/ref/api-data.texi: New section 'Arrays as arrays of
	  arrays'. Document array-from, array-from*, array-amend!,
	  array-for-each-cell, array-for-each-cell-in-order.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	New functions (array-for-each-cell, array-for-each-cell-in-order)
	* libguile/array-map.c (scm_i_array_rebase, scm_array_for_each_cell):
	  New functions. Export scm_array_for_each_cell() as
	  (array-for-each-cell).

	  (array-for-each-cell-in-order): Define additional export.

	* libguile/array-map.h (scm_i_array_rebase, scm_array_for_each_cell):
	  Add prototypes.

	* test-suite/tests/array-map.test: Renamed from
	  test-suite/tests/ramap.test, fix module name. Add tests for
	  (array-for-each-cell).

	* test-suite/Makefile.am: Apply rename array-map.test -> ramap.test.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	New functions array-from, array-from*, array-amend!
	* libguile/arrays.h (scm_array_from, scm_array_from_s,
	  scm_array_amend_x): New declarations.

	* libguile/arrays.c (scm_array_from, scm_array_from_s,
	  scm_array_amend_x): New functions, export as array-from, array-from*,
	  array-amend!.

	* test-suite/tests/arrays.test: Tests for array-from, array-from*,
	  array-amend!. Replace with-test-prefix/c&e with with-test-prefix where
	  the array read syntax isn't used.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Do not use array handles in scm_vector
	* libguile/vectors.c (scm_vector): Use SCM_I_VECTOR_WELTS on new vector
	  instead of generic scm_vector_elements; cf. scm_vector_copy().

	  (scm_vector_elements): Forward to scm_vector_writable_elements().

	  (scm_vector_writable_elements): Remove special error message for weak
	  vector arg.

	* libguile/generalized-vectors.c (SCM_VALIDATE_VECTOR_WITH_HANDLE):
	  Remove unused macro.

	* libguile/array-handle.c (scm_array_handle_elements): Forward to
	  scm_array_handle_writable_elements().

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Special case for array-map! with three arguments
	Benchmark:

	(define type #t)
	(define A (make-typed-array 's32 0 10000 1000))
	(define B (make-typed-array 's32 0 10000 1000))
	(define C (make-typed-array 's32 0 10000 1000))

	before:

	scheme@(guile-user)> ,time (array-map! C + A B)
	;; 0.792653s real time, 0.790970s run time.  0.000000s spent in GC.

	after:

	scheme@(guile-user)> ,time (array-map! C + A B)
	;; 0.598513s real time, 0.597146s run time.  0.000000s spent in GC.

	* libguile/array-map.c (ramap): Add special case with 3 arguments.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Speed up for multi-arg cases of scm_ramap functions
	This patch results in a 20%-40% speedup in the > 1 argument cases of
	the following microbenchmarks:

	(define A (make-shared-array #0(1) (const '()) #e1e7))
	; 1, 2, 3 arguments.
	(define a 0) ,time (array-for-each (lambda (b) (set! a (+ a b))) A)
	(define a 0) ,time (array-for-each (lambda (b c) (set! a (+ a b c))) A A)
	(define a 0) ,time (array-for-each (lambda (b c d) (set! a (+ a b c d))) A A A)

	(define A (make-shared-array (make-array 1) (const '()) #e1e7))
	(define B (make-shared-array #0(1) (const '()) #e1e7))
	; 1, 2, 3 arguments.
	,time (array-map! A + B)
	,time (array-map! A + B B)
	,time (array-map! A + B B B)

	* libguile/array-map.c (scm_ramap): Note on cproc arguments.

	  (rafill): Assume that dst's lbnd is 0.

	  (racp): Assume that src's lbnd is 0.

	  (ramap): Assume that ra0's lbnd is 0. When there're more than two
	  arguments, compute the array handles before the loop. Allocate the arg
	  list once and reuse it in the loop.

	  (rafe): Do as in ramap(), when there's more than one argument.

	  (AREF, ASET): Remove.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Support typed arrays in some sort functions
	* libguile/sort.c (sort!, sort, restricted-vector-sort!, sorted?):
	  Support arrays of rank 1, whatever the type.

	* libguile/quicksort.i.c: Fix accessors to handle typed arrays.

	* test-suite/tests/sort.test: Test also with typed arrays.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Remove deprecated array functions
	* libguile/array-map.c (scm_array_fill_int, scm_array_fill_int,
	    scm_ra_eqp, scm_ra_lessp scm_ra_leqp, scm_ra_grp, scm_ra_greqp,
	    scm_ra_sum, scm_ra_difference, scm_ra_product, scm_ra_divide,
	    scm_array_identity): Remove deprecated functions.

	* libguile/array-map.h: Remove declaration of deprecated functions.

	* libguile/generalized-vectors.h, libguile/generalized-vectors.c
	  (scm_is_generalized_vector, scm_c_generalized_vector_length,
	  scm_c_generalized_vector_ref, scm_c_generalized_vector_set_x): These
	  functions were deprecated in 2.0.9. Remove.

	* doc/ref/api-compound.texi: Remove uniform-array-read!,
	  uniform-array-write from the manual. These procedures where removed in
	  fc7bd367ab4b5027a7f80686b1e229c62e43c90b (2011-05-12).

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Reuse SCM_BYTEVECTOR_TYPED_LENGTH in scm_array_get_handle
	* libguile/bytevectors.h (SCM_BYTEVECTOR_TYPE_SIZE,
	  SCM_BYTEVECTOR_TYPED_LENGTH): Moved from libguile/bytevectors.c.

	* libguile/array-handle.c (scm_array_get_handle): Reuse
	  SCM_BYTEVECTOR_TYPED_LENGTH.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Avoid unneeded internal use of array handles
	* libguile/arrays.c (scm_shared_array_root): Adopt uniform check order.

	  (scm_shared_array_offset, scm_shared_array_increments): Use the array
	  fields directly just as scm_shared_array_root does.

	  (scm_c_array_rank): Moved from libguile/generalized-arrays.c. Don't
	  use array handles, but follow the same type check sequence as the
	  other array functions (shared-array-root, etc).

	  (scm_array_rank): Moved from libguile/generalized-arrays.h.

	* libguile/arrays.h: Move prototypes here.

	* test-suite/tests/arrays.test: Tests for shared-array-offset,
	  shared-array-increments.

2016-11-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Fix compilation of rank 0 typed array literals
	* module/system/vm/assembler.scm (simple-uniform-vector?): array-length
	  fails for rank 0 arrays; fix the shape condition.

	* test-suite/tests/arrays.test: Test reading of #0f64(x) in compilation
	  context.

2016-11-22  Andy Wingo  <wingo@pobox.com>

	Merge api-{data,compound}.texi
	* doc/ref/api-compound.texi: Remove.
	* doc/ref/api-data.texi: Fold "Compound Data Types" and "Simple Data
	  Types" into just "Data Types".  The distinction didn't work.
	* doc/ref/guile.texi:
	* doc/ref/Makefile.am:
	* doc/ref/srfi-modules.texi: Adapt.

	Add NEWS item about mutexes
	* NEWS: Add entry.

2016-11-21  Andy Wingo  <wingo@pobox.com>

	Deprecate dynamic roots
	* libguile/root.h:
	* libguile/root.c: Remove these files.
	* libguile/deprecated.h:
	* libguile/deprecated.c (scm_internal_cwdr, scm_call_with_dynamic_root)
	  (scm_dynamic_root, scm_apply_with_dynamic_root): Deprecate.

	Remove all root.h usage, which was vestigial.

	* module/ice-9/serialize.scm: Use (current-thread) instead
	  of (dynamic-root).

2016-11-21  Andy Wingo  <wingo@pobox.com>

	Update join-thread docs
	* doc/ref/api-scheduling.texi (Threads): Joining a foreign thread is an
	  error.
	* NEWS: Update.

2016-11-19  Andy Wingo  <wingo@pobox.com>

	Add asyncs test
	* test-suite/tests/asyncs.test: New file.

	Inline interrupts
	* libguile/async.c:
	* libguile/async.h (scm_i_async_push, scm_i_async_pop): Make internally
	  available.
	* libguile/vm-engine.c (vm_engine): Invoke interrupts inline.  Add
	  return-from-interrupt instruction.
	* libguile/vm.c (vm_handle_interrupt_code): New "builtin".

2016-11-18  Andy Wingo  <wingo@pobox.com>

	Refactor async handling to be FIFO
	* libguile/async.c (scm_i_async_push, scm_i_async_pop): New helpers.
	  (scm_async_tick, scm_system_async_mark_for_thread): Use the new
	  helpers.

2016-11-18  Andy Wingo  <wingo@pobox.com>

	Remove SCM_DEBUG_CELL_ACCESSES==1
	Since the move to BDW-GC this option has not been useful.

	* libguile/__scm.h (SCM_DEBUG_CELL_ACCESSES): Remove default
	  definition.
	* libguile/gc.h: Add comment about cells.
	  (SCM_VALIDATE_CELL): Remove.  I did a search on the internet and I
	  found no external users.
	  (SCM_CELL_WORD, SCM_CELL_OBJECT, SCM_SET_CELL_WORD)
	  (SCM_SET_CELL_OBJECT, SCM_CELL_OBJECT_LOC): Remove SCM_VALIDATE_CELL
	  uses.
	* libguile/gc.c (scm_debug_cell_accesses_p)
	  (scm_expensive_debug_cell_accesses_p)
	  (scm_debug_cells_gc_interval, scm_i_expensive_validation_check)
	  (scm_assert_cell_valid): Remove bindings only available when
	  SCM_DEBUG_CELL_ACCESSES was 1.
	* libguile/list.c (scm_list_n): Remove SCM_VALIDATE_CELL usage.

2016-11-17  Andy Wingo  <wingo@pobox.com>

	Explicit interrupt handling in VM
	* libguile/foreign.c (CODE, get_foreign_stub_code): Add explicit
	  handle-interrupts and return-values calls, as foreign-call will fall
	  through.
	* libguile/gsubr.c (A, B, C, AB, AC, BC, ABC, SUBR_STUB_CODE)
	  (scm_i_primitive_call_ip): Same.
	* libguile/vm-engine.c (VM_HANDLE_INTERRUPTS): Inline into
	  handle-interrupts.
	  (RETURN_ONE_VALUE, RETURN_VALUE_LIST): Inline into callers, and fall
	  through instead of returning.
	  (BR_BINARY, BR_UNARY, BR_ARITHMETIC, BR_U64_ARITHMETIC): Remove
	  conditional VM_HANDLE_INTERRUPTS, as the compiler already inserted the
	  handle-interrupts calls if needed.
	  (vm_engine): Remove VM_HANDLE_INTERRUPTS invocations except in the
	  handle-interrupts instruction.

2016-11-16  Andy Wingo  <wingo@pobox.com>

	Add handle-interrupts inst and compiler pass
	* libguile/vm-engine.c (vm_engine): Remove initial VM_HANDLE_INTERRUPTS
	  call; surely our caller already handled interrupts.  Add
	  handle-interrupts opcode.
	* am/bootstrap.am (SOURCES):
	* module/Makefile.am (SOURCES): Add handle-interrupts.scm.
	* module/system/vm/assembler.scm (system):
	* module/language/cps/compile-bytecode.scm (compile-function):
	  (lower-cps): Add handle-interrupts support.
	* module/language/cps/handle-interrupts.scm: New file.

2016-11-14  Andy Wingo  <wingo@pobox.com>

	Slim thread cleanup
	* libguile/threads.c (on_thread_exit): Clean up the cleanup.  We no
	  longer need to re-enter Guile mode, and some of the comments were
	  incorrect.

	join-thread in Scheme
	* module/ice-9/threads.scm (join-thread): Implement in Scheme.
	  (call-with-new-thread): Arrange to record values in a weak table and
	  signal the join cond.
	  (with-mutex): Move up definition; call-with-new-thread needs it.  (How
	  was this working before?)
	* libguile/threads.c (guilify_self_1, guilify_self_2, do_thread_exit):
	  Remove join queue management.
	* libguile/threads.c (scm_join_thread, scm_join_thread_timed): Call out
	  to Scheme.
	  (scm_init_ice_9_threads): Capture join-thread var.

	scm_spawn_thread uses call-with-new-thread
	* libguile/throw.h (scm_i_make_catch_body_closure)
	  (scm_i_make_catch_handler_closure): Add scm_i_ prefix and make
	  available for internal use.
	* libguile/throw.c: Adapt.
	* libguile/threads.c (scm_spawn_thread): Rewrite in terms of
	  scm_call_with_new_thread.

2016-11-13  Andy Wingo  <wingo@pobox.com>

	Fix crasher in scm_system_async_mark_for_thread
	* libguile/async.c (scm_system_async_mark_for_thread): Only signal the
	  cond if there is a wait mutex.

	More comments in threads.c
	* libguile/threads.c (struct scm_mutex): Better comments.

	Optimize lock-mutex
	* libguile/threads.c (lock_mutex, scm_timed_lock_mutex): As with
	  unlock_mutex before, optimize by specializing to the mutex kind.
	  Also, avoid lock thrashing after a return from block_self.

	Improve mutexes / condition variable implementation
	* libguile/threads.c (scm_timed_lock_mutex): Use "level" field only for
	  recursive mutexes.
	  (unlock_mutex, scm_unlock_mutex): Factor implementation back out of
	  scm_unlock_mutex (doh?), but in such a way that can specialize against
	  mutex type.
	  (scm_mutex_level): Only look at level for recursive mutexes.
	  (scm_mutex_locked_p): Look at owner field, not level field.
	  (timed_wait, scm_timed_wait_condition_variable): Factor implementation
	  out, as above with unlock-mutex.  Specialize relocking of the Guile
	  mutex.

	Refactor GC implications of thread sleep
	* libguile/async.c (struct scm_thread_wake_data): Move definition here.
	  (scm_i_setup_sleep): Remove "sleep_object".  Caller now responsible
	  for scm_remember_upto_here_1 as appropriate.
	  (scm_system_async_mark_for_thread): Remove scm_remember_upto_here_1
	  call.
	* libguile/async.h (scm_i_setup_sleep): Adapt prototype.
	* libguile/threads.h (struct scm_thread_wake_data): Remove definition.
	* libguile/threads.c (block_self): Remove sleep_object argument.
	  (scm_join_thread_timed, scm_timed_lock_mutex)
	  (scm_timed_wait_condition_variable, scm_std_select): Adapt.

	Unlocked mutexes don't have owners
	* libguile/threads.c (scm_unlock_mutex)
	  (scm_timed_wait_condition_variable): Unlocked mutexes should never
	  have owners.

	Put mutex kind in SMOB flags
	* libguile/threads.c (struct scm_mutex, SCM_MUTEX_KIND, scm_make_mutex)
	  (scm_timed_lock_mutex, scm_unlock_mutex)
	  (scm_timed_wait_condition_variable): Mutex kind in SMOB flags.

	Rename Guile's internal mutexes and condvars
	* libguile/threads.c: Rename fat_mutex to struct scm_mutex, and likewise
	  for scm_cond.

	Internal threads refactor
	* libguile/threads.c: Inline "fat mutexes" and "fat conds" into their
	  users.  These are just Guile mutexes and Guile condition variables.

2016-11-07  Christopher Allan Webber  <cwebber@dustycloud.org>

	doc: Adjust capitalization for "HTTPS" and "GnuTLS".
	* doc/ref/web.texi (open-socket-for-uri): Adjust capitalization.

2016-11-07  Christopher Allan Webber  <cwebber@dustycloud.org>

	web: Add https support through gnutls.
	Since importing gnutls directly would result in a dependency cycle,
	we load gnutls lazily.

	This uses code originally written for Guix by Ludovic Courtès.

	* module/web/client.scm: (%http-receive-buffer-size)
	  (gnutls-module, ensure-gnutls, gnutls-ref, tls-wrap): New variables.
	  (open-socket-for-uri): Wrap in tls when uri scheme is https.
	* doc/ref/web.texi (open-socket-for-uri): Document gnutls usage.

2016-11-06  Andy Wingo  <wingo@pobox.com>

	Update NEWS.
	* NEWS: Update.

	Minor editing in api-scheduling.texi
	* doc/ref/api-scheduling.texi: Fix a couple editing mistakes.

	Update documentation on mutexes
	* doc/ref/api-scheduling.texi (Mutexes and Condition Variables):
	  Update.

2016-11-05  Andy Wingo  <wingo@pobox.com>

	scm_timed_lock_mutex replaces scm_lock_mutex_timed
	* libguile/deprecated.h:
	* libguile/deprecated.c (scm_lock_mutex_timed): Deprecate.
	* libguile/threads.h:
	* libguile/threads.c (scm_timed_lock_mutex): New function.
	  (scm_join_thread): Fix formatting.
	  (scm_lock_mutex): Fix formatting and update to scm_timed_lock_mutex
	  change.
	  (scm_try_mutex): Update to scm_timed_lock_mutex.

	Update mutex documentation
	* doc/ref/api-scheduling.texi (Mutexes and Condition Variables): Add
	  foreboding preface.

	Separate fat mutex unlock and wait operations
	* libguile/threads.c (fat_mutex_unlock, fat_mutex_wait): Separate wait
	  from unlock.
	  (scm_unlock_mutex, scm_timed_wait_condition_variable): Adapt.

	Back to simple unlock-mutex
	* libguile/threads.c (scm_unlock_mutex): Bind to unlock-mutex.
	* libguile/threads.h: Remove scm_unlock_mutex_timed.
	* libguile/deprecated.h: Add scm_unlock_mutex_timed.
	* libguile/deprecated.c (scm_unlock_mutex_timed): Deprecate.
	* test-suite/tests/threads.test: Update unlock-mutex tests to use
	  wait-condition-variable if they would wait on a cond.

	Replace scm_make_mutex_with_flags
	* libguile/threads.c (enum fat_mutex_kind): New data type, replacing
	  separate flags.
	  (struct fat_mutex): Adapt.
	  (make_fat_mutex): Fat mutexes can only be one of three kinds, not one
	  of 4 kinds.  (Recursive unowned mutexes are not a thing.)
	  (scm_make_mutex): Adapt.
	  (scm_make_mutex_with_kind): New function, replacing
	  scm_make_mutex_with_flags.  Still bound to make-mutex.
	  (scm_make_recursive_mutex): Adapt.
	  (fat_mutex_lock, fat_mutex_unlock): Adapt.
	* libguile/threads.h (scm_make_mutex_with_kind): New decl.
	* libguile/deprecated.h:
	* libguile/deprecated.c (scm_make_mutex_with_flags): Deprecate.

	Remove unchecked-unlock facility from Guile mutexes
	* libguile/threads.c (fat_mutex): Remove unchecked_unlock member.
	  (make_fat_mutex): Adapt.
	  (scm_make_mutex_with_flags): Remove unchecked-unlock flag.
	  (scm_make_recursive_mutex): Likewise.
	  (fat_mutex_unlock): Remove unchecked-unlock case.
	* test-suite/tests/threads.test: Remove unchecked-unlock test.

	Recursively locking a SRFI-18 mutex blocks
	* libguile/threads.c (fat_mutex_lock): allow-external-unlock mutexes
	  can't be recursive, but a recursive lock attempt can be unblocked by
	  an external thread, so these mutexes shouldn't throw an error on
	  recursive lock attempts.
	* test-suite/tests/srfi-18.test: Add tests.

	SRFI-18 mutexes are not recursive
	* module/srfi/srfi-18.scm (make-mutex): Not recursive.

	Move more functionality to SRFI-18 mutex-unlock!
	* module/srfi/srfi-18.scm (mutex-unlock!): Implement the
	  ignore-unlock-errors and wait-condition-variable behavior of
	  mutex-unlock! directly, without relying on Guile.

	Remove fat mutex abandoned mutex error
	* libguile/threads.c (fat_mutex_lock): Remove abandoned mutex error, as
	  SRFI-18 is responsible for this.
	* test-suite/tests/threads.test: Update test.

	Remove thread held pthread_mutex field
	* libguile/threads.h (scm_i_thread):
	* libguile/threads.c (guilify_self_1, on_thread_exit)
	  (scm_pthread_cond_wait, scm_pthread_cond_timedwait): The thread-local
	  held_mutex field is no longer needed, now that we cancel threads via
	  interrupts instead of pthread_cancel.

	Remove thread-local weak mutex set
	* libguile/threads.h (scm_i_thread):
	* libguile/threads.c (guilify_self_1, do_thread_exit, fat_mutex_lock):
	  Remove thread-local weak mutex set.

	SRFI-18 manages own mutex "abandoned" state
	* module/srfi/srfi-18.scm (<mutex>, with-thread-mutex-cleanup)
	  (make-mutex, mutex-state, abandon-mutex!, mutex-lock!): Manage
	  "abandoned" bit on Scheme side with no need for thread cleanup
	  handler.

2016-11-04  Andy Wingo  <wingo@pobox.com>

	Remove lock-mutex owner facility
	* libguile/threads.c (scm_lock_mutex_timed): Deprecate "owner"
	  argument.
	  (fat_mutex_lock): Remove owner argument.
	  (fat_mutex_unlock): Don't pass owner to scm_lock_mutex_timed.
	* test-suite/tests/threads.test: Remove tests of mutex-owner.

	SRFI-18 threads disjoint from guile threads
	* doc/ref/srfi-modules.texi (SRFI-18 Threads): Update.
	* module/srfi/srfi-18.scm (<mutex>): Add owner field.
	  (<thread>): New data type.
	  (make-thread): Adapt for boxed threads.
	  (thread-start!, thread-terminate!): Likewise.
	  (mutex-state): Adapt for boxed threads.
	  (mutex-lock!, mutex-unlock!): Update owner field.

	Update SRFI-18 documentation.
	* doc/ref/srfi-modules.texi (SRFI-18): Update documentation for disjoint
	  mutexes and cond variables.

	srfi-18 condition variables disjoint
	* module/srfi/srfi-18.scm (<condition-variable>): New data type.
	  (make-thread): Use srfi-18 interfaces.
	  (mutex-unlock!): Adapt to optional cond argument being disjoint from
	  Guile condition variables.
	  (make-condition-variable, condition-variable-signal!)
	  (condition-variable-broadcast!): Adapt.

	Remove export srfi-18 never had
	* module/srfi/srfi-18.scm (condition-variable-wait!): Remove undefined
	  export.

	SRFI-18 mutexes disjoint from Guile mutexes
	* module/srfi/srfi-18.scm (<mutex>): Define as a wrapper type around
	  Guile mutexes.
	  (thread-mutexes): New variable.
	  (with-thread-mutex-cleanup): New facility to abandon mutexes on
	  SRFI-18 thread exit.  Not yet used.
	  (make-thread): Use SRFI-18 interfaces.
	  (make-mutex): Reimplement for our boxed mutexes.
	  (mutex-state): Adapt.
	  (mutex-lock!): Adapt.
	  (mutex-unlock!): Adapt.
	* test-suite/tests/srfi-18.test: Don't assume that SRFI-18 mutexes are
	  the same as Guile mutexes.

2016-11-02  Andy Wingo  <wingo@pobox.com>

	try-mutex in terms of mutex-lock
	* libguile/threads.c (scm_try_mutex): Just call scm_lock_mutex_timed
	  with a zero timeout.
	* module/ice-9/threads.scm (try-mutex): Likewise.

	Fix typo in threads documentation
	* doc/ref/api-scheduling.texi (Threads): Fix typo.

2016-11-01  Andy Wingo  <wingo@pobox.com>

	Deprecate critical sections
	* NEWS: Deprecate critical sections.
	* doc/ref/api-scheduling.texi (Critical Sections): Remove.
	* libguile/async.c:
	* libguile/async.h:
	* libguile/deprecated.c:
	* libguile/deprecated.h:
	* libguile/threads.c:
	* libguile/threads.h: Deprecate critical section API.

	Threads no longer track critical section level
	* libguile/threads.h (scm_i_thread):
	* libguile/threads.c (guilify_self_1): Remove critical_section_level
	  member of scm_i_thread.
	* libguile/async.c (scm_critical_section_end)
	  (scm_critical_section_start): Remove bookkeeping.

	Remove call/cc assertion about critical sections
	* libguile/continuations.c (scm_dynthrow): Remove assertion about
	  critical section level; it's just a mutex anyway.

	Remove last critical section use
	* libguile/scmsigs.c (signal_handler_lock): New variable.
	  (scm_sigaction_for_thread): Block asyncs and use a mutex instead of
	  using scm_dynwind_critical_section.

	Mutex in dynamic linker
	* libguile/dynl.c (scm_dynamic_link, scm_dynamic_unlink)
	  (scm_dynamic_pointer): Use a mutex to provide thread-safety.

	Remove critical section in scm_debug_options
	* libguile/debug.c (scm_debug_options): Remove critical section.  There
	  is no memory corruption hazard and racing callers to debug options
	  won't produce sensible results anyway; or anyway they will be the same
	  as racing vector-set!.

	Mutex instead of critical section in gc.c
	* libguile/gc.c (scm_gc_protect_object, scm_gc_unprotect_object): Use a
	  mutex instead of a critical section.  Remove dead code.

	Mutex instead of critical section in GOOPS
	* libguile/goops.c (scm_sys_modify_instance)
	  (scm_sys_modify_class): Use a mutex instead of a critical section.

	Simplify critical section implementation
	* libguile/async.h (SCM_CRITICAL_SECTION_START)
	  (SCM_CRITICAL_SECTION_END): Define in just one way.
	* libguile/async.c (critical_section_mutex): New static variable.
	  (scm_critical_section_start, scm_critical_section_end): Inline
	  internal body of critical section gates.
	  (scm_init_async): Init critical_section_mutex.
	* libguile/threads.c (scm_threads_prehistory): Don't declare critical
	  section mutex here.

	Mutex instead of critical sectoin in symbol->keyword
	* libguile/keywords.c (scm_symbol_to_keyword): Use a mutex in a dynwind
	  instead of a critical section.

	Mutexes instead of critical sections in stime.c
	* libguile/stime.c (scm_current_time): No need for a critical section
	  around time().
	  (tz_lock): New mutex.
	  (scm_localtime): Use tz_lock in a dynwind.  Fixes bug in which
	  critical section was never left on error.
	  (scm_gmtime, scm_mktime, scm_strftime, scm_strptime): Use a normal
	  mutex instead of a critical section.

	Remove unused internal definitions
	* libguile/async.h (scm_i_pthread_mutex_lock_block_asyncs)
	  (scm_i_pthread_mutex_unlock_unblock_asyncs): Remove unused internal
	  definitions.

	regexec comment fix
	* libguile/regex-posix.c (SCM_DEFINE): Remove comment about
	  threadsafety, given that regexec does appear to be threadsafe.

	sigaction critical section refactor.
	* libguile/scmsigs.c (scm_sigaction_for_thread): Use critical section
	  dynwinds instead of SCM_CRITICAL_SECTION_START.

	threads: Use a mutex instead of a critical section.
	* libguile/threads.c: Replace uses of critical sections with a dedicated
	  mutex.

	Add scm_yield to manual alongside yield
	* doc/ref/api-scheduling.texi (Threads): Mention scm_yield.

	api-scheduling.texi: Syntactic cleanups.
	* doc/ref/api-scheduling.texi: Remove vestigial comments.

2016-10-31  Andy Wingo  <wingo@pobox.com>

	Remove thread cleanup facility
	* NEWS: Add entry.
	* doc/ref/api-scheduling.texi (Threads): Remove thread-cleanup docs.
	* libguile/threads.c (guilify_self_1, do_thread_exit):
	  (scm_set_thread_cleanup_x, scm_thread_cleanup): Remove these.
	* libguile/threads.h (scm_i_thread): Remove cleanup_handler.
	* module/ice-9/threads.scm:
	* module/ice-9/deprecated.scm (thread-cleanup, set-thread-cleanup!):
	  Remove.
	* test-suite/tests/threads.test: Adapt to test cancel-thread return
	  values and not test thread-cleanup procs.

	REPL server avoids thread cleanup handlers
	* module/system/repl/server.scm (serve-client): Avoid thread cleanup
	  handlers.

	srfi-18: thread-terminate! without cleanup handlers
	* module/srfi/srfi-18.scm (%cancel-sentinel, thread-terminate!): Just
	  use cancel-thread to cause the thread to return a sentinel value.
	  (%timeout-sentinel): Rename from %sentinel.
	  (thread-join!): Adapt and transform %cancel-sentinel to a
	  &terminated-thread-exception.

	cancel-thread can take arguments
	* doc/ref/api-scheduling.texi (Threads):
	* module/ice-9/threads.scm (cancel-thread): Additional args to
	  cancel-thread will be returned by the thread.

	Trim srfi-18 thread startup machinery
	* module/srfi/srfi-18.scm (make-thread): Use just one cond/mutex pair
	  for signalling in both directions: waiting for launch and waiting for
	  start.

	Refactor thread-join! to use optional args.
	* module/srfi/srfi-18.scm (thread-join!): Use optional args.  Also don't
	  treat false return values from threads as meaning anything.

	Rationalize exception handling in srfi-18
	* module/srfi/srfi-18.scm (make-thread): Inline some helpers, and use
	  just one catch block.
	  (thread->exception): Move up definition.
	  (exception-handler-for-foreign-threads): Use this as the default
	  handler, not the one that squirrels away exceptions in
	  thread->exception.
	  (thread-terminate!): Don't instate an exception handler for the thread
	  cleanup proc.

	srfi-18: Avoid call/cc.
	* module/srfi/srfi-18.scm (with-exception-handlers-here): New function.
	  (wrap): Remove.
	  (thread-join!, mutex-lock!): Use with-exception-handlers-here instead
	  of the call/cc+wrap mess.

2016-10-30  Andy Wingo  <wingo@pobox.com>

	srfi-18: Inline uses of srfi-18-exception-preserver.
	* module/srfi/srfi-18.scm (srfi-18-exception-preserver): Inline into
	  call sites.

	srfi-18: Use srfi-35 conditions.
	* module/srfi/srfi-18.scm: Use srfi-35 conditions instead of our
	  home-grown equivalent system.
	  (thread-exception-handlers): Remove unused table.
	  (srfi-18-exception-handler): Always capture key consed to args; no
	  special case for bare key.
	* test-suite/tests/srfi-18.test (provided?): Adapt to reason always
	  being key+args.

	srfi-18: Use parameters.
	* module/srfi/srfi-18.scm: Use srfi-34 internally with srfi-34: prefix.
	  (current-exception-handler): Be a parameter.
	  (with-exception-handler): Adapt to current-exception-handler change.
	  (thread-join!, mutex-lock!): Adapt to use srfi-34: prefix.

	srfi-18: Use lambda* optional arguments.
	* module/srfi/srfi-18.scm (make-mutex, make-condition-variable): Use
	  optional arguments.

	srfi-18: Simplify thread-sleep!, thread-terminate!.
	* module/srfi/srfi-18.scm (thread-sleep!): Use `when'.
	  (thread-terminate!): Simplify.

	srfi-18: Use `match' in thread-start!.
	* module/srfi/srfi-18.scm (thread-start!): Use `match'.

	srfi-18: Improve style.
	* module/srfi/srfi-18.scm (raise): Rely on SRFI-34 to #:replace raise.
	  (make-thread): Use lambda* and when.

	Fix srfi-34 indentation
	* module/srfi/srfi-34.scm (with-exception-handler): Fix indentation.

2016-10-27  Andy Wingo  <wingo@pobox.com>

	cancel-thread via asyncs, not pthread_cancel
	* module/ice-9/threads.scm (cancel-tag): New variable.
	  (cancel-thread): New Scheme function.
	  (call-with-new-thread): Install a prompt around the thread.
	* libguile/threads.h (scm_i_thread): Remove cancelled member.
	* libguile/threads.c (scm_cancel_thread): Call out to Scheme.  Always
	  available, and works on the current thread too.
	  (scm_set_thread_cleanup_x, scm_thread_cleanup): Adapt.
	  (scm_init_ice_9_threads): Capture cancel-thread var.
	* doc/ref/api-scheduling.texi (Threads): Update.
	* NEWS: Update.

2016-10-26  Andy Wingo  <wingo@pobox.com>

	Use atomics for async interrupts
	* libguile/__scm.h (SCM_TICK): Always define as scm_async_tick().
	* libguile/error.c (scm_syserror, scm_syserror_msg):
	* libguile/fports.c (fport_read, fport_write):
	* libguile/_scm.h (SCM_SYSCALL): Replace SCM_ASYNC_TICK with
	  scm_async_tick ().
	  (SCM_ASYNC_TICK, SCM_ASYNC_TICK_WITH_CODE)
	  (SCM_ASYNC_TICK_WITH_GUARD_CODE): Remove internal definitions.  We
	  inline into vm-engine.c, the only place where it matters.
	* libguile/async.h:
	* libguile/async.c (scm_async_tick, scm_i_setup_sleep):
	  (scm_i_reset_sleep, scm_system_async_mark_for_thread):
	* libguile/threads.h (struct scm_thread_wake_data):
	* libguile/threads.h (scm_i_thread):
	* libguile/threads.c (block_self, guilify_self_1, scm_std_select):
	  Rewrite to use sequentially-consistent atomic references.
	* libguile/atomics-internal.h (scm_atomic_set_pointer):
	  (scm_atomic_ref_pointer): New definitions.
	* libguile/finalizers.c (queue_finalizer_async): We can allocate, so
	  just use scm_system_async_mark_for_thread instead of the set-cdr!
	  shenanigans.
	* libguile/scmsigs.c (take_signal):
	* libguile/gc.c (queue_after_gc_hook): Adapt to new asyncs mechanism.
	  Can't allocate but we're just manipulating the current thread when no
	  other threads are running so we should be good.
	* libguile/vm-engine.c (VM_HANDLE_INTERRUPTS): Inline the async_tick
	  business.

	Move call-with-new-thread to Scheme
	* libguile/threads.c (scm_call_with_new_thread): Trampoline to Scheme.
	  (launch_data, really_launch, scm_sys_call_with_new_thread): Simplify.
	  (scm_init_ice_9_threads): Capture call-with-new-thread variable.
	* module/ice-9/threads.scm (call-with-new-thread): Add implementation in
	  Scheme.  Should allow for easier cancel-thread via prompt abort.

2016-10-25  Julian Graham  <joolean@undecidable.net>

	Fix tree-il code generation for ECMAscript `new' expression.
	The compiler was producing `((toplevel foo))' instead of `(toplevel foo)'.
	Changed to use `call' form with target type and spliced constructor
	arguments.

	* module/language/ecmascript/compile-tree-il.scm (comp): Replace `@impl'
	  shorthand with `call' + `@implv' for better control over resulting
	  tree-il.
	* test-suite/tests/ecmascript.test (compiler): Add test for "new Object();"

2016-10-23  Andy Wingo  <wingo@pobox.com>

	Move thread bindings to (ice-9 threads)
	* libguile/init.c (scm_i_init_guile): Don't call scm_init_thread_procs.
	* libguile/threads.c (scm_init_ice_9_threads): Rename from
	  scm_init_thread_procs, make static.
	  (scm_init_threads): Register scm_init_thread_procs extension.
	* libguile/threads.h (scm_init_thread_procs): Remove decl.
	* module/ice-9/boot-9.scm: Load (ice-9 threads), so that related side
	  effects occur early.
	* module/ice-9/deprecated.scm (define-deprecated): Fix to allow
	  deprecated bindings to appear in operator position.  Export deprecated
	  bindings.
	  (define-deprecated/threads, define-deprecated/threads*): Trampoline
	  thread bindings to (ice-9 threads).
	* module/ice-9/futures.scm: Use ice-9 threads.
	* module/ice-9/threads.scm: Load scm_init_ice_9_threads extension.
	  Reorder definitions and imports so that the module circularity
	  with (ice-9 futures) continues to work.
	* module/language/cps/intmap.scm:
	* module/language/cps/intset.scm:
	* module/language/tree-il/primitives.scm: Use (ice-9 threads).
	* module/language/cps/reify-primitives.scm: Reify current-thread
	  in (ice-9 threads) module.
	* module/srfi/srfi-18.scm: Use ice-9 threads with a module prefix, and
	  adapt all users.  Use proper keywords in module definition form.
	* test-suite/tests/filesys.test (test-suite):
	* test-suite/tests/fluids.test (test-suite):
	* test-suite/tests/srfi-18.test: Use ice-9 threads.
	* NEWS: Add entry.
	* doc/ref/api-scheduling.texi (Threads): Update.
	* doc/ref/posix.texi (Processes): Move current-processor-count and
	  total-processor-count docs to Threads.

	Deferred module observers via a parameter
	* module/ice-9/boot-9.scm (module-defer-observers): Instead of being a
	  global flag, change to be a parameter.
	  (module-defer-observers-mutex, module-defer-observers-table): Remove.
	  (module-modified): Adapt.
	  (call-with-deferred-observers): Adapt.  Allow nested called.

2016-10-19  Andy Wingo  <wingo@pobox.com>

	Adapt run-server* to change to `accept'.
	* module/system/repl/server.scm (run-server*): Adapt to new #f return
	  value of accept on non-blocking ports.
	  (errs-to-retry): Remove variable.

2016-10-18  Andy Wingo  <wingo@pobox.com>

	Small api-scheduling.texi reorder
	* doc/ref/api-scheduling.texi: Put "Threads" section at beginning of
	  scheduling chapter.

	Update "Asyncs" section of manual.
	* doc/ref/api-scheduling.texi (Asyncs): Update.

2016-10-17  Andy Wingo  <wingo@pobox.com>

	NEWS item for deprecated user asyncs
	* NEWS: Add news.

	Deprecate user asyncs
	* libguile/async.c:
	* libguile/async.h:
	* libguile/deprecated.c:
	* libguile/deprecated.h (scm_async, scm_async_mark, scm_run_asyncs):
	  Deprecate these functions, which comprise the "users asyncs" facility.
	* module/oop/goops.scm: Adapt to <async> deprecation.
	* doc/ref/api-scheduling.texi:
	* doc/ref/libguile-concepts.texi:
	* doc/ref/libguile-foreign-objects.texi:
	* doc/ref/posix.texi: Remove documentation on user asyncs, and replace
	  references to "system asyncs" to be just "asyncs".

	Deprecate arbiters
	* libguile/arbiters.c:
	* libguile/arbiters.h:
	* test-suite/tests/arbiters.test: Delete files.
	* libguile/deprecated.c:
	* libguile/deprecated.h: Move arbiters code here.
	* doc/ref/api-scheduling.texi: Remove section on arbiters.
	* libguile.h:
	* libguile/Makefile.am:
	* libguile/init.c:
	* module/oop/goops.scm:
	* test-suite/Makefile.am: Remove mention of arbiters.
	* NEWS: Update.

	Fold 2.1.4 news into 2.2 news
	* NEWS: Fold 2.1.4 news into main 2.2 news.

2016-10-11  Andy Wingo  <wingo@pobox.com>

	Fix slot allocation for prompts
	* module/language/cps/slot-allocation.scm
	  (add-prompt-control-flow-edges): Fix to add links from prompt bodies
	  to handlers, even in cases where the handler can reach the body but
	  the body can't reach the handler.
	* test-suite/tests/compiler.test ("prompt body slot allocation"): Add
	  test case.

	Texinfo serialization: add braces when needed
	* module/texinfo/serialize.scm (include, empty-command, inline-text):
	  (inline-args, inline-text-args, eol-text-args, eol-text, eol-args)
	  (environ, table-environ, paragraph, item, entry, fragment, serialize)
	  (stexi->texi): Pass extra rest? parameter around to indicate arguments
	  that can take any number of subforms without being surrounded by
	  braces.
	  (embrace, serialize-text-args): Surround non-rest arguments with
	  braces.
	* test-suite/tests/texinfo.serialize.test: Add tests.

	Remove .gnuploadrc.
	* .gnuploadrc: Remove file.

2016-09-14  Andy Wingo  <wingo@pobox.com>

	Fix compile warning in posix.c
	* libguile/posix.c (scm_system_star): Fix SIG_IGN usage to not emit a
	  warning.  Still broken on Windows64 and similar systems though!

	Bump version to 2.1.4
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump to 2.1.4.

	Update NEWS.
	* NEWS: Update.

	Avoid deprecated _IONBF in http tests
	* test-suite/tests/web-http.test ("chunked encoding"): Avoid deprecated
	  _IONBF.

	Avoid deprecated statprof interface in test
	* test-suite/tests/statprof.test ("return values"): Avoid deprecated
	  with-statprof.

2016-09-06  Andy Wingo  <wingo@pobox.com>

	Fix cross-compilation of negative fixnums
	* module/system/vm/assembler.scm (encoder): Use immediate-bits instead
	  of object-address, to fix cross-compilation.

2016-09-06  Andy Wingo  <wingo@pobox.com>

	Compiler support for atomics
	* doc/ref/vm.texi (Inlined Atomic Instructions): New section.
	* libguile/vm-engine.c (VM_VALIDATE_ATOMIC_BOX, make-atomic-box)
	  (atomic-box-ref, atomic-box-set!, atomic-box-swap!)
	  (atomic-box-compare-and-swap!): New instructions.
	* libguile/vm.c: Include atomic and atomics-internal.h.
	  (vm_error_not_a_atomic_box): New function.
	* module/ice-9/atomic.scm: Register primitives with the compiler.
	* module/language/cps/compile-bytecode.scm (compile-function): Add
	  support for atomic ops.
	* module/language/cps/effects-analysis.scm: Add comment about why no
	  effects analysis needed.
	* module/language/cps/reify-primitives.scm (primitive-module): Add case
	  for (ice-9 atomic).
	* module/language/tree-il/primitives.scm (*effect-free-primitives*):
	  (*effect+exception-free-primitives*): Add atomic-box?.
	* module/system/vm/assembler.scm: Add new instructions.

	* test-suite/tests/atomic.test: Test with compilation and
	  interpretation.

2016-09-06  Andy Wingo  <wingo@pobox.com>

	Fix fixnum min/max for assembler
	* module/system/vm/assembler.scm (immediate-bits): I am a complete and
	  total idiot and got the fixnum mins and maxes swapped.

	Add atomic boxes
	* doc/ref/api-scheduling.texi (Atomics): New manual section.
	* libguile.h: Include atomic.h.
	* libguile/Makefile.am (libguile_@GUILE_EFFECTIVE_VERSION@_la_SOURCES):
	  (DOT_X_FILES, DOT_DOC_FILES, modinclude_HEADERS): Add atomic.
	* libguile/atomic.c:
	* libguile/atomic.h: New files.
	* libguile/atomics-internal.h (scm_atomic_set_scm, scm_atomic_ref_scm)
	  (scm_atomic_swap_scm, scm_atomic_compare_and_swap_scm): New
	  facilities.
	* libguile/goops.c (class_atomic_box, scm_sys_goops_early_init): Add
	  support for <atomic-box>.  Remove duplicate <keyword> fetch.
	* libguile/init.c (scm_i_init_guile): Call scm_register_atomic_box.
	* libguile/print.c (iprin1): Add atomic box case.
	* libguile/tags.h (scm_tc7_atomic_box): New tag.
	* libguile/validate.h (SCM_VALIDATE_ATOMIC_BOX): New macro.
	* module/Makefile.am (SOURCES): Add ice-9/atomic.scm.
	* module/ice-9/atomic.scm: New file.
	* module/oop/goops.scm (<atomic-box>): New var.

	Reorder tc7 type codes
	* libguile/tags.h: Reorder type codes so that they are in numeric order
	  in the header file; no type code value is changed.

	Tweak value of tc7-smob.
	* libguile/tags.h (scm_tc7_smob):
	* module/system/base/types.scm (%tc7-smob): Tweak this value, just to
	  prove that it can be done.  Remove scary comment.

	Convert tc7 values to hex in tags.h and elsewhere
	* libguile/tags.h:
	* module/system/base/types.scm:
	* module/system/vm/assembler.scm: Convert tc7 values to hex.  No change
	  otherwise.

2016-09-05  Wilfred Hughes  <me@wilfred.me.uk>

	Clarify bootstrap docs
	* doc/ref/vm.texi: Add a sentence stating which parts of the bytecode
	  toolchain are in C, and which are in Scheme. This avoids confusion if
	  users assume Guile==Scheme and so assume the whole toolchain is in
	  Scheme.

2016-09-03  Robin Templeton  <robin@terpri.org>

	Check for missing debug info in print-program
	* module/system/vm/program.scm (print-program): Check the return value
	  of find-program-debug-info. Fixes #24320.

2016-09-02  Andy Wingo  <wingo@pobox.com>

	Fix typo in Nil documentation
	* doc/ref/api-languages.texi (Nil): Fix typo.  Thanks to Wilfred Hughes
	  for the report.  Fixes #24342.

	Better char<? compilation
	* module/language/tree-il/primitives.scm
	  (character-comparison-expander): Expand out char<? and friends to <,
	  unboxing the char arguments.
	* module/language/cps/types.scm:
	* module/language/cps/effects-analysis.scm: Remove mention of char<? and
	  friends as we won't see them any more.  Also fixes #24318.

	GOOPS caches created vtables
	* libguile/goops.c (scm_i_define_class_for_vtable): Cache created
	  vtables.  Fixes #24286.
	* test-suite/tests/goops.test ("classes for built-in types"): Add
	  tests.

2016-09-01  Andy Wingo  <wingo@pobox.com>

	Better unboxing
	* module/language/cps/specialize-numbers.scm (truncate-u64): New helper,
	  truncates a SCM value.
	  (specialize-u64-binop): Add ulogxor case.
	  (sigbits-union, sigbits-intersect, sigbits-intersect3)
	  (next-power-of-two, range->sigbits, inferred-sigbits)
	  (significant-bits-handlers, define-significant-bits-handler):
	  (significant-bits-handler, compute-significant-bits): Add facility to
	  compute the bits in a value that are significant.
	  (specialize-operations): Unbox in more cases, when only u64 bits are
	  significant.  Unbox logxor.  Elide logand where it has no effect.

	Fabricated expression tweak in CSE
	* module/language/cps/cse.scm (compute-equivalent-subexpressions):
	  u64->scm fabricates equivalence for scm->u64/truncate too.

	Add unboxed logxor on u64 values
	* libguile/vm-engine.c (ulogxor): New instruction.
	* module/language/cps/effects-analysis.scm (ulogxor):
	* module/language/cps/slot-allocation.scm (compute-var-representations):
	* module/language/cps/types.scm (ulogxor):
	* module/system/vm/assembler.scm (emit-ulogxor): Add support for new
	  instruction.
	* doc/ref/vm.texi (Unboxed Integer Arithmetic): Document ulogxor.

2016-08-31  Andy Wingo  <wingo@pobox.com>

	GC of non-blocking port does not block
	* libguile/ports.h (SCM_F_PORT_FINALIZING)
	  (SCM_PORT_FINALIZING_P, SCM_SET_PORT_FINALIZING): New private
	  definitions.
	* libguile/ports.c (finalize_port): Set the port-finalizing flag.
	  (scm_i_write_bytes): If the port is finalizing but output returned
	  EWOULDBLOCK, warn and discard the output.

	Only ptob->close() after read/write finish
	* libguile/Makefile.am (noinst_HEADERS): Add atomics-internal.h.
	* libguile/atomics-internal.h: New file.
	* libguile/ports-internal.h (refcount): New member.
	* libguile/ports.c (release_port, scm_dynwind_acquire_port): New
	  facility for acquiring a port within a dynwind.
	  (scm_port_poll, scm_i_read_bytes, scm_setvbuf, scm_end_input)
	  (scm_i_write_bytes, scm_char_ready_p, scm_seek)
	  (scm_truncate_file, trampoline_to_c_read)
	  (trampoline_to_c_write): Acquire port.
	  (scm_c_make_port_with_encoding): Init refcount to 1.
	  (scm_close_port): Release port.
	* doc/ref/api-io.texi (I/O Extensions): Add documentation

2016-08-31  Christopher Allan Webber  <cwebber@dustycloud.org>

	Fix example in make-custom-binary-input-port documentation
	* doc/ref/api-io.texi (Custom Ports): Add additional argument to example's
	  invocation of make-custom-binary-input-port.  Previously had mismatched arity
	  by missing "closed" argument.

2016-08-31  Andy Wingo  <wingo@pobox.com>

	Set rw_random correctly for all custom binary port types
	* libguile/r6rs-ports.c (custom_binary_port_random_access_p): Rename
	  from custom_binary_input_output_port_type, and use for all custom
	  binary port types.

	Avoid flushing buffers for ftell
	* libguile/ports.c (scm_seek): Avoid flushing buffers for an ftell.
	  Also allows non-random-access ports to ftell() if they have a seek
	  implementation, as is the case for custom binary ports with a
	  get-position function but no set-position function.
	* test-suite/tests/ports.test: Adapt expectations, reverting changes
	  made in April by me in b77fb752dd7e14876741ecb6360ef0319eae18e0.

	Require C99 to build Guile.
	* configure.ac: Require C99 or later.  Emacs does, therefore so can
	  we.  Note that by default GCC compiles in "gnu11" mode these days, and
	  this declaration doesn't change that.

2016-08-31  Christopher Allan Webber  <cwebber@dustycloud.org>

	Add tests for make-custom-binary-input/output-port
	* test-suite/tests/r6rs-ports.test ("8.2.13 Input/output ports"):
	  Add tests for custom binary input/output ports, copied from
	  existing binary input and binary output tests.

	Correct section number for "Input Ports" tests.
	* test-suite/tests/r6rs-ports.test: Correct "Input Ports" section heading
	  from "7.2.7" -> "8.2.7", "7.2.5" -> "8.2.5", "7.2.8" -> "8.2.8",
	  and "7.2.11" -> "8.2.11".

2016-08-31  Andy Wingo  <wingo@pobox.com>

	Move system* to posix.c, impl on open-process
	* libguile/simpos.c: Trim includes.
	  (scm_system_star): Move to posix.c.
	* libguile/simpos.h (scm_system_star): Remove.
	* libguile/posix.h (scm_system_star): Add.
	* libguile/posix.c (scm_system_star): Move here and implement in terms
	  of open-process.  This lets system* work on Windows.  Inspired by a
	  patch by Eli Zaretskii.
	  (start_child): Exit with 127 if the command isn't found.

2016-08-30  Andy Wingo  <wingo@pobox.com>

	Add file descriptor finalizers
	* doc/ref/posix.texi (Ports and File Descriptors): Document new
	  interfaces.
	* libguile/filesys.c (scm_close, scm_close_fdes)
	* libguile/fports.c (fport_close):
	* libguile/ioext.c (scm_primitive_move_to_fdes): Call
	  scm_run_fdes_finalizers.
	* module/ice-9/fdes-finalizers.scm:
	* test-suite/tests/fdes-finalizers.test:
	* libguile/fdes-finalizers.h:
	* libguile/fdes-finalizers.c: New files.
	* module/Makefile.am:
	* test-suite/Makefile.am:
	* libguile/Makefile.am:
	* libguile.h:
	* libguile/init.c: Wire up new files.

2016-08-28  Andy Wingo  <wingo@pobox.com>

	Remove duplicate documentation
	* doc/ref/posix.texi (Ports and File Descriptors): Remove duplicate
	  documentation for port-mode and setvbuf.

	Remove SCM_I_MAX_PORT_TYPE_COUNT
	* libguile/ports.h (SCM_I_MAX_PORT_TYPE_COUNT): Remove unused CPP
	  definition.

	ETag list headers accept sloppy etags
	* module/web/http.scm (parse-entity-tag): Add #:sloppy-delimiters
	  keyword argument, and return a second value indicating the end
	  position.
	  (parse-entity-tag-list): Use parse-entity-tag, so that we also accept
	  sloppy etags that aren't qstrings.
	* test-suite/tests/web-http.test ("request headers"): Add a test.

	Add prebuilt alias for x86_64-pc-linux-gnu
	* prebuilt/x86_64-pc-linux-gnu: Add as alias to
	  x86_64-unknown-linux-gnu.

2016-08-25  Andy Wingo  <wingo@pobox.com>

	Tweak to conversion strategy access
	* libguile/strings.c (scm_from_port_stringn, scm_to_port_stringn):
	  Access the conversion_strategy directly to make sure these functions
	  can run while the port is flushing on close.  Fixes web-http.test to
	  allow the closed flag to be atomically cleared on a port before
	  flushing.

	Fix exception when running ",help debug"
	* module/system/repl/command.scm (*command-table*): Remove entry for
	  ",procedure", a command removed a few months ago.

2016-08-08  sirgazil  <felipe.lopez@openmailbox.org>

	Fix typo about open-pipe
	* doc/ref/posix.texi (Pipes): Fix typo.

2016-08-08  James Clarke  <jrtc27@jrtc27.com>

	Recognize alpha as compilation target
	* module/system/base/target.scm (cpu-endianness): Add case for "alpha".
	(triplet-pointer-size): Likewise.

2016-08-08  sirgazil  <felipe.lopez@openmailbox.org>

	Fix typo about variable definitions
	* doc/ref/api-binding.texi (Top Level Variable Definitions): Fix typo.

2016-08-07  Ethan Stefan Day  <esday@ethan-stefan.net>

	Documentation fixes
	* doc/ref/api-compound.texi:
	* doc/ref/api-control.texi:
	* doc/ref/api-data.texi: Fix typos and clarify.

2016-08-07  David Kastrup  <dak@gnu.org>

	Let assv/assoc shortcircuit to assq where feasible
	* libguile/alist.c (scm_sloppy_assv, scm_sloppy_assoc):
	  (scm_assv, scm_assoc): Shortcircuit to scm_assq where feasible.

2016-08-07  Marek Vasut  <marex@denx.de>

	Recognize nios2 as compilation target
	Add support for the nios2 architecture.

2016-08-07  Andy Wingo  <wingo@pobox.com>

	Capture full path to GUILE_FOR_BUILD.
	* acinclude.m4: Capture full path to GUILE_FOR_BUILD.  Fixes #22342.

2016-08-07  Calvin Heim  <frofroggy@gmail.com>

	Fix grammar in api-compound.texi
	* doc/ref/api-compound.texi: Fix grammar.

2016-08-07  sirgazil  <felipe.lopez@openmailbox.org>

	Fix typo about pattern variables
	* doc/ref/sxml-match.texi (Matching XML Elements): Fix typo.

2016-08-07  Andy Wingo  <wingo@pobox.com>

	Manual recommends against SRFI-10
	* doc/ref/srfi-modules.texi (SRFI-10): Deprecate, or at least recommend
	  against.

2016-08-04  Andy Wingo  <wingo@pobox.com>

	Implement R6RS custom binary input/output ports
	* NEWS: Add new feature.
	* doc/ref/r6rs.texi (rnrs io ports):
	* doc/ref/api-io.texi (Custom Ports): Document new procedure.
	* libguile/r6rs-ports.h:
	* libguile/r6rs-ports.c (make_custom_binary_input_output_port)
	  (scm_make_custom_binary_input_output_port)
	  (custom_binary_input_output_port_random_access_p)
	  (initialize_custom_binary_input_output_ports)
	  (scm_init_r6rs_ports): Implement custom binary input/output ports.
	* module/rnrs/io/ports.scm (rnrs):
	* module/ice-9/binary-ports.scm (ice-9): Export
	  make-custom-binary-input/output-port.

	Fix compilation of `continue' in `while'.
	* module/language/cps/rotate-loops.scm (rotate-loops-in-function): Don't
	  attempt to rotate a loop whose header is a $prompt.  Fixes use of
	  `continue' in `while'.  Thanks to Nala Ginrut for the report :)

2016-07-25  Eli Zaretskii  <eliz@gnu.org>

	Avoid compilation warnings about alloca in read.c
	* libguile/read.c: Include alloca.h.

2016-07-25  Andy Wingo  <wingo@pobox.com>

	Fix --without-threads against threaded BDW-GC
	* libguile/gc.c (scm_storage_prehistory): Prevent BDW-GC from spawning
	  marker threads if Guile was built without threading support.

	Reimplement null-threads as inline functions
	* libguile/null-threads.h: Reimplement null-threads stubs for pthread
	  data types, initializers, and functions in terms of types and inline
	  functions instead of CPP macros.  Fixes unused-value warnings, and
	  tightens things up in general.
	  (scm_i_pthread_cleanup_push, scm_i_pthread_cleanup_pop): Remove these,
	  as they were unused and incorrect -- they would never run the cleanup
	  handler even if 1 was passed to pop.

	Use non-deprecated HAVE_STRUCT_TM_TM_ZONE
	* libguile/stime.c: Change uses of the deprecated HAVE_TM_ZONE to the
	  new HAVE_STRUCT_TM_TM_ZONE.

	Use gnulib for basename / dirname
	* libguile/filesys.c (scm_dirname, scm_basename): Rewrite to use
	  gnulib's dirname-lgpl.

	Gnulib: Add dirname-lgpl.
	* lib/Makefile.am:
	* m4/gnulib-cache.m4:
	* m4/gnulib-comp.m4: Add dirname-lgpl.

2016-07-25  Ludovic Courtès  <ludo@gnu.org>

	doc: Add unquote and unquote-splicing examples.
	Suggested by Vincent Legoll <vincent.legoll@gmail.com>.

	* doc/ref/api-evaluation.texi (Expression Syntax): Add an unquote and an
	unquote-splicing example.

2016-07-25  Eli Zaretskii  <eliz@gnu.org>

	Untabify posix-w32.c

	Improve process handling on MS-Windows
	* libguile/posix-w32.c: Include gc.h and threads.h.
	(proc_record): New structure tag.
	<procs, proc_size>: New static variables.
	(find_proc, proc_handle, record_proc, delete_proc): New utility
	functions.
	(start_child): Return value is now pid_t, as it is on Posix
	platforms.  Record the new process and returns its PID, instead of
	returning a handle.  Fix the recursive call.
	(waitpid, kill, getpriority, setpriority, sched_getaffinity)
	(sched_setaffinity): Look up the PID in the recorded subprocesses
	before trying to open a process that is not our subprocess.  Make
	sure any open handle is closed before returning, unless it's our
	subprocess.

2016-07-25  Andy Wingo  <wingo@pobox.com>

	Allow mkstemp! to have optional "mode" argument
	* m4/mkstemp.m4: Remove.
	* lib/mkstemp.c: Remove.
	* lib/mkostemp.c: New file.
	* m4/mkostemp.m4: New file.
	* lib/Makefile.am:
	* m4/gnulib-cache.m4:
	* m4/gnulib-comp.m4: Remove mkstemp module, replace with mkostemp.

	* libguile/fports.h:
	* libguile/fports.c (scm_i_mode_to_open_flags): Factor out helper to
	  parse mode string to open flags.
	  (scm_open_file_with_encoding): Use the new helper.
	* libguile/filesys.c:
	  (scm_i_mkstemp): Adapt to take optional second argument, being a mode
	  string.  Use mkostemp.
	  (scm_mkstemp): Backwards compatible shim that calls scm_i_mkstemp.

	* doc/ref/posix.texi:
	* NEWS: Update.

	* module/system/base/compile.scm (call-with-output-file/atomic): Pass
	  "wb" as mode, to cause O_BINARY to be added on MinGW.

2016-07-25  Ricardo Wurmus  <rekado@elephly.net>

	doc: Do not gender the programmer.
	* doc/ref/api-foreign.texi: Replace "his" with "their".
	* doc/ref/sxml.texi: Likewise.

2016-07-25  Eli Zaretskii  <eliz@gnu.org>

	Update uname implementation in posix-w32
	* libguile/posix-w32.c (uname): Update to modern processors (ia64 and
	  x86_64) and OS versions (Vista to Windows 10).  Delete trailing
	  whitespace.

2016-07-25  Andy Wingo  <wingo@pobox.com>

	Fix unused static variables in net_db.c
	* libguile/net_db.c (SCM_DEFINE_CONSTANT): New helper.  Use it to
	  define constants and avoid the unneeded static variables that were
	  used before, named "sym_" but actually holding variables.  Thanks to
	  Eli Zaretskii for the report.

	Fix MinGW build error
	* configure.ac: Fix for recent rename of win32-uname.c to posix-w32.c.

	Update NEWS
	* NEWS: Update.

	Add popen feature
	* doc/ref/api-options.texi (Common Feature Symbols): Document the popen
	  feature.
	* doc/ref/posix.texi (Pipes): Depend on the popen feature, not fork.
	* libguile/posix.c (scm_init_posix): Add popen feature if we can.

2016-07-25  Eli Zaretskii  <eliz@gnu.org>

	Add POSIX shims for MinGW
	* libguile/posix-w32.h:
	* libguile/posix-w32.c (kill, waitpid, getpriority, setpriority)
	  (sched_getaffinity, sched_setaffinity): Add MinGW implementations.
	  Also, provides macros that on Posix hosts are in sys/wait.h, like
	  WIFEXITED and WTERMSIG.
	  (start_child): Add implementation.

2016-07-25  Andy Wingo  <wingo@pobox.com>

	Rename win32-uname.[ch] to posix-w32.[ch]
	* libguile/posix-w32.c:
	* libguile/posix-w32.h: Rename from win32-uname.c and win32-uname.h.
	* libguile/posix.c:
	* libguile/Makefile.am
	  (EXTRA_libguile_@GUILE_EFFECTIVE_VERSION@_la_SOURCES)
	  (noinst_HEADERS): Adapt.

	Ignore meta/build-env
	* .gitignore: Ignore meta/build-env.

	Factor start_child out of open_process
	* libguile/posix.c (start_child): Factor out from open_process.  Based
	  on initial work by Eli Zaretskii.

	More specific status:exit-val et al compilation guards
	* libguile/posix.c (scm_status_exit_val, scm_status_term_sig)
	  (scm_status_stop_sig): Guard on WIFEXITED et al macros instead of on
	  MinGW.

	getaffinity, setaffinity docstring cleanup
	* libguile/posix.c (scm_getaffinity, scm_setaffinity): Clean up
	  docstrings.  Obviously if you have the function, you don't need to be
	  told that you have it in the docstring.

	Provide `kill' only if supported by the host
	* libguile/posix.c (scm_kill): Only provide if the host has `kill'.  An
	  incompatible change on MinGW, where this function would work only if
	  the PID was the current PID, but that will be fixed by the next
	  process.

	More robust setuid, setgid, etc detection
	* configure.ac: Check for getuid, getgid, setuid, and setgid.
	* libguile/posix.c (scm_getuid, scm_getgid, scm_setuid, scm_setgid):
	  Only provide Scheme functions if the OS provides these facilities.
	  (scm_geteuid, scm_getegid, scm_seteuid, scm_setegid): Provide if the
	  host has getuid, getgid, etc, instead of being in a MinGW guard.

2016-07-25  Ludovic Courtès  <ludo@gnu.org>

	Add missing 'const' qualifier.
	* libguile/stime.c (tzvar): Add 'const'.

	Unconditionally include <time.h> from Gnulib.
	* libguile/stime.c: Unconditionally include <time.h>.

	build: Remove unneeded check for 'unsetenv'.
	* configure.ac: Remove check for 'unsetenv', which is unneeded since we
	use Gnulib's 'unsetenv'.

2016-07-11  Andy Wingo  <wingo@pobox.com>

	build-env: prebuilt .go files are in srcdir
	* meta/build-env.in (GUILE_LOAD_COMPILED_PATH): Look for prebuilt files
	  in the srcdir, not the builddir.

2016-07-10  Andy Wingo  <wingo@pobox.com>

	Add meta/build-env
	* meta/build-env.in: New file which sets up an environment that does not
	  inherit GUILE_LOAD_PATH / GUILE_LOAD_COMPILED_PATH (unless
	  cross-compiling).
	* doc/ref/Makefile.am (autoconf-macros.texi):
	* libguile/Makefile.am (snarf2checkedtexi):
	* module/Makefile.am (ice-9/psyntax-pp.go):
	* test-suite/standalone/Makefile.am (GUILE_INSTALL_LOCALE):
	* am/bootstrap.am (.scm.go):
	* am/guilec (.scm.go): Use build-env.
	* configure.ac: Create build-env.

	Avoid Gnulib unistr/* modules
	(unistr/base, unistr/u8-mbtouc, unistr/u8-mbtouc-unsafe)
	(unistr/u8-mbtoucr, unistr/u8-prev unistr/u8-uctomb, unitypes): --avoid
	these modules.

2016-07-07  Andy Wingo  <wingo@pobox.com>

	Update Gnulib to 68b6ade.
	Also add --conditional-dependencies to the flags.  See:
	https://lists.gnu.org/archive/html/guile-devel/2016-07/msg00012.html

	Update git-version-gen.diff for current gnulib
	* gnulib-local/build-aux/git-version-gen.diff: Update.

2016-06-29  Andy Wingo  <wingo@pobox.com>

	Update NEWS
	* NEWS: Add 2.0.12 NEWS.  Fold 2.1.3 NEWS into main 2.2.0 NEWS.

2016-06-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	tests-suite: resurrect invoking check-guile --coverage.
	* test-suite/guile-test (main): remove (the-vm) from with-code-coverage call.

2016-06-27  Andy Wingo  <wingo@pobox.com>

	psyntax can trace expand-time changes to the current module
	* module/ice-9/psyntax.scm (expand-top-sequence): Support expand-time
	  changes to the current module.
	* module/ice-9/psyntax-pp.scm: Regenerate.

	Fix uninstalled-env bug that put prebuilt/ in front
	* meta/uninstalled-env.in (top_builddir): Fix bug whereby
	  meta/uninstalled-env run within meta-uninstalled-env, as happens
	  sometimes, would move the prebuilt dir to the front.

2016-06-27  David Pirotte  <david@altosw.be>

	Fixing GUILE_PROGS wrong versioning checks
	* meta/guile.m4: Fixing GUILE_PROGS versioning checks were wrong and
	  incomplete, leading to false errors like: "... checking for Guile
	  version >= 2.0.11... configure: error: Guile 2.0.11 required, but
	  2.1.3 found".

	  thanks to Colomban Wendling, aka b4n, who also suggested this fix
	  during a chat on #autotools while helping me wrt another autotool
	  related problem I was nvestigating.

2016-06-27  David Pirotte  <david@altosw.be>

	Do not track some test-suite files
	* .gitignore:  Adding test-smob-mark-race to the list of the test-suite
	  files we do not track.

2016-06-27  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	Fix 'monitor' macro.
	* module/ice-9/threads.scm (monitor-mutex-table)
	(monitor-mutex-table-mutex, monitor-mutex-with-id): New variables.
	(monitor): Fix it.

2016-06-25  Andy Wingo  <wingo@pobox.com>

	Add -Wmacro-use-before-definition
	* module/ice-9/boot-9.scm (%auto-compilation-options):
	* am/guilec (GUILE_WARNINGS): Add -Wmacro-use-before-definition.
	* module/language/tree-il/analyze.scm (unbound-variable-analysis): Use
	  match-lambda.
	  (<macro-use-info>, macro-use-before-definition-analysis): New
	  analysis.
	* module/system/base/message.scm (%warning-types): Add
	  macro-use-before-definition warning type.
	* module/language/tree-il/compile-cps.scm (%warning-passes): Add
	  support for macro-use-before-definition.

	Fix duplicate case in peval
	* module/language/tree-il/peval.scm (singly-valued-expression?): Fix
	  duplicate case.  Spotted by "mejja" on IRC.

	Add documentation pointer from getopt-long to SRFI-37.
	* doc/ref/mod-getopt-long.texi (getopt-long): Point to SRFI-37.

2016-06-24  Andy Wingo  <wingo@pobox.com>

	Favor "escape continuation" over "one-shot continuation" in manual
	* doc/ref/api-control.texi (Prompt Primitives): Remove mention of
	  one-shot continuations, as it's possible to invoke them multiple times
	  if the continuation is re-entered through other means.

2016-06-24  Andy Wingo  <wingo@pobox.com>

	Check for strtod_l before using it.
	Based on a patch by Andy Stormont <astormont@racktopsystems.com>.

	* configure.ac: Check for strtod_l.
	* libguile/i18n.c (scm_locale_string_to_integer): Fix style.
	  (scm_locale_string_to_inexact): Check for strtod_l.

2016-06-24  Andy Wingo  <wingo@pobox.com>

	Constant-folding eq? and eqv? uses deduplication
	* test-suite/tests/peval.test ("partial evaluation"): Add tests.
	* module/language/tree-il/peval.scm (peval): Constant-fold eq? and eqv?
	  using equal?, anticipating deduplication.

	Prevent (@ (ice-9 boot-9) x)
	* module/ice-9/boot-9.scm: Prevent re-loading, perhaps via (@ (ice-9
	  boot-9) foo).  (ice-9 boot-9) isn't a module.  Fixes #21801.

2016-06-24  Daniel Llorens  <daniel.llorens@bluewin.ch>

	On Darwin, skip tests that depend on setrlimit
	On Darwin, setrlimit is ignored, and these tests do not terminate. There
	doesn't seem to be another way to limit the memory allocated by a
	process.

	* test-suite/standalone/test-stack-overflow: Skip this test on Darwin.
	* test-suite/standalone/test-out-of-memory: Skip this test on Darwin.

2016-06-24  Andy Wingo  <wingo@pobox.com>

	Fix texinfo->html for @acronym, @itemize
	* module/texinfo/html.scm (itemize, acronym, tag-replacements, rules):
	  Fix HTML serialization of @itemize and @acronym.  Fixes #21772.
	* test-suite/tests/texinfo.html.test: New file.
	* test-suite/Makefile.am: Add new file.

	Parse bytecode to determine minimum arity
	* libguile/programs.c (try_parse_arity): New helper, to parse bytecode
	  to determine the minimum arity of a function in a cheaper way than
	  grovelling through the debug info.  Should speed up all thunk? checks
	  and similar.
	  (scm_i_program_arity): Simplify.
	* libguile/gsubr.h:
	* libguile/gsubr.c (scm_i_primitive_arity):
	* libguile/foreign.h:
	* libguile/foreign.c (scm_i_foreign_arity):

	Fix include-from-path when file found in relative path
	* module/ice-9/psyntax.scm (include-from-path): Canonicalize result of
	  %search-load-path.  Otherwise a relative path passed to `include'
	  would be treated as relative to the directory of the file that
	  contains the `include-from-path'.  Fixes #21347.
	* module/ice-9/psyntax-pp.scm: Regenerate.

2016-06-24  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Avoid stifling readline history when looking up options
	With this patch, history is never stifled unless (readline-set!) is used.

	* src/guile-readline/readline.c (scm_readline_options)

2016-06-24  Andy Wingo  <wingo@pobox.com>

	Fix typo about `keywords' read option
	* doc/ref/api-data.texi (Keyword Read Syntax): Fix typo.  Thanks to
	  Glenn Michaels for the report and fix.

	Fix ,profile in pure modules
	* libguile/scmsigs.c (close_1): Make the async closure in an environment
	  where `lambda' has its usual meaning.  Fixes #21013.

	Add with-input-from-port, etc documentation
	* doc/ref/api-io.texi (Default Ports): Add documentation for
	  with-input-from-port, with-output-to-port, and with-error-to-port.
	  Fixes #20919.

	Clarify use of the term "scanning" in the manual
	* doc/ref/api-memory.texi (Garbage Collection Functions):
	* doc/ref/libguile-concepts.texi (Garbage Collection): Attempt to be
	  clear that scanning is a thing that happens in the mark phase.  Fixes
	  #20907 I think.

	Locale is default port encoding
	* libguile/ports.c (scm_init_ports): Use the locale as the default
	  charset.  After the switch to default GUILE_INSTALL_LOCALE=1, this
	  harmonizes the default port encoding with the installed locale.

2016-06-23  Andy Wingo  <wingo@pobox.com>

	Add weak hash table documentation
	* doc/ref/api-memory.texi (Weak hash tables): Update documentation.
	  Fixes #20551.

	Fix R6RS fold-left documentation
	* doc/ref/r6rs.texi (rnrs lists): Fix documentation of fold-left.

	Static default for define-module #:duplicates
	* module/ice-9/boot-9.scm (define-module*): Leaving off #:duplicates
	  defaults to installing the duplicate binding handlers specified in the
	  manual, not the value of some other dynamic parameter.
	  (default-duplicate-binding-procedures):
	  (default-duplicate-binding-handler): Instead of closing over a
	  separate fluid, close over the handlers of the current module.  That
	  way when a user does (default-duplicate-binding-handler ...) in a
	  script, then it applies to the right module.

	Fix default-duplicate-binding-handlers for compilation
	* module/ice-9/boot-9.scm (define-module*): Capture value of
	  `default-duplicate-binding-procedures' when the module is created.
	  Fixes #20093.

	Don't serialize uninterned symbols
	* module/system/vm/assembler.scm (intern-constant): Don't serialize
	  uninterned symbols.
	* test-suite/tests/rtl.test ("bad constants"): Add a test.

	Fix memory leak in scm_from_{u,}int64 on 32-bit platforms
	* libguile/conv-integer.i.c (SCM_FROM_TYPE_PROTO):
	* libguile/conv-uinteger.i.c (SCM_FROM_TYPE_PROTO): Fix a big in which
	  scm_from_int64 and scm_from_uint64 on a 32-bit platform leaked memory
	  if they needed to allocate a bignum.  Fixes #20079.

2016-06-23  Daniel Llorens  <daniel.llorens@bluewin.ch>

	Remove unused doc/maint

2016-06-23  Andy Wingo  <wingo@pobox.com>

	Fix race between SMOB marking and finalization
	* libguile/smob.c (clear_smobnum): New helper.
	  (finalize_smob): Re-set the smobnum to the "finalized smob" type
	  before finalizing.  Fixes #19883.
	  (scm_smob_prehistory): Pre-register a "finalized smob" type, which has
	  no mark procedure.
	* test-suite/standalone/test-smob-mark-race.c: New file.
	* test-suite/standalone/Makefile.am: Arrange to build and run the new
	  test.

	Fix relative file name canonicalization on paths with "."
	* libguile/filesys.c (scm_i_relativize_path): Canonicalize the file
	  names elements that we will be using as prefixes.  Fixes the case
	  where a load path contains a relative file name: #19540.
	* test-suite/tests/ports.test ("%file-port-name-canonicalization"): Add
	  tests that elements of the load path are canonicalized.

2016-06-22  Andy Wingo  <wingo@pobox.com>

	Remove unused internal i18n functions
	* libguile/i18n.c (str_upcase, str_downcase, str_upcase_l)
	  (str_downcase_l): Remove unused inline functions.  Based on a patch by
	  Pedro Aguilar <paguilar@paguilar.org>.  Fixes #19172.

	Remove a stale variable use in libguile/Makefile.am
	* libguile/Makefile.am (BUILT_SOURCES): Remove a use of a variable that
	  doesn't exist in 2.2.

	Fix SCM_DEBUG_TYPING_STRICTNESS bug
	* libguile/ports.c (scm_setvbuf): Fix bad use of SCM as a test value.
	  Actually all ports have read buffers, so we can remove the condition
	  entirely.  Thanks Hydra for building in this way :)

2016-06-21  Andy Wingo  <wingo@pobox.com>

	Fix (< 'foo) compilation
	* module/language/tree-il/primitives.scm (expand-chained-comparisons):
	  Fix (< 'foo) compilation.
	* test-suite/tests/compiler.test ("regression tests"): Add test case.

	Fix srfi-64.test for #:select borkage.  The irony...
	* test-suite/tests/srfi-64.test: Fix for recent #:select borkage.

	`define!' instruction returns the variable
	* doc/ref/vm.texi (Top-Level Environment Instructions): Update
	  documentation.
	* libguile/_scm.h (SCM_OBJCODE_MINOR_VERSION): Bump, sadly.
	* module/system/vm/assembler.scm (*bytecode-minor-version*): Bump.
	* libguile/vm-engine.c (define!): Change to store variable in dst slot.
	* module/language/tree-il/compile-cps.scm (convert):
	* module/language/cps/compile-bytecode.scm (compile-function): Adapt to
	  define! change.
	* module/language/cps/effects-analysis.scm (current-module): Fix define!
	  effects.  Incidentally here was the bug: in Guile 2.2 you can't have
	  effects on different object kinds in one instruction, without
	  reverting to &unknown-memory-kinds.
	* test-suite/tests/compiler.test ("regression tests"): Add a test.

	Use source file permissions for compiled files
	* module/system/base/compile.scm (call-with-output-file/atomic): Use the
	  permissions of the source file, if available, as the permissions of
	  the compiled file.  Fixes #18477.

	Document pretty-print #:max-expr-width
	* doc/ref/misc-modules.texi (Pretty Printing): Document #:max-expr-width
	  keyword argument.  Fixes #17657.

	Importing modules with #:select no longer grovels private bindings
	* module/ice-9/boot-9.scm (resolve-interface): Don't look in private
	  interface for #:select bindings.  Fixes #17418.
	* module/system/repl/coop-server.scm: Don't rely on bad #:select
	  behavior.
	* NEWS: Add entry.

	Detect too-old libunistring at configure-time.
	* configure.ac: Detect too-old libunistring at configure-time.  Fixes
	  #17399.

	Update and-let-star.test
	* test-suite/tests/and-let-star.test ("and-let*"): Update test
	  expectations.

2016-06-21  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	Add SRFI-2 (and-let*) test suite.
	* test-suite/tests/srfi-2.test: New file.
	* test-suite/Makefile.am (SCM_TESTS): Add it.

	Fix SRFI-2 (and-let*) implementation.
	* module/ice-9/and-let-star.scm (%and-let*): Re-implemented this in a
	  more verbose but accurate way.

2016-06-21  Andy Wingo  <wingo@pobox.com>

	Add R6RS bytevector->string, string->bytevector
	* module/rnrs/io/ports.scm (string->bytevector):
	  (bytevector->string): New procedures.
	* module/rnrs.scm: Export new procedures.
	* test-suite/tests/r6rs-ports.test: Add string->bytevector and
	  bytevector->string tests.

	Export &i/o-decoding, &i/o-encoding from (rnrs)
	* module/rnrs/io/ports.scm (&i/o-decoding, &i/o-encoding): Rename from
	  &i/o-decoding-error and &i/o-encoding-error, to conform to R6RS.
	* module/rnrs.scm (rnrs): Export &i/o-decoding, &i/o-encoding, their
	  accessors and constructors.

	Implement R6RS output-port-buffer-mode
	* module/rnrs/io/ports.scm (r6rs-open): Set buffer-mode on new port.
	  (output-port-buffer-mode): Implement and export.
	* module/rnrs.scm (rnrs): Export output-port-buffer-mode
	* test-suite/tests/r6rs-ports.test (test-output-file-opener): Add
	  tests.

2016-06-21  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	(rnrs hashtables): Hash functions of eq? and eqv? hashtables
	Also pinging this thread with a (very slightly) updated patch. :-)

	[2. text/x-diff; 0001-Hashtable-hash-function-returns-f-on-eq-and-eqv-tabl.patch]

	From 17599f6ce7ba0beb100e80455ff99af07333d871 Mon Sep 17 00:00:00 2001
	From: =?UTF-8?q?Taylan=20Ulrich=20Bay=C4=B1rl=C4=B1/Kammer?=
	 <taylanbayirli@gmail.com>
	Date: Tue, 21 Jun 2016 00:23:29 +0200
	Subject: [PATCH] Hashtable-hash-function returns #f on eq and eqv tables.

	* module/rnrs/hashtables.scm (r6rs:hashtable)[type]: New field.
	(r6rs:hashtable-type): New procedure.
	* test-suite/tests/r6rs-hashtables.test: Add related tests.

2016-06-21  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	(rnrs hashtables): Mutation of immutable hashtable ignored
	Pinging this thread with a (very slightly) updated patch. :-)

	[2. text/x-diff; 0001-Hashtable-set-errors-on-immutable-hashtable.patch]

	From 7f35d515d711e255bba5a89a013d9d92034edf41 Mon Sep 17 00:00:00 2001
	From: =?UTF-8?q?Taylan=20Ulrich=20Bay=C4=B1rl=C4=B1/Kammer?=
	 <taylanbayirli@gmail.com>
	Date: Tue, 21 Jun 2016 00:25:19 +0200
	Subject: [PATCH] Hashtable-set! errors on immutable hashtable.

	* module/rnrs/hashtables.scm (hashtable-set!): Raise an assertion
	  violation error when the hashtable is immutable.
	* test-suite/tests/r6rs-hashtables.test: Fix accordingly.

2016-06-21  Andy Wingo  <wingo@pobox.com>

	Fix fixnum-range changes in R6RS fixnum bitops
	* module/rnrs/arithmetic/fixnums.scm (fxcopy-bit, fxbit-field)
	  (fxcopy-bit-field, fxarithmetic-shift)
	  (fxarithmetic-shift-left, fx-arithmetic-shift-right)
	  (fxrotate-bit-field, fxreverse-bit-field): Enforce range on amount by
	  which to shift.  Fixes #14917.
	* test-suite/tests/r6rs-arithmetic-fixnums.test ("fxarithmetic-shift-left"):
	  Update test to not shift left by a negative amount.

	Add another code coverage test
	* test-suite/tests/coverage.test ("line-execution-counts"): Add a test
	  from Taylan Ulrich B, from bug #14849.

	Document sigaction + SA_RESTART
	* doc/ref/posix.texi (Signals): Document interaction between Guile's
	  signal handling and SA_RESTART.  Fixes #14640.

2016-06-20  Andy Wingo  <wingo@pobox.com>

	Fix peval on (call-with-values foo (lambda (x) x))
	* module/language/tree-il/peval.scm (peval): Don't
	  inline (call-with-values foo (lambda (x) exp)) to (let ((x (foo)))
	  exp).  The idea is that call-with-values sets up an explicit context
	  in which we are requesting an explicit return arity, and that dropping
	  extra values when there's not a rest argument is the wrong thing.
	  Fixes #13966.
	* test-suite/tests/peval.test ("partial evaluation"): Update test.

	Document char-ready? limitations.
	* doc/ref/api-io.texi (Venerable Port Interfaces): Document limitations
	  of char-ready?.  See http://debbugs.gnu.org/10627.

2016-06-20  Andy Wingo  <wingo@pobox.com>

	Fix size measurement in bytevector_large_set
	* libguile/bytevectors.c (bytevector_large_set): Fix computation of
	  value size in words.
	* test-suite/tests/bytevectors.test: Add test.

	Thanks to Ben Rocer <fleabyte@mail.com> for the bug report and fix.

2016-06-20  Andy Wingo  <wingo@pobox.com>

	Fix uri-decode behavior for "+"
	* module/web/uri.scm (uri-decode): Add #:decode-plus-to-space? keyword
	  argument.
	  (split-and-decode-uri-path): Don't decode plus to space.
	* doc/ref/web.texi (URIs): Update documentation.
	* test-suite/tests/web-uri.test ("decode"): Add tests.
	* NEWS: Add entry.

	Based on a patch by Brent <brent@tomski.co.za>.

2016-06-19  Diogo F. S. Ramos  <dfsr@riseup.net>

	Add reference to the lack of "non-greedy" variants
	While describing special characters, remind the reader that
	"non-greedy" variants are not supported.  They might not be familiar
	with POSIX extended regular expression and expect it to work.

	* doc/ref/api-regex.texi: Add "non-greedy" observation

2016-06-19  Diogo F. S. Ramos  <dfsr@riseup.net>

	Remove link to Emacs' regexp syntax
	Linking to Emacs' regexps as an example of regexp syntax gives the
	wrong impression that Guile supports it, which is not true.

	* doc/ref/api-regex.texi: Remove link to Emacs' regexp syntax

2016-06-18  Andy Wingo  <wingo@pobox.com>

	Bump version to 2.1.3
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump to 2.1.3.

	Minor NEWS updates
	* NEWS: Minor updates.

	Fix ports bug when size_t is 32 bits
	* libguile/ports.c (scm_end_input): I am a complete idiot.  I had no
	  idea that `- (uint32_t) x' is actually still a uint32_t.

2016-06-17  Andy Wingo  <wingo@pobox.com>

	Fix 64->32 bit cross-compilation of large-ish fixnums
	* module/system/vm/assembler.scm (immediate-bits): Fix a bug whereby
	  compiling to a 32-bit target from a 64-bit host would treat all
	  integers whose representation fit into 32 bits as immediates.  This
	  would result in integer constants between #x20000000 and 0x3fffffff
	  being residualized in such a way that they would be loaded as negative
	  numbers.

2016-06-12  Andy Wingo  <wingo@pobox.com>

	Skip incompatible .go files
	* libguile/load.c (load_thunk_from_path, try_load_thunk_from_file): New
	  functions.
	  (search_path): Simplify.
	  (scm_primitive_load_path, scm_init_eval_in_scheme): Use the new
	  functions to load compiled files.
	* module/ice-9/boot-9.scm (load-in-vicinity): Skip invalid .go files.

	Inspired by a patch from Jan Nieuwenhuizen <janneke@gnu.org>.

2016-06-11  Andy Wingo  <wingo@pobox.com>

	Remove unused static definitions
	* libguile/expand.c:
	* libguile/vm.c: Remove unused static definitions.

	Fix shuffling of unboxed stack elements on 32-bit systems
	* libguile/vm-engine.c (SP_REF_SLOT, SP_SET_SLOT): New defines.
	  (push, pop, mov, long-mov): Move full slots.  Fixes 32-bit with
	  unboxed 64-bit stack values; before when shuffling these values
	  around, we were only shuffling the lower 32 bits on 32-bit platforms.

	VM type checking refactor
	* libguile/vm-engine.c (VM_VALIDATE): Refactor some type-related
	  assertions to use a common macro.
	  (vector-length, vector-set!/immediate): Fix the proc mentioned in the
	  error message.

	vm: Make sure IP is stored before potentially GCing.
	* libguile/vm-engine.c: Add a number of SYNC_IP calls that were missing
	  before calls that could GC.

2016-06-10  Andy Wingo  <wingo@pobox.com>

	Fix bad backtraces
	* libguile/vm-engine.c (BV_REF, BV_BOUNDED_SET, BV_SET, integer->char)
	  (char->integer): Use VM_ASSERT so that we save the IP before erroring
	  out.

	Minor VM fixes
	* libguile/vm-engine.c (string-ref): Unpack the index into a 64-bit
	  integer.
	  (br-if-u64-<-scm): Tighten up the fast path.

	Type inference: Use &u64-max instead of #xffff...
	* module/language/cps/types.scm: Use &u64-max where possible.

	Types refactor for unboxed char ranges
	* module/language/cps/types.scm (*max-codepoint*): Factor codepoint
	  range restrictions to use this value.

2016-06-09  Andy Wingo  <wingo@pobox.com>

	Non-blocking accept/connect Scheme support
	* module/ice-9/sports.scm (accept, connect): New Scheme functions.

	Support `connect' on nonblocking sockets
	* libguile/socket.c (scm_connect):
	* doc/ref/posix.texi (Network Sockets and Communication): Support
	  connect on nonblocking ports.

	`accept' on nonblocking socket can return #f
	* doc/ref/posix.texi (Network Sockets and Communication):
	* libguile/socket.c (scm_accept): Return #f if the socket is nonblocking
	  and no connection is ready.

	put-char in Scheme
	* libguile/ports.c (scm_port_encode_char): New function.
	* module/ice-9/ports.scm (port-encode-char): Export port-encode-char to
	  the internals module.
	* module/ice-9/sports.scm (put-char): New function.
	  (port-bindings): Add put-char and put-string.

	Update port documentation, rename sports to suspendable ports
	* module/ice-9/suspendable-ports.scm: Rename from ice-9/sports.scm, and
	  adapt module names.  Remove exports that are not related to the
	  suspendable ports facility; we want people to continue using the port
	  operations from their original locations.  Add put-string to the
	  replacement list.
	* module/Makefile.am: Adapt to rename.
	* test-suite/tests/suspendable-ports.test: Rename from sports.test.
	* test-suite/Makefile.am: Adapt to rename.
	* module/ice-9/textual-ports.scm (unget-char, unget-string): New
	  functions.
	* doc/ref/api-io.texi (Textual I/O, Simple Output): Flesh out
	  documentation.
	  (Line/Delimited): Undocument write-line, read-string, and
	  read-string!.  This is handled by (ice-9 textual-ports).
	  (Bytevector Ports): Fix duplicated section.
	  (String Ports): Move the note about encodings down to the end.
	  (Custom Ports): Add explanatory text.  Remove mention of C functions;
	  they should use the C port interface.
	  (Venerable Port Interfaces): Add text, and make documentation refer to
	  recommended interfaces.
	  (Using Ports from C): Add documentation.
	  (Non-Blocking I/O): Document more fully and adapt to suspendable-ports
	  name change.

2016-06-08  Andy Wingo  <wingo@pobox.com>

	Big ports documentation update
	* doc/ref/api-io.texi: Update to document ports more thoroughly.  Still
	  some work needed.

	* doc/ref/r6rs.texi: Move ports documentation back to r6rs.texi, now
	  that Guile has a more thorough binary/textual I/O story, heavily based
	  on R6RS.

	* doc/ref/api-control.texi:
	* doc/ref/api-data.texi:
	* doc/ref/api-options.texi:
	* doc/ref/misc-modules.texi:
	* doc/ref/posix.texi:
	* doc/ref/srfi-modules.texi: Update references.

2016-06-08  Andy Wingo  <wingo@pobox.com>

	Undocument (ice-9 rw)
	* doc/ref/api-io.texi (Block Reading and Writing): Undocument (ice-9
	  rw).  The R6RS routines do the same job and are not so clunky.

	Add (ice-9 textual-ports)
	* module/ice-9/textual-ports.scm: New module.
	* module/Makefile.am: Add new module.

	put-char, put-string in (ice-9 ports internals)
	* libguile/ports.h (scm_put_char):
	* libguile/ports.c (scm_put_char): New function.
	  (scm_put_string): Add docstrings, and expose to the internal ports
	  module.
	* module/ice-9/ports.scm (put-char, put-string): Expose these bindings
	  only through the internals module.

2016-06-04  Andy Wingo  <wingo@pobox.com>

	socket: TCP_CORK, TCP_NODELAY
	* libguile/socket.c (scm_init_socket): Define TCP_NODELAY and TCP_CORK
	  if they are available.
	* doc/ref/posix.texi (Network Sockets and Communication): Add
	  documentation.
	* NEWS: Add entry.

2016-06-01  Andy Wingo  <wingo@pobox.com>

	put-string in Scheme
	* module/ice-9/ports.scm: Export port-encode-chars and
	  port-clear-stream-start-for-bom-write via the internals module.
	* module/ice-9/sports.scm (put-string): New function.

	Rework text encoding to be more Scheme-friendly
	* libguile/ports.c (scm_port_clear_stream_start_for_bom_write): Instead
	  of returning the BOM, take an optional buffer in which to write the
	  BOM.  Return number of bytes written.
	  (port_clear_stream_start_for_bom_write): Remove.
	  (scm_i_write): Adapt scm_port_clear_stream_start_for_bom_write call.
	  (try_encode_char_to_iconv_buf, encode_latin1_chars_to_latin1_buf):
	  (encode_latin1_chars_to_utf8_buf, encode_latin1_chars_to_iconv_buf):
	  (encode_latin1_chars, encode_utf32_chars_to_latin1_buf):
	  (encode_utf32_chars_to_utf8_buf, encode_utf32_chars_to_iconv_buf):
	  (encode_utf32_chars, port_encode_chars): New helpers.
	  (scm_port_encode_chars): New procedure.
	  (scm_c_put_latin1_chars, scm_c_put_utf32_chars): Rework to use new
	  encoding helpers.
	  (scm_lfwrite): Use scm_c_put_latin1_chars.

2016-05-30  Andy Wingo  <wingo@pobox.com>

	Simplify string, symbol, char display/write impls
	* libguile/print.h:
	* libguile/print.c: Use the new routines from ports.[ch].

	Add scm_c_put_escaped_char, scm_c_can_put_char
	* libguile/ports.h:
	* libguile/ports.c (scm_c_put_escaped_char, scm_c_can_put_char): New
	  helpers.

	iprin1 uses scm_c_put_string
	* libguile/print.c (iprin1): Use scm_c_put_string for strings.
	* test-suite/test-suite/lib.scm (exception:encoding-error): Add an
	  additional expected error string for `encoding-error'.

	print_normal_symbol uses new port functions
	* libguile/print.c (print_normal_symbol): Use new port functions.

	Beginnings of supporting encoding text in ports.c
	* libguile/ports.h (scm_c_put_latin1_chars, scm_c_put_utf32_chars)
	  (scm_c_put_char, scm_c_put_string, scm_print_string): New public
	  functions.  The plan is to move encoding to ports.c and out of
	  print.c.
	* libguile/ports.c (UTF8_BUFFER_SIZE, ESCAPE_BUFFER_SIZE): New internal
	  defines.
	  (update_port_position): Take a position instead of a port.  Update
	  callers.
	  (utf8_to_codepoint): Allow lengths that are larger than necessary.
	  (port_clear_stream_start_for_bom_write): Require that io_mode be
	  BOM_IO_TEXT to write a BOM.
	  (scm_fill_input): Add a related comment about BOM handling.
	  (scm_i_write): use BOM_IO_TEXT, at least for now.
	  (encode_escape_sequence, codepoint_to_utf8, utf8_to_codepoint)
	  (put_utf8_chars_to_iconv_port, put_latin1_chars_to_utf8_port)
	  (put_latin1_chars_to_iconv_port, put_utf32_chars_to_latin1_port)
	  (put_utf32_chars_to_utf8_port, put_utf32_chars_to_iconv_port): New
	  helpers.
	  (scm_putc, scm_puts): Use scm_c_put_char and scm_put_latin1_chars.

2016-05-25  Andy Wingo  <wingo@pobox.com>

	Add port-line-buffered?
	* libguile/ports.c (scm_port_line_buffered_p): New function.
	* module/ice-9/ports.scm: Plump port-line-buffered? and
	  port-auxiliary-write-buffer through to the internals module

	port_clear_stream_start_for_bom_write refactor
	* libguile/ports.c (port_clear_stream_start_for_bom_write): Rework to be
	  friendly to Scheme write implementations.

2016-05-24  Andy Wingo  <wingo@pobox.com>

	Speed up scm_c_write / scm_lfwrite
	* libguile/ports-internal.h (scm_t_port): Add write_buf_aux field.
	* libguile/ports.h (scm_port_auxiliary_write_buffer): New internal
	  decl.
	* libguile/ports.c (AUXILIARY_WRITE_BUFFER_SIZE): New constant.
	  (initialize_port_buffers): Init aux write buf.
	  (scm_port_auxiliary_write_buffer): Lazily allocate an aux write
	  buffer.
	  (scm_c_write): Arrange to write through an aux buffer if the port is
	  unbuffered.

	Speed golf on Scheme put-u8, put-bytevector
	* module/ice-9/sports.scm (put-u8, put-bytevector): Speed hack.

	Add put-u8 implementation in Scheme
	* module/ice-9/sports.scm (put-u8): Add implementation.
	  (port-bindings): Add put-u8.

	`put-bytevector' in Scheme
	* module/ice-9/sports.scm (flush-input): New helper.
	  (put-bytevector): New function.
	  (port-bindings): Add put-bytevector.

	Wire up non-blocking support in sport writes
	* module/ice-9/sports.scm (write-bytes): Support non-blocking writes.
	  (force-output, flush-output): Rearrange placement.

	close-port implementation in sports
	* module/ice-9/sports.scm (close-port): New function.
	  (port-bindings): Add close-port.

	Add force-output to sports
	* module/ice-9/sports.scm (force-output): New implementation.
	  (port-bindings): Add force-output.

2016-05-23  Andy Wingo  <wingo@pobox.com>

	Thread-safety fixes for iconv and ports
	* libguile/ports-internal.h (scm_t_port): Rework to store iconv
	  descriptors inline, so that the port finalizer doesn't race with the
	  iconv descriptor finalizer.  Access is serialized through a lock.
	  Fixes a bug whereby if the port finalizer and the descriptor finalizer
	  run on different threads, the close-port run by the port finalizer
	  could try to free the iconv descriptors at the same time as the
	  descriptor finalizer.
	* libguile/ports.c (iconv_lock): New static variable.
	  (scm_c_make_port_with_encoding): Initialize iconv-related fields.
	  (scm_close_port): Lock while frobbing iconv descriptors.
	  (prepare_iconv_descriptors): Adapt.
	  (scm_specialize_port_encoding_x, scm_i_set_port_encoding_x): Lock
	  while preparing iconv descriptors.
	  (scm_port_acquire_iconv_descriptors)
	  (scm_port_release_iconv_descriptors): New functions, which replace
	  scm_i_port_iconv_descriptors.
	  (scm_port_decode_char): Lock around iconv operations.
	  (port_clear_stream_start_for_bom_write): Acquire iconv descriptors
	  before checking precise_encoding, to make sure precise_encoding is
	  initialized.
	* libguile/print.c (display_string_using_iconv): Adapt to use the new
	  interface to get iconv descriptors from a port.

2016-05-22  Andy Wingo  <wingo@pobox.com>

	get-bytevector-n in Scheme.
	* module/ice-9/sports.scm (fill-input): Add io-mode optional arg.
	  (get-bytevector-n): New implementation.
	  (port-bindings): Add get-bytevector-n.
	* test-suite/tests/sports.test: Add r6rs-ports tests.

	Fix range checking in new Scheme-to-C port code
	* libguile/ports.c (trampoline_to_c_read, trampoline_to_c_write): Fix
	  bugs checking ranges of start and count parameters.

2016-05-22  Andy Wingo  <wingo@pobox.com>

	More thorough ice-9 sports testing
	* module/ice-9/sports.scm: Export read-line, %read-line, and
	  read-delimited.  Add these latest three to install-sports!, and fix
	  install-sports! if the current module isn't (ice-9 sports).

	* test-suite/tests/sports.test: Use install-sports! instead of lexical
	  bindings, to allow us to nicely frob bindings in rdelim.  Include
	  rdelim tests.

2016-05-22  Andy Wingo  <wingo@pobox.com>

	Merge from stable-2.0
	This cherry-picks changes from stable-2.0, starting from
	acd2c8e36a25d77e9e9c9b6782780b23a1764973 and ending in
	461b62efc90135d3ca8719ba0f3b6ced4ad13754, inclusively.  I did not
	cherry-pick patches that were already on master and did not cherry-pick
	ones that don't make sense on master (for example because of the port
	re-write).  I did pick all tests though.

	I also did not cherry-pick the "Revert foreign objects" patch from
	ff98cbb643d43c9f8c6ee0e0b4e1bad72aced62e; further discussion necessary.

2016-05-22  Luribert  <luribert331@zoho.com>

	doc: Fix typo in Web documentation.
	* doc/ref/web.texi (Http Headers): Fixed typo.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	http: Accept date strings with a leading space for hours.
	Fixes <http://bugs.gnu.org/23421>.
	Reported by Ricardo Wurmus <ricardo.wurmus@mdc-berlin.de>.

	* module/web/http.scm (parse-rfc-822-date): Add two clauses for hours
	with a leading space.
	* test-suite/tests/web-http.test ("general headers"): Add two tests.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Bump user-visible copyright years to 2016.
	* doc/ref/guile.texi: Add 2016 to user-visible copyright notice.
	* module/ice-9/command-line.scm (version-etc): Bump 'copyright-year' to
	  2016.
	* module/system/repl/common.scm (*version*): Add 2016 to the range of
	  copyright years.

	SRFI-19: Update the table of leap seconds.
	* module/srfi/srfi-19.scm (leap-second-table): Update to include the
	  most recent leap second.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	http: Use 'read-header-line' instead of 'read-line*'.
	* module/web/http.scm (read-line*): Remove.
	(read-continuation-line, read-header, read-request-line): Use
	'read-header-line' instead of 'read-line*'.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	http: Accept empty reason phrases.
	Fixes <http://bugs.gnu.org/22273>.
	Reported by Ricardo Wurmus <ricardo.wurmus@mdc-berlin.de>.

	* module/web/http.scm (read-header-line): New procedure.
	(read-response-line): Use it instead of 'read-line*'.
	* test-suite/tests/web-http.test ("read-response-line"): Add test.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	http: Test that responses lacking CR/LF are rejected.
	* test-suite/tests/web-http.test ("read-response-line")["missing
	CR/LF"]: New test.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Bump user-visible copyright years to 2015.
	* module/ice-9/command-line.scm (version-etc): Bump 'copyright-year' to
	  2015.

	* module/system/repl/common.scm (*version*): Add 2015 to the range of
	  copyright years.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Fix getsockopt/setsockopt handling of SO_SNDBUF/SO_RCVBUF options.
	Reported by Park SungMin <byulparan_eng@icloud.com>
	in <https://lists.gnu.org/archive/html/guile-user/2015-11/msg00026.html>.

	* libguile/socket.c (scm_getsockopt, scm_setsockopt): Remove code that
	  incorrectly assumed that the argument for SO_SNDBUF and SO_RCVBUF
	  options was of type 'size_t'.  Both the Linux and POSIX documentation
	  indicates that the argument is of type 'int', as is the case for most
	  options.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	Regenerate SRFI-14 character set data.
	Suggested by Mike Gran <spk121@yahoo.com>.

	* libguile/srfi-14.i.c: Regenerate for Unicode 8.0.0,
	  <ftp://unicode.org/Public/UNIDATA/UnicodeData.txt> with SHA256
	  38b17e1118206489a7e0ab5d29d7932212d38838df7d3ec025ecb58e8798ec20.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	build: Add SCM_T_OFF_MAX and SCM_T_OFF_MIN to scmconfig.h.
	* libguile/gen-scmconfig.c (main): Add SCM_T_OFF_MAX and SCM_T_OFF_MIN
	  to the generated 'scmconfig.h' file.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	doc: Mention a known-good Flex version number.
	Suggested by Jamil Egdemir <unclejamil@gmail.com>.

	* HACKING: Mention a Flex version number.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	Thank David and Kouhei.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	build: Remove libguile/mkstemp.c, redundant with Gnulib.
	Fixes <http://bugs.gnu.org/21425>.
	Reported by Kouhei Sutou <kou@cozmixng.org>.

	* configure.ac: Remove 'AC_REPLACE_FUNCS' for 'mkstemp'.
	* libguile/Makefile.am (EXTRA_libguile_@GUILE_EFFECTIVE_VERSION@_la_SOURCES):
	  Remove mkstemp.c.
	* libguile/mkstemp.c: Remove.

2016-05-22  David Michael  <fedora.dm0@gmail.com>

	Remove SIGEV constant definitions.
	* libguile/Makefile.am (chknew-E chknew-SIG): Anchor the end of the
	  signal/error name pattern to only match alphanumeric symbols.
	* libguile/cpp-SIG.syms (SIGEV_MAX_SIZE, SIGEV_NONE): Remove.
	  (SIGEV_PAD_SIZE, SIGEV_SIGNAL, SIGEV_THREAD): Likewise.
	  (SIGEV_THREAD_ID): Likewise.

	Add Hurd signal and error constants.
	* libguile/cpp-E.syms (EAUTH, EBACKGROUND): New definitions.
	  (EBADRPC, ED, EDIED, EFTYPE, EGRATUITOUS, EGREGIOUS): Likewise.
	  (EIEIO, ENEEDAUTH, EPROCLIM, EPROCUNAVAIL): Likewise.
	  (EPROGMISMATCH, EPROGUNAVAIL, ERPCMISMATCH): Likewise.
	* libguile/cpp-SIG.syms (SIGEMT, SIGEV_MAX_SIZE): Likewise.
	  (SIGEV_PAD_SIZE, SIGINFO, SIGLOST): Likewise.

	Add new Linux errno constants.
	* libguile/cpp-E.syms (EHWPOISON, ERFKILL): New definitions.

2016-05-22  David Michael  <fedora.dm0@gmail.com>

	Fix the rule to check for new signals and errors
	Fixes <http://bugs.gnu.org/21114>.

	* libguile/Makefile.am (chknew-E chknew-SIG): Remove the line
	  continuation after the targets, and include numbers in the
	  recipe's signal/error regexp to catch names like E2BIG.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	i18n: Add new collation test for posterity.
	* test-suite/tests/i18n.test ("text collation (Czech)"): New test
	  prefix.

	web: Gracefully handle premature EOF when reading chunk header.
	* module/web/http.scm (read-chunk-header): Return 0 when 'read-line'
	  returns EOF.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	docs: Fix external representation of <toplevel-define> in tree-il.
	* doc/ref/compiler.texi (Tree-IL): Provide the correct external
	  representation of <toplevel-define>.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	web: Fix 'close' method of delimited input ports.
	* module/web/response.scm (make-delimited-input-port)[close]: Replace
	  erroneous self-recursive call with a call to 'close-port'.
	* test-suite/tests/web-response.test ("example-1")["response-body-port +
	  close"]: New test.

	Thank Ricardo.

	doc: Fix menu order for SXML.
	* doc/ref/sxml.texi (SXML): Add missing quotes in example.
	  Fix node order in menu.

2016-05-22  Ricardo Wurmus  <rekado@elephly.net>

	doc: Add SXPath documentation from sources
	Fixes <http://bugs.gnu.org/19478>.

	* doc/ref/sxml.texi (SXPath): Add procedure documentation from sources.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	psyntax: Fix bug in match-each+.
	Reported by Panicz Maciej Godek <godek.maciek@gmail.com> in
	<http://lists.gnu.org/archive/html/guile-user/2015-09/msg00017.html>.

	* module/ice-9/psyntax.scm (match-each+): Fix the case where a non-pair
	  syntax object is encountered in a dotted tail.
	* module/ice-9/psyntax-pp.scm: Regenerate.

2016-05-22  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	Clarify datum->syntax documentation.
	* doc/ref/api-macros.texi (Syntax Case): Make it clear that the first
	  argument to datum->syntax must be an identifier.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Fix uses of 'scm_gc_protect', which does not exist, in the manual.
	* doc/ref/api-memory.texi (Garbage Collection Functions),
	  doc/ref/libguile-concepts.texi (Garbage Collection): Change
	  'scm_gc_protect' --> 'scm_gc_protect_object'.

2016-05-22  Andreas Rottmann  <a.rottmann@gmx.at>

	Heed the reader settings implied by #!r6rs
	When encountering the #!r6rs directive, apply the appropriate reader
	settings to the port.

	* libguile/read.scm (read-string-as-list): New helper procedure.
	  (scm_read_shebang): Set reader options implied by the R6RS syntax
	  upon encountering the #!r6rs directive.
	* test-suite/tests/reader.test (per-port-read-options): Add tests for
	  the #!r6rs directive.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Fix atan procedure when applied to complex numbers.
	Fixes a regression introduced in commit
	ad79736c68a803a59814fbfc0cb4b092c2b4cddf.

	* libguile/numbers.c (scm_atan): Fix the complex case.
	* test-suite/tests/numbers.test ("atan"): Add test.

2016-05-22  Mathieu Lirzin  <mthl@openmailbox.org>

	doc: Fix parameter of 'set-record-type-printer!'.
	* doc/ref/api-compound.texi (SRFI-9 Records)[set-record-type-printer!]:
	  Fix parameter name.

2016-05-22  Natanael Copa  <ncopa@alpinelinux.org>

	i18n: Check for non-POSIX strtol_l.
	* configure.ac: Check for strtol_l.
	* libguile/i18n.c: Check HAVE_STRTOL_L before using strtol_l.

2016-05-22  Alex Kost  <alezost@gmail.com>

	Fix typo in the man page.
	* doc/guile.1: "--no-autocompile" -> "--no-auto-compile".

	Fix typo in manual.
	* doc/ref/api-modules.texi (Using Guile Modules): Remove extra "yet".

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	doc: Update libgc URL.
	* doc/ref/data-rep.texi (Conservative GC): Update libgc URL.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Add more R6RS port encoding tests
	Originally applied to stable-2.0 as "Fix bytevector and custom binary
	ports to actually use ISO-8859-1 encoding.", commit
	d574d96f879c147c6c14df43f2e4ff9e8a6876b9.  Related to
	http://bugs.gnu.org/20200, which was introduced in in stable-2.0 but
	never existed on master.  Test modified by Andy Wingo to add a
	`force-output' where needed.

	* test-suite/tests/r6rs-ports.test: Add tests.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Handle zero-length bytevectors correctly in (system base types).
	* module/system/base/types.scm (cell->object): Use 'get-bytevector-n'
	  instead of 'get-bytevector-all', so that the zero-length case does not
	  return EOF.

	Work around requirement that size be non-zero in GDB 'open-memory'.
	* module/system/base/types.scm (memory-port): Handle zero size case
	  specially.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	web: Export 'server-impl' procedures and the 'http' server implementation.
	* module/web/server.scm: Export the 'server-impl' procedures.
	* module/web/server/http.scm: Export 'http'.

2016-05-22  Taylan Ulrich Bayırlı/Kammer  <taylanbayirli@gmail.com>

	Correct docstring of 'symlink'.
	* libguile/filesys.c (symlink): Correct the docstring, which had
	  'oldpath' and 'newpath' confused.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	tests: Gracefully handle ENOSYS return for 'setaffinity'.
	Fixes <http://bugs.gnu.org/19646>.
	Reported by John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>.

	* test-suite/tests/posix.test ("affinity")["setaffinity"]: Wrap in
	  'catch' and throw 'unresolved upon ENOSYS.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	tests: Make 'test-guild-compile' more reliable.
	Before that it would occasionally fail because the "$target" (not the
	intermediate temporary file) would be produced.

	* test-suite/standalone/test-guild-compile: Call 'pause' before 'sleep'
	  in test program.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Don't return expressions from void functions in numbers.c
	Although popular compilers allow it as long as the expression is of type
	void, it violates C99 and some compilers choke on it.

	* libguile/numbers.c (scm_euclidean_divide, scm_floor_divide)
	  (scm_ceiling_divide, scm_truncate_divide, scm_centered_divide)
	  (scm_round_divide): Don't use the return statement with an expression
	  from functions with return type void.

2016-05-22  Mark H Weaver  <mhw@netris.org>

	Implement 'string-utf8-length' and 'scm_c_string_utf8_length'.
	* libguile/strings.c (utf8_length, scm_c_string_utf8_length)
	  (scm_string_utf8_length): New functions.
	* libguile/strings.h (scm_c_string_utf8_length, scm_string_utf8_length):
	  New prototypes.
	* doc/ref/api-data.texi (Bytevectors as Strings): Add docs.
	* doc/ref/guile.texi: Update manual copyright date to 2015.
	* test-suite/tests/strings.test (string-utf8-length): Add tests.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	http: Do not buffer HTTP chunks.
	Fixes <http://bugs.gnu.org/19939>.

	* module/web/http.scm (read-chunk, read-chunk-body): Remove.
	  (make-chunked-input-port)[next-chunk, buffer-, buffer-size,
	  buffer-pointer]: Remove.
	  [chunk-size, remaining]: New variables.
	  [read!]: Rewrite to write directly to BV.
	* test-suite/tests/web-http.test ("chunked encoding")["reads chunks
	  without buffering", "reads across chunk boundaries"]: New tests.

2016-05-22  Ludovic Courtès  <ludo@gnu.org>

	tests: Use 'pass-if-equal' in web-http chunked encoding tests.
	* test-suite/tests/web-http.test ("chunked encoding"): Use
	  'pass-if-equal' where appropriate.

2016-05-22  Andy Wingo  <wingo@pobox.com>

	Speed up port position access from Scheme
	* libguile/ports-internal.h (scm_port_buffer_position):
	  (scm_port_position_line, scm_port_position_set_line):
	  (scm_port_position_column, scm_port_position_set_column): New
	  helpers.
	  (scm_t_port): Ports now hold position as a pair, so that Scheme can
	  access it easily.
	  (SCM_LINUM, SCM_COL, SCM_INCLINE, SCM_ZEROCOL, SCM_INCCOL)
	  (SCM_DECCOL, SCM_TABCOL): Remove.
	* libguile/ports.c (make_port_buffer): Rename from
	  scm_c_make_port_buffer, make static, and take port as an argument so
	  we can initialize the position field.
	  (initialize_port_buffers): Adapt make_port_buffer change.
	  (scm_c_make_port_with_encoding): Initialize position.
	  (update_port_position): Rename from update_port_lf, and operate on
	  port position objects.
	  (scm_ungetc): Operate on port position objects.
	  (scm_setvbuf, scm_expand_port_read_buffer_x): Adapt to
	  make_port_buffer change.
	  (scm_lfwrite): Adapt to call update_port_position.
	  (scm_port_line, scm_set_port_line_x, scm_port_column)
	  (scm_set_port_column_x): Adapt to use port positions.
	* libguile/ports.h (scm_c_make_port_buffer): Remove internal decl.
	* libguile/read.c: Adapt to use scm_port_line / scm_port_column instead
	  of SCM_LINUM et al.
	* module/ice-9/ports.scm (port-buffer-position, port-position-line)
	  (port-position-column, set-port-position-line!)
	  (set-port-position-column!): New accessors for the internals module.
	* module/ice-9/sports.scm (advance-port-position!): Rename from
	  port-advance-position! and use the new accessors.
	  (read-char, port-fold-chars/iso-8859-1): Adapt to use
	  advance-port-position!.

	Implementation of read-delimited in Scheme
	* module/ice-9/sports.scm (port-fold-chars/iso-8859-1):
	  (port-fold-chars, read-delimited, read-line, %read-line): Initial
	  implementation of read-delimited.

	Sports refactor
	* module/ice-9/sports.scm (port-advance-position!): Factor out to a
	  helper.
	  (read-char): Use port-advance-position!.

2016-05-20  Andy Wingo  <wingo@pobox.com>

	Add install-sports!, uninstall-sports! functions
	* module/ice-9/sports.scm (install-sports!, uninstall-sports!): New
	  functions.

	Support for non-blocking I/O
	* doc/ref/api-io.texi (I/O Extensions): Document read_wait_fd /
	  write_wait_fd members.
	  (Non-Blocking I/O): New section.
	* libguile/fports.c (fport_read, fport_write): Return -1 if the
	  operation would block.
	  (fport_wait_fd, scm_make_fptob): Add read/write wait-fd
	  implementation.
	* libguile/ports-internal.h (scm_t_port_type): Add read_wait_fd /
	  write_wait_fd.
	* libguile/ports.c (default_read_wait_fd, default_write_wait_fd): New
	  functions.
	  (scm_make_port_type): Initialize default read/write wait fd impls.
	  (trampoline_to_c_read, trampoline_to_scm_read)
	  (trampoline_to_c_write, trampoline_to_scm_write): To Scheme, a return
	  of #f indicates EWOULDBLOCk.
	  (scm_set_port_read_wait_fd, scm_set_port_write_wait_fd): New
	  functions.
	  (port_read_wait_fd, port_write_wait_fd, scm_port_read_wait_fd)
	  (scm_port_write_wait_fd, port_poll, scm_port_poll): New functions.
	  (scm_i_read_bytes, scm_i_write_bytes): Poll if the read or write would
	  block.
	* libguile/ports.h (scm_set_port_read_wait_fd)
	  (scm_set_port_write_wait_fd): Add declarations.
	* module/ice-9/ports.scm: Shunt port-poll and port-{read,write}-wait-fd
	  to the internals module.
	* module/ice-9/sports.scm (current-write-waiter):
	  (current-read-waiter): Implement.
	* test-suite/tests/ports.test: Adapt non-blocking test to new behavior.
	* NEWS: Add entry.

2016-05-18  Andy Wingo  <wingo@pobox.com>

	Fix sports.test
	* test-suite/tests/sports.test (include-tests): Fix encoding when
	  reading ports.test.

2016-05-16  Andy Wingo  <wingo@pobox.com>

	Test Scheme port implementation
	* module/ice-9/ports.scm: Add port-decode-char to internals export
	  list.
	* test-suite/Makefile.am:
	* test-suite/tests/sports.test: Add new test.

	U+FFFD is the input substitution character
	* libguile/ports.c (UNICODE_REPLACEMENT_CHARACTER):
	* libguile/ports.c (peek_utf8_codepoint)
	  (scm_port_decode_char, peek_iconv_codepoint):
	* module/ice-9/sports.scm (peek-char-and-len/utf8):
	  (peek-char-and-len/iconv): Return U+FFFD when we get a decoding error
	  when reading, instead of '?', in accordance with Unicode
	  recommendations.
	* test-suite/tests/iconv.test:
	* test-suite/tests/ports.test:
	* test-suite/tests/rdelim.test: Update tests.
	* NEWS: Update.

	Bump objcode version
	* libguile/_scm.h (SCM_OBJCODE_MINOR_VERSION):
	* module/system/vm/assembler.scm (*bytecode-minor-version*): Bump for
	  Guile 2.1.3.

2016-05-15  Andy Wingo  <wingo@pobox.com>

	Update NEWS for release
	* NEWS: Try to tell the port story better.

2016-05-14  Andy Wingo  <wingo@pobox.com>

	Remove unused type from ports-internal
	* libguile/ports-internal.h: Remove unused scm_t_port_rw_active.
	* libguile/deprecated.h (scm_port_rw_active): Remove deprecation shim,
	  as this thing is just gone now.

	Document scm_c_make_port and friends
	* doc/ref/api-io.texi (I/O Extensions): Document scm_c_make_port and
	  friends, and document "mode bits".

	Update port mode bits documentation.
	* libguile/ports.h: Update documentation of port mode bits.

	Add SCM_OPN to mode bits when making ports
	* libguile/ports.c (scm_c_make_port_with_encoding): Add SCM_OPN to mode
	  bits, so that users don't have to.
	  (scm_i_mode_bits_n):
	* libguile/print.c (scm_simple_format)
	* libguile/r6rs-ports.c (make_bytevector_input_port)
	  (make_custom_binary_input_port, make_bytevector_output_port)
	  (make_custom_binary_output_port, make_transcoded_port)
	* libguile/strports.c (scm_object_to_string, scm_open_input_string)
	  (scm_open_output_string, scm_c_read_string): Remove now-unneeded
	  SCM_OPN mentions.

2016-05-13  Andy Wingo  <wingo@pobox.com>

	Update port type documentation
	* doc/ref/api-io.texi (I/O Extensions): Update for port type change.

2016-05-13  Andy Wingo  <wingo@pobox.com>

	Use heap-allocated port types instead of ptobnums
	This removes a limitation on the number of port types, simplifies the
	API, and removes a central point of coordination.

	* libguile/ports-internal.h (struct scm_t_port_type): Rename from
	  scm_t_ptob_descriptor, now that it's private.  Add GOOPS class
	  fields.
	  (struct scm_t_port): Rename from struct scm_port, especially
	  considering that deprecated.h redefines scm_port using the
	  preprocessor :(.
	* libguile/ports.h: Add definitions of SCM_PORT and SCM_PORT_TYPE,
	  though the scm_t_port and scm_t_port_type types are incomplete.
	  (SCM_TC2PTOBNUM, SCM_PTOBNUM, SCM_PTOBNAME): Remove, as there are no
	  more typecodes for port types.
	  (scm_c_num_port_types, scm_c_port_type_ref, scm_c_port_type_add_x):
	  Remove.
	  (scm_make_port_type): Return a scm_t_port_type*.  All methods adapted
	  to take a scm_t_port_type* instead of a ptobnum.
	  (scm_c_make_port_with_encoding, scm_c_make_port): Take a port type
	  pointer instead of a tag.
	  (scm_new_port_table_entry): Remove; not useful.
	* libguile/ports.c: Remove things related to the port kind table.  Adapt
	  uses of SCM_PORT_DESCRIPTOR / scm_t_ptob_descriptor to use
	  SCM_PORT_TYPE and scm_t_port_type.
	* libguile/deprecated.c:
	* libguile/deprecated.h:
	* libguile/filesys.c:
	* libguile/fports.c:
	* libguile/fports.h:
	* libguile/print.c:
	* libguile/r6rs-ports.c:
	* libguile/strports.c:
	* libguile/strports.h:
	* libguile/tags.h:
	* libguile/vports.c:
	* test-suite/standalone/test-scm-c-read.c: Adapt to change.
	* libguile/goops.c (scm_class_of, make_port_classes)
	  (scm_make_port_classes, create_port_classes): Adapt to store the
	  classes in the ptob.

2016-05-13  Andy Wingo  <wingo@pobox.com>

	Make scm_t_ptob_descriptor private.
	* libguile/goops.c: Use port internals header.
	* libguile/ports-internal.h (scm_t_port_type_flags)
	  (struct scm_t_ptob_descriptor): Make private.
	* libguile/ports.h: Adapt.

	Update port documentation
	* doc/ref/api-io.texi: Update for refactorings.

	Remove scm_t_port_internal
	* libguile/ports-internal.h (SCM_PORT): Rename from SCM_PTAB_ENTRY.
	  (scm_t_port_internal, SCM_PORT_GET_INTERNAL): Remove.
	  (SCM_FILENAME, SCM_SET_FILENAME, SCM_LINUM, SCM_COL): Adapt.
	* libguile/ports.c:
	* libguile/poll.c:
	* libguile/ioext.c:
	* libguile/fports.c:
	* libguile/filesys.c:
	* libguile/print.c:
	* libguile/read.c:
	* libguile/rw.c:
	* libguile/strings.c: Adapt.

	Make scm_t_port private
	* libguile/ports-internal.h (enum scm_port_encoding_mode): Remove unused
	  enum.
	  (scm_t_port_internal, scm_t_port): Make encoding and
	  conversion_strategy private. Instead of scm_t_port_internal containing
	  scm_t_port, now that all members are private, we can store the user's
	  "stream" in a word in the port object itself and make the whole of
	  scm_t_port private.  The next commit will remove scm_t_port_internal.
	  (SCM_PTAB_ENTRY, SCM_PORT_DESCRIPTOR): Make private.
	* libguile/ports.c (scm_c_make_port_with_encoding): Adapt to new port
	  layout.
	  (scm_port_print): Use SCM_PTAB_ENTRY when printing.
	* libguile/ports.h: Remove scm_t_port definition.
	* libguile/ioext.c (get_matching_port): Simplify.
	* libguile/fports.c (scm_i_evict_port): Simplify.

	Make port buffering fields private
	* libguile/ports-internal.h (enum scm_port_buffer_field)
	  (scm_t_port_internal): Make port buffering fields private.
	* libguile/ports.h (scm_t_port): Adapt.
	* libguile/filesys.c (set_element):
	* libguile/ioext.c (scm_redirect_port):
	* libguile/poll.c (scm_primitive_poll):
	* libguile/ports.c:
	* libguile/read.c (scm_i_scan_for_encoding):
	* libguile/rw.c (scm_write_string_partial): Adapt users.

	Make file/line/column fields of ports private
	* libguile/ports-internal.h (scm_t_port_internal): Move file_name,
	  line_number, and column_number here.
	  (SCM_FILENAME, SCM_SET_FILENAME, SCM_LINUM, SCM_COL, SCM_INCLINE):
	  (SCM_ZEROCOL, SCM_INCCOL, SCM_DECCOL, SCM_TABCOL): Make internal.
	* libguile/ports.c (scm_c_make_port_with_encoding)
	  (scm_set_port_line_x, scm_set_port_column_x): Adapt to change.

	Embed scm_t_port in scm_t_port_internal
	* libguile/ports-internal.h (scm_t_port_internal)
	* libguile/ports.h (scm_t_port): Embed scm_t_port in scm_t_port_internal
	  so that we have just one allocation.
	* libguile/ports-internal.h (SCM_PORT_GET_INTERNAL): Adapt.
	* libguile/ports.c (scm_i_port_property, scm_i_set_port_property_x)
	  (scm_c_make_port_with_encoding): Adapt.

	Remove SCM backlink in port structure
	* libguile/ports.h (scm_t_port): Remove port backlink.
	* libguile/ports.c (scm_c_make_port_with_encoding, scm_fill_input)
	  (scm_seek): Adapt.

	Add random_access_p port type method
	* doc/ref/api-io.texi (I/O Extensions): Update documentation on
	  implementing port types.  Document get_natural_buffer_sizes.  Document
	  the new random_access_p.
	* libguile/fports.c (scm_i_fdes_to_port, fport_random_access_p):
	  (scm_make_fptob): Instead of frobbing rw_random manually, implement a
	  random_access_p function.
	* libguile/ports.c (default_random_access_p)
	  (scm_set_port_random_access_p): New functions.
	  scm_make_port_type, scm_c_make_port_with_encoding): Arrange for
	  random_access_p to work.

	Add (ice-9 sports) module
	* module/ice-9/sports.scm: New module.
	* module/Makefile.am (SOURCES): Add new module.

2016-05-13  Andy Wingo  <wingo@pobox.com>

	Beginnings of shunting ports-in-scheme off to a module
	* libguile/ports.c (scm_specialize_port_encoding_x): Add some sanity
	  checks.
	  (scm_unget_bytes): Use scm_expand_port_read_buffer_x.
	  (port_clear_stream_start_for_bom_read): Use
	  scm_specialize_port_encoding_x.
	  (scm_fill_input): Use scm_expand_port_read_buffer_x.
	  (scm_expand_port_read_buffer_x): Rename from
	  scm_set_port_read_buffer_x and actually expand the buffer.
	* libguile/ports.h: Adapt to scm_expand_port_read_buffer_x change.

	* module/ice-9/ports.scm: Remove ports-in-scheme stuff, and instead
	  expose the ports internals via an auxiliary module.  This will let
	  ports-in-scheme live in a module during Guile 2.2.

2016-05-12  Andy Wingo  <wingo@pobox.com>

	Implement lookahead-u8, get-u8 in Scheme
	* module/ice-9/ports.scm (%lookahead-u8, %get-u8): Scheme
	  implementations.

2016-05-10  Andy Wingo  <wingo@pobox.com>

	%read-char speedup
	* module/ice-9/ports.scm (%read-char): Always call update-position! with
	  the same continuation, so that it will contify.

	Implement read-char in Scheme.
	* module/ice-9/ports.scm (%read-char): New function.

	%peek-char port argument optional.
	* module/ice-9/ports.scm (%peek-char): Port argument is optional.

	peek-char-and-len/iconv uses both returns from fill-input
	* module/ice-9/ports.scm (peek-char-and-len/iconv): Use buffered value
	  from fill-input.

	Fix bad-utf8-len bug.
	* module/ice-9/ports.scm (bad-utf8-len): Fix bug.

	clear-stream-start-for-bom-read refactor
	* module/ice-9/ports.scm (clear-stream-start-for-bom-read): Use the
	  "buffered" value that fill-input returns.

	Fix port-clear-stream-start-for-bom-read logic.
	* libguile/ports.c (scm_port_clear_stream_start_for_bom_read): Fix
	  logic.

	Scheme peek-char can handle iconv encodings
	* module/ice-9/ports.scm (peek-char-and-len/iconv): Fully implement.

	Factor out iconv to port-decode-char
	* libguile/ports.c (scm_port_decode_char): New helper, exported
	  to (ice-9 ports).
	  (peek_iconv_codepoint): Use scm_port_decode_char.

	Simplify decoding error handling
	* libguile/ports.c (peek_utf8_codepoint, peek_latin1_codepoint):
	  (peek_iconv_codepoint, peek_codepoint): Refactor to push error
	  handling to the leaves, where errors happen.  Just return
	  the (possibly substituted) codepoint, without an error code; if
	  there's really an error, we should raise it.
	  (scm_getc, scm_peek_char): Adapt.

	Decoding errors do not advance read pointer
	* libguile/ports.c (scm_getc): If the port conversion strategy is
	  'error, signal an error before advancing the read pointer.  This is a
	  change from previous behavior; before, we advanced the read pointer
	  under an understanding that that was what R6RS required.  But, that
	  seems to be not the case.
	* test-suite/tests/ports.test ("string ports"): Update decoding-error
	  tests to assume that read-char with an error doesn't advance the read
	  pointer.
	* test-suite/tests/rdelim.test ("read-line"): Likewise.

	Fix bug in trampoline_to_c_read
	* libguile/ports.c (trampoline_to_c_read): Fix bug comparing SCM
	  values.

2016-05-07  Andy Wingo  <wingo@pobox.com>

	Speed refactors to Scheme %peek-char
	* module/ice-9/ports.scm (peek-bytes): New helper.
	  (peek-byte): Use peek-bytes helper.
	  (decoding-error): Don't inline; no need.
	  (decode-utf8, bad-utf8-len): New helpers.
	  (peek-char-and-len/utf8): Use new helpers.
	  (peek-char-and-len): No fast paths, and not inline.  Peek-char has its
	  own fast path.
	  (%peek-char): Use helpers to make fast path.

	Fix port-clear-stream-start-for-bom-read bug
	* libguile/ports.c (scm_port_clear_stream_start_for_bom_read): Fix to
	  return SCM_BOOL_F instead of 0.

2016-05-05  Andy Wingo  <wingo@pobox.com>

	Fix use of port-encoding
	* module/ice-9/ports.scm (clear-stream-start-for-bom-read): Fix to use
	  %port-encoding, which works in symbols.

	Speed up peek-char
	* module/ice-9/ports.scm (peek-char-and-len): Only inline fast path for
	  UTF-8.

	Port to Scheme of new BOM handling
	* libguile/ports.c (scm_specialize_port_encoding_x)
	  (scm_port_clear_stream_start_for_bom_read): New functions exported
	  to (ice-9 ports).
	* module/ice-9/ports.scm (clear-stream-start-for-bom-read):
	  (fill-input, peek-char-and-len): Rework to handle BOM in fill-input
	  instead of once per peek-char.

	Handle BOM around fill/flush instead of peek/put
	* libguile/print.c (display_string_using_iconv): Remove BOM handling;
	  this is now handled by scm_lfwrite.
	* libguile/ports.c (open_iconv_descriptors): Refactor to take encoding
	  as a symbol.
	  (prepare_iconv_descriptors): New helper.
	  (scm_i_port_iconv_descriptors): Remove scm_t_port_rw_active argument,
	  and don't sniff UTF-16/UTF-32 byte orders here.  Instead BOM handlers
	  will call prepare_iconv_descriptors.
	  (scm_c_read_bytes): Call new port_clear_stream_start_for_bom_read
	  helper.
	  (port_maybe_consume_initial_byte_order_mark)
	  (scm_port_maybe_consume_initial_byte_order_mark): Remove.  Leaves
	  Scheme %peek-char broken but it's unused currently so that's OK.
	  (peek_iconv_codepoint): Fetch iconv descriptors after doing fill-input
	  because it's fill-input that will sniff the BOM.
	  (peek_codepoint): Instead of handling BOM at every character, handle
	  in fill-input instead.
	  (maybe_consume_bom, port_clear_stream_start_for_bom_read)
	  (port_clear_stream_start_for_bom_write): New helpers.
	  (scm_fill_input): Slurp a BOM if needed.
	  (scm_i_write): Clear the start-of-stream-for-bom-write flag.
	  (scm_lfwrite): Write a BOM if needed.

2016-05-04  Andy Wingo  <wingo@pobox.com>

	Spead tweaks to Scheme peek-char
	* module/ice-9/ports.scm: Speed tweaks to %peek-char.  Ultimately
	  somewhat fruitless; I can get 1.4s instead of 1.5s by only
	  half-inlining the UTF-8 case though.

	Add integer->char and char->integer opcodes
	* libguile/vm-engine.c (integer_to_char, char_to_integer): New opcodes.
	* libguile/vm.c (vm_error_not_a_char): New error case.
	* module/language/cps/compile-bytecode.scm (compile-function):
	* module/language/cps/slot-allocation.scm (compute-var-representations):
	* module/language/cps/types.scm:
	* module/language/tree-il/compile-cps.scm (convert):
	* doc/ref/vm.texi (Inlined Scheme Instructions):
	* module/system/vm/assembler.scm: Add support for new opcodes.

	Initial peek-char implementation in Scheme
	* module/ice-9/ports.scm (EILSEQ, decoding-error, peek-char-and-len/utf8):
	  (peek-char-and-len/iso-8859-1, peek-char-and-len/iconv):
	  (peek-char-and-len, %peek-char): New definitions.  Missing iconv1 for
	  peek-char, but enough to benchmark.

	Port refactors to help Scheme peek-char
	* libguile/ports.h (scm_sys_port_encoding, scm_sys_set_port_encoding):
	  New functions, to expose port encodings as symbols directly to (ice-9
	  ports).
	  (scm_port_maybe_consume_initial_byte_order_mark): New function.
	* libguile/ports.c (scm_port_encoding): Dispatch to %port-encoding.
	  (scm_set_port_encoding_x): Dispatch to %set-port-encoding!.
	  (port_maybe_consume_initial_byte_order_mark): New helper, factored out
	  of peek_codepoint.
	  (scm_port_maybe_consume_initial_byte_order_mark, peek_codepoint): Call
	  port_maybe_consume_initial_byte_order_mark.
	* module/ice-9/ports.scm (port-encoding): Implement in Scheme.

	Port conversion strategies internally are symbols
	* libguile/ports.h (scm_t_port): Represent the conversion strategy as a
	  symbol, to make things easier for Scheme.  Rename to
	  "conversion_strategy".
	  (scm_c_make_port_with_encoding): Change to take encoding and
	  conversion_strategy arguments as symbols.
	  (scm_i_string_failed_conversion_handler): New internal helper, to turn
	  a symbol to a scm_t_string_failed_conversion_handler.
	  (scm_i_default_port_encoding): Return the default port encoding as a
	  symbol.
	  (scm_i_default_port_conversion_strategy)
	  (scm_i_set_default_port_conversion_strategy): Rename from
	  scm_i_default_port_conversion_handler et al.  Take and return Scheme
	  symbols.
	* libguile/foreign.c (scm_string_to_pointer, scm_pointer_to_string): Use
	  scm_i_default_string_failed_conversion_handler instead of
	  scm_i_default_port_conversion_handler.
	* libguile/print.c (PORT_CONVERSION_HANDLER): Update definition.
	  (print_normal_symbol): Use PORT_CONVERSION_HANDLER.
	* libguile/r6rs-ports.c (make_bytevector_input_port):
	  (make_custom_binary_input_port, make_bytevector_output_port): Adapt to
	  changes in scm_c_make_port_with_encoding.
	* libguile/strings.h:
	* libguile/strings.c (scm_i_default_string_failed_conversion_handler):
	  New helper.
	  (scm_from_locale_stringn, scm_from_port_stringn):
	  (scm_to_locale_stringn, scm_to_port_stringn): Adapt to interface
	  changes.
	* libguile/strports.c (scm_mkstrport): Adapt to
	  scm_c_make_port_with_encoding change.
	* libguile/ports.c (scm_c_make_port): Adapt to
	  scm_c_make_port_with_encoding change.
	  (ascii_toupper, encoding_matches, canonicalize_encoding): Move down in
	  the file.
	  (peek_codepoint, get_codepoint, scm_ungetc): Adapt to port conversion
	  strategy change.  Remove duplicate case in get_codepoint.
	  (scm_init_ports): Move symbol initializations to the same place.

2016-05-03  Andy Wingo  <wingo@pobox.com>

	Port encoding internally represented as symbol
	* libguile/ports-internal.h (scm_t_port_internal): Remove encoding_mode
	  member.
	* libguile/ports.h (scm_t_port): "encoding" member is now a SCM symbol.
	* libguile/ports.c (scm_init_ports): Define symbols for the encodings
	  that we handle explicitly.
	  (encoding_matches): Adapt to check against an encoding as a symbol.
	  (canonicalize_encoding): Return an encoding as a symbol.
	  (scm_c_make_port_with_encoding, scm_i_set_default_port_encoding)
	  (decide_utf16_encoding, decide_utf32_encoding)
	  (scm_i_port_iconv_descriptors, scm_i_set_port_encoding_x)
	  (scm_port_encoding, peek_codepoint, scm_ungetc): Adapt to encoding
	  change.

	* libguile/print.c (display_string_using_iconv, display_string):
	* libguile/read.c (scm_read_character):
	* libguile/strings.c (scm_from_port_stringn, scm_to_port_stringn): Adapt
	  to port encoding change.

2016-05-01  Andy Wingo  <wingo@pobox.com>

	Minor tweak to Scheme peek-byte.
	* module/ice-9/ports.scm (peek-byte): Use second return from
	  fill-input.

	Changes to Scheme fill-input corresponding to C
	* module/ice-9/ports.scm (fill-input): Rewrite to make changes like the
	  ones made to the C scm_fill_input: allow callers to specify a minimum
	  amount of buffering.

	Char readers peek into read buffer
	* libguile/ports.c (scm_i_set_pending_eof): Remove now-unused helper.
	  (peek_utf8_codepoint, peek_latin1_codepoint, peek_iconv_codepoint):
	  (peek_codepoint): Refactor the fundamental character readers in Guile
	  to peek into the read buffer instead of reading then unreading.  This
	  will allow Scheme to use the port buffer to convert, when we port this
	  to Scheme.
	  (get_codepoint): Use peek_codepoint.
	  (scm_getc): Adapt.
	  (scm_peek_char): Use peek_codepoint.

	scm_fill_input can guarantee a minimum fill amount
	* libguile/ports.h (scm_fill_input): Add "minimum_size" argument.  Adapt
	  all callers to pass 0 as this argument.
	* libguile/ports.c (scm_i_read): Inline into scm_fill_input.
	  (scm_fill_input): "minimum_size" argument ensures that there are a
	  certain number of bytes available, or EOF.  Instead of shrinking the
	  read buffer, only fill by the read_buffering amount, or the
	  minimum_size, whichever is larger.
	* libguile/r6rs-ports.c:
	* libguile/read.c: Adapt scm_fill_input callers.

2016-04-30  Andy Wingo  <wingo@pobox.com>

	peek-byte in Scheme
	* libguile/ports.c (trampoline_to_c_read, trampoline_to_c_write): Since
	  C might assume that the indices are within bounds of the bytevector,
	  verify them more here.
	  (scm_port_random_access_p, scm_port_read_buffering)
	  (scm_set_port_read_buffer, scm_port_read, scm_port_write): New helpers
	  exposed to (ice-9 ports).
	  (scm_port_read_buffer, scm_port_write_buffer): Don't flush or validate
	  port mode; we do that in Scheme.
	* module/ice-9/ports.scm: Implement enough of port machinery to
	  implement peek-byte in Scheme.  Not yet exported.

	Tweak port initialization order
	* libguile/init.c (scm_i_init_guile): Initialize ports before
	  strports/fports, so that we have initialized the read/write
	  trampolines before making port types.

	Refactor way the-eof-object is defined
	* libguile/ports.c (scm_init_ice_9_ports): Define the-eof-object here.
	  Update a comment.
	* module/ice-9/ports.scm: Use the-eof-object definition from C.

	Add SCM port read/write functions
	* libguile/ports.h (scm_t_ptob_descriptor): Add "scm_read" and
	  "scm_write" members, for calling from Scheme.
	  (scm_set_port_scm_read, scm_set_port_scm_write): New procedures.
	* libguile/ports.c (trampoline_to_c_read_subr)
	  (trampoline_to_c_write_subr): New static variables.
	* libguile/ports.c (scm_make_port_type): Initialize scm_read and
	  scm_write members to trampoline to C.
	  (trampoline_to_c_read, trampoline_to_scm_read)
	  (trampoline_to_c_write, trampoline_to_scm_write): New helpers.
	  (scm_set_port_scm_read, scm_set_port_scm_write): New functions.
	  (default_buffer_size): Move definition down.
	  (scm_i_read_bytes, scm_i_write_bytes): Use new names for read and
	  write procedures.
	  (scm_init_ports): Initialize trampolines.

2016-04-28  Andy Wingo  <wingo@pobox.com>

	Remove port locks
	* libguile/ports.h (scm_t_port): Remove lock field.
	  (scm_dynwind_lock_port, scm_c_lock_port, scm_c_try_lock_port):
	  Remove.
	* libguile/ports.c (scm_i_port_property, scm_i_set_port_property_x):
	  Remove locking.
	* libguile/ports.c (scm_c_make_port_with_encoding): Remove lock.
	  (scm_i_read_bytes, scm_i_read, scm_i_write_bytes, scm_i_write): Remove
	  "_unlocked" from names and adapt callers.

	Optimize peek-char
	* libguile/ports.c (scm_peek_char): Optimize.  A loop calling peek-char
	  on a buffered string port 10e6 times goes down from 50ns/iteration to
	  32ns/iteration.

	Remove port locking around write, display
	* libguile/print.c (scm_write, scm_display):
	* libguile/read.c (set_port_read_option): Remove port locking.  Reading
	  and writing to the same port from multiple threads just must not
	  crash; it doesn't have to make sense.

2016-04-26  Andy Wingo  <wingo@pobox.com>

	scm_lfwrite, not scm_lfwrite_unlocked
	* libguile/ports.h (scm_lfwrite_unlocked): Remove.
	* libguile/ports.c (scm_lfwrite): Rename from scm_lfwrite_unlocked.
	* libguile/numbers.c:
	* libguile/print.c: Adapt to call scm_lfwrite.

	Remove scm_c_write_unlocked
	* libguile/ports.h (scm_c_write_bytes_unlocked): Remove.
	* libguile/ports.c (scm_c_write_bytes): Rename from
	  scm_c_write_bytes_unlocked, make public, and return void.
	  (scm_c_write): Rename from scm_c_write_unlocked.  Remove locked
	  variant.
	  (scm_lfwrite_unlocked): Call scm_c_write.
	* libguile/rw.c (scm_write_string_partial): Call scm_c_write.

	Remove scm_puts_unlocked.
	* libguile/ports.h (scm_puts_unlocked): Remove.
	* libguile/ports.c (scm_puts): Replace implementation with
	  scm_puts_unlocked's implementation.
	* libguile/arbiters.c:
	* libguile/backtrace.c:
	* libguile/bitvectors.c:
	* libguile/continuations.c:
	* libguile/deprecation.c:
	* libguile/dynl.c:
	* libguile/eval.c:
	* libguile/filesys.c:
	* libguile/fluids.c:
	* libguile/foreign.c:
	* libguile/fports.c:
	* libguile/frames.c:
	* libguile/guardians.c:
	* libguile/hashtab.c:
	* libguile/hooks.c:
	* libguile/load.c:
	* libguile/macros.c:
	* libguile/mallocs.c:
	* libguile/print.c:
	* libguile/programs.c:
	* libguile/promises.c:
	* libguile/smob.c:
	* libguile/srcprop.c:
	* libguile/srfi-14.c:
	* libguile/stackchk.c:
	* libguile/struct.c:
	* libguile/threads.c:
	* libguile/throw.c:
	* libguile/values.c:
	* libguile/variable.c:
	* libguile/vm.c:
	* libguile/weak-set.c:
	* libguile/weak-table.c: Use scm_puts instead of scm_puts_unlocked.

	Remove scm_putc_unlocked.
	* libguile/ports.h (scm_putc_unlocked): Remove.
	* libguile/ports.c (scm_putc): Replace implementation with
	  scm_putc_unlocked's implementation.
	  (scm_port_print): Use scm_putc.
	* libguile/arbiters.c:
	* libguile/arrays.c:
	* libguile/bitvectors.c:
	* libguile/bytevectors.c:
	* libguile/continuations.c:
	* libguile/dynl.c:
	* libguile/eval.c:
	* libguile/filesys.c:
	* libguile/fluids.c:
	* libguile/foreign.c:
	* libguile/fports.c:
	* libguile/frames.c:
	* libguile/hashtab.c:
	* libguile/hooks.c:
	* libguile/macros.c:
	* libguile/mallocs.c:
	* libguile/print.c:
	* libguile/programs.c:
	* libguile/promises.c:
	* libguile/r6rs-ports.c:
	* libguile/smob.c:
	* libguile/srcprop.c:
	* libguile/struct.c:
	* libguile/variable.c:
	* libguile/weak-set.c:
	* libguile/weak-table.c: Use scm_putc instead of scm_putc_unlocked.

	Remove scm_fill_input_unlocked
	* libguile/ports.h (scm_fill_input_unlocked): Remove.
	* libguile/ports.c (scm_fill_input): Rename from
	  scm_fill_input_unlocked.  Adapt callers.
	* libguile/r6rs-ports.c (scm_get_bytevector_some): Adapt.
	* libguile/read.c (scm_i_scan_for_encoding): Adapt.

	Remove locking in scm_end_input
	* libguile/ports.c (scm_end_input): Sadly, we can't naively lock around
	  the scm_port_buffer_take, as it might throw.  Will revisit in the
	  future.

2016-04-23  Andy Wingo  <wingo@pobox.com>

	scm_ungetc, scm_ungets instead of _unlocked variants
	* libguile/ports.h (scm_ungetc_unlocked, scm_ungets_unlocked): Remove;
	  replace with scm_ungetc, scm_ungets.
	* libguile/ports.c (scm_ungetc, scm_ungets, scm_unread_char)
	  (scm_unread_string): Adapt.
	* libguile/rdelim.c (scm_read_delimited_x): Use scm_ungetc.
	* libguile/read.c: Unread characers with scm_ungetc, not
	  scm_ungetc_unlocked.

	Remove scm_unget_{byte,bytes}_unlocked
	* libguile/ports.h (scm_unget_bytes_unlocked, scm_unget_byte_unlocked):
	  Remove.
	* libguile/ports.c (looking_at_bytes): Use scm_unget_bytes instead of
	  scm_i_unget_bytes_unlocked
	  (scm_unget_bytes): Rename from scm_i_unget_bytes_unlocked.  Remove
	  other implementations of this function.
	  (scm_unget_byte): Likewise.
	  (scm_ungetc_unlocked, scm_peek_char): Use scm_unget_byte.
	* libguile/read.c (read_token): Use scm_unget_byte.

	Replace scm_getc with scm_getc_unlocked
	* libguile/ports.h (scm_getc_unlocked): Remove, or rather rename to
	  scm_getc.  This probably introduces some thread-related bugs but we'll
	  fix them in a different way.
	* libguile/ports.c (scm_getc): Rename from scm_getc_unlocked, replacing
	  the locky implementation.
	  (scm_read_char): Use scm_getc.
	* libguile/r6rs-ports.c (scm_get_string_n_x): Use scm_getc.
	* libguile/rdelim.c (scm_read_delimited_x, scm_read_line): Use
	  scm_getc.
	* libguile/read.c: Use scm_getc.

	Remove scm_c_read_bytes_unlocked
	* libguile/ports.c (scm_c_read_bytes_unlocked): Remove internal
	  function.

	Remove scm_flush_unlocked / scm_end_input_unlocked
	* libguile/ports.h (scm_flush_unlocked, scm_end_input_unlocked):
	  Remove.
	* libguile/ports.c (scm_c_read_bytes_unlocked):
	  (scm_i_unget_bytes_unlocked, scm_setvbuf, scm_force_output)
	  (scm_fill_input_unlocked, scm_c_write_bytes_unlocked)
	  (scm_c_write_unlocked, scm_lfwrite_unlocked, scm_seek)
	  (scm_truncate_file, flush_output_port): Call scm_flush / scm_end_input
	  instead of the _unlocked variants.
	  (scm_end_input): Lock while discarding the input buffer but not while
	  calling out to the seek function.
	* libguile/filesys.c (scm_fsync):
	* libguile/ioext.c (scm_redirect_port):
	* libguile/read.c (scm_i_scan_for_encoding):
	* libguile/rw.c (scm_write_string_partial): Use scm_flush, not
	  scm_flush_unlocked.

2016-04-22  Andy Wingo  <wingo@pobox.com>

	Remove port rw_active field
	* libguile/ports.h (scm_t_port_rw_active): Move type definition to
	  ports-internal.h.
	  (scm_t_port): Remove rw_active field.  It's sufficient to check the
	  port buffer cursors.
	* libguile/read.c (scm_i_scan_for_encoding): Just call
	  scm_flush_unlocked; it's idempotent.
	* libguile/ports.c (scm_c_make_port_with_encoding): Remove rw_active
	  field.
	  (scm_c_read_bytes_unlocked, scm_c_read, scm_i_unget_bytes_unlocked)
	  (scm_end_input_unlocked, scm_flush_unlocked, scm_fill_input_unlocked)
	  (scm_port_write_buffer, scm_port_read_buffer)
	  (scm_c_write_bytes_unlocked, scm_c_write_unlocked, scm_seek): Remove
	  management of rw_active field.

	scm_c_read instead of scm_c_read_unlock
	* libguile/ports.h (scm_c_read_unlocked): Remove.
	* libguile/ports.c (scm_c_read): Rename from scm_c_read_unlocked.
	  Remove old scm_c_read.  Lock around access to the rw_active flag, and
	  call scm_flush instead of scm_flush_unlocked, and scm_fill_input
	  instead of scm_fill_input_unlocked.
	* libguile/read.c (scm_i_scan_for_encoding): Use scm_c_read instead of
	  the _unlocked function.

	Refactor to internal get/peek-byte functions
	* libguile/ports.h (scm_get_byte_or_eof_unlocked)
	  (scm_peek_byte_or_eof_unlocked): Remove inline functions.  The
	  important uses are in ports.c anyway and we will use a static function
	  there.
	  (scm_slow_get_byte_or_eof_unlocked)
	  (scm_slow_peek_byte_or_eof_unlocked): Remove declarations without
	  definitions.
	* libguile/ports.c (looking_at_bytes): Use scm_peek_byte_or_eof instead
	  of the _unlocked variant.
	  (get_byte_or_eof, peek_byte_or_eof): New static functions.
	  (scm_get_byte_or_eof, scm_peek_byte_or_eof): Don't lock: the port
	  buffer mechanism means that we won't crash.  More comments to come.
	  (get_utf8_codepoint, get_latin1_codepoint, get_iconv_codepoint): Use
	  new static functions.
	* libguile/read.c (read_token, scm_read_semicolon_comment): Use
	  scm_get_byte_or_eof, not scm_get_byte_or_eof_unlocked.

	Refactor thread safety for %port-property
	* libguile/ports.c (scm_i_port_property, scm_i_set_port_property_x):
	  Knowing that the critical section can't throw, use serial lock
	  discipline.

2016-04-20  Andy Wingo  <wingo@pobox.com>

	Port buffers are Scheme values
	* libguile/ports-internal.h (scm_port_buffer_bytevector)
	  (scm_port_buffer_cur, scm_port_buffer_set_cur)
	  (scm_port_buffer_end, scm_port_buffer_set_end)
	  (scm_port_buffer_has_eof_p, scm_port_buffer_set_has_eof_p): New
	  helpers.
	* libguile/ports-internal.h (scm_port_buffer_size)
	  (scm_port_buffer_reset, scm_port_buffer_reset_end)
	  (scm_port_buffer_can_take, scm_port_buffer_can_put)
	  (scm_port_buffer_can_putback, scm_port_buffer_did_take)
	  (scm_port_buffer_did_put, scm_port_buffer_take_pointer)
	  (scm_port_buffer_put_pointer, scm_port_buffer_take)
	  (scm_port_buffer_put, scm_port_buffer_putback): Adapt to treat port
	  buffers as SCM values and use helpers to access them.
	* libguile/ports.c (scm_i_clear_pending_eof, scm_i_set_pending_eof)
	  (scm_c_make_port_buffer, scm_i_read_unlocked)
	  (scm_c_read_bytes_unlocked, scm_i_unget_bytes_unlocked)
	  (scm_setvbuf, scm_fill_input, scm_take_from_input_buffers)
	  (scm_drain_input, scm_end_input_unlocked, scm_flush_unlocked)
	  (scm_fill_input_unlocked, scm_i_write_unlocked)
	  (scm_c_write_bytes_unlocked, scm_c_write_unlocked)
	  (scm_char_ready_p): Adapt to treat port buffers as SCM values and use
	  helpers to access them.
	  (scm_port_read_buffer, scm_port_write_buffer): New functions,
	  allowing (ice-9 ports) to access port buffers.
	* libguile/ports.h: Update comments on port buffers.  Replace
	  scm_t_port_buffer structure with a Scheme vector whose fields are
	  enumerated by "enum scm_port_buffer_field".
	  (scm_get_byte_or_eof_unlocked, scm_peek_byte_or_eof_unlocked): Adapt
	  these implementations to port buffer representation change.
	* libguile/r6rs-ports.c (scm_get_bytevector_some):
	* libguile/read.c (scm_i_scan_for_encoding):
	* libguile/rw.c (scm_write_string_partial): Port buffers are Scheme
	  objects.

2016-04-19  Andy Wingo  <wingo@pobox.com>

	peek-u8 correctness and speed refactor
	* libguile/ports-internal.h (scm_port_buffer_size): Verify that the
	  bytevector field is a bytevector, in anticipation of Schemification.
	  (scm_port_buffer_can_take, scm_port_buffer_can_put)
	  (scm_port_buffer_can_putback): Enforce invariants on cur and end
	  here.
	  (scm_port_buffer_did_take, scm_port_buffer_did_put): Relax to not call
	  other functions.
	* libguile/ports.h (scm_get_byte_or_eof_unlocked)
	  (scm_peek_byte_or_eof_unlocked): Refactor to call no functions on the
	  fast path.

	Port buffer cur/next pointers are Scheme values
	* libguile/ports.h (scm_t_port_buffer): Change "cur" and "end" members
	  to be SCM values, in preparation for changing port buffers to be
	  Scheme vectors.
	  (scm_get_byte_or_eof_unlocked, scm_peek_byte_or_eof_unlocked): Adapt.
	* libguile/ports.c (scm_c_make_port_buffer): Initialize cur and end
	  members.
	  (looking_at_bytes): Use helper instead of incrementing cur.
	  (scm_i_read_unlocked): Adapt to end type change.
	  (CONSUME_PEEKED_BYTE): Use helper instead of incrementing cur.
	  (scm_i_unget_bytes_unlocked): Use helper instead of comparing cur.
	  (scm_i_write_unlocked): Fix for changing end/cur types.
	* libguile/read.c (scm_i_scan_for_encoding): Use helpers instead of
	  addressing cursors directly.
	* libguile/rw.c (scm_write_string_partial): Likewise.
	* libguile/ports-internal.h (scm_port_buffer_reset):
	  (scm_port_buffer_reset_end, scm_port_buffer_can_take):
	  (scm_port_buffer_can_put, scm_port_buffer_can_putback):
	  (scm_port_buffer_did_take, scm_port_buffer_did_put):
	  (scm_port_buffer_take_pointer, scm_port_buffer_put_pointer):
	  (scm_port_buffer_putback): Adapt to data types.

2016-04-18  Andy Wingo  <wingo@pobox.com>

	Remove "buf" field from port buffers
	* libguile/ports-internal.h (scm_port_buffer_reset_end): New helper.
	  (scm_port_buffer_putback): New helper.
	* libguile/ports.h (scm_t_port_buffer): Remove "buf" field.
	  (scm_get_byte_or_eof_unlocked, scm_peek_byte_or_eof_unlocked): Adapt.
	* libguile/ports.c (scm_c_make_port_buffer): No more "buf" field.
	  (scm_i_unget_bytes_unlocked): Use helper.
	* libguile/read.c (scm_i_scan_for_encoding): No more "buf" field.

2016-04-17  Andy Wingo  <wingo@pobox.com>

	Remove size field from port buffers
	* libguile/ports.h (scm_t_port_buffer): Remove size field.  Instead use
	  bytevector size.
	* libguile/ports-internal.h (scm_port_buffer_size)
	  (scm_port_buffer_reset)
	  (scm_port_buffer_can_take, scm_port_buffer_can_put)
	  (scm_port_buffer_did_take, scm_port_buffer_did_put)
	  (scm_port_buffer_take_pointer, scm_port_buffer_put_pointer)
	  (scm_port_buffer_take, scm_port_buffer_put): New helpers.
	* libguile/filesys.c (set_element): Use new helpers.
	* libguile/poll.c (scm_primitive_poll): Use new helpers.
	* libguile/ports.c (scm_c_make_port_buffer): No more "size" field.
	  (scm_i_read_unlocked, scm_c_read_bytes_unlocked)
	  (scm_c_read_unlocked, scm_i_unget_bytes_unlocked)
	  (scm_unget_bytes, scm_setvbuf, scm_take_from_input_buffers)
	  (scm_drain_input, scm_end_input_unlocked, scm_flush_unlocked)
	  (scm_fill_input_unlocked, scm_i_write_unlocked)
	  (scm_c_write_bytes_unlocked, scm_c_write_unlocked)
	  (scm_char_ready_p): Use new helpers.
	* libguile/r6rs-ports.c (scm_get_bytevector_some): Use new helpers.
	* libguile/rw.c (scm_write_string_partial): Use new helpers.

	Port buffer has-eof? field is SCM value
	* libguile/ports.h (scm_t_port_buffer): Rename has_eof member to
	  has_eof_p, and be a Scheme value, in anticipation of moving the port
	  buffers to be Scheme objects.

	Remove unrelated scm_t_port_buffer use in vports
	* libguile/vports.c (struct soft_port): Inline the encoding buffer so as
	  to not use scm_t_port_buffer, in anticipation of changing the port
	  buffer representations.  Adapt users.

2016-04-15  Andy Wingo  <wingo@pobox.com>

	Load port bindings in separate (ice-9 ports) module
	* module/ice-9/ports.scm: New file.
	* am/bootstrap.am (SOURCES): Add ice-9/ports.scm.
	* libguile/fports.c (scm_init_ice_9_fports): New function.
	  (scm_init_fports): Arrange for scm_init_ice_9_fports to be called via
	  load-extension, and load snarfed things there.  Move open-file
	  definition early, to allow ports to bootstrap.
	* libguile/ioext.c (scm_init_ice_9_ioext): New function.
	  (scm_init_ioext): Similarly, register scm_init_ice_9_ioext as an
	  extension.
	* libguile/ports.c (scm_set_current_input_port)
	  (scm_set_current_output_port, scm_set_current_error_port): Don't
	  define Scheme bindings; do that in Scheme.
	* libguile/ports.c (scm_i_set_default_port_encoding):
	  (scm_i_default_port_encoding, scm_i_default_port_conversion_handler):
	  (scm_i_set_default_port_conversion_handler): Since we now init
	  encoding early, remove the "init" flags on these encoding/strategy
	  vars.
	  (scm_init_ice_9_ports): New function.
	  (scm_init_ports): Register scm_init_ice_9_ports extension, and define
	  some bindings needed by the bootstrap.
	* module/Makefile.am (SOURCES): Add ice-9/ports.scm.
	* module/ice-9/boot-9.scm: Remove code that's not on the boot path,
	  moving it to ice-9/ports.scm.  At the end, load (ice-9 ports).
	* module/ice-9/psyntax.scm (include): Use close-port instead of
	  close-input-port.
	* module/ice-9/psyntax-pp.scm (include): Regenerate.

2016-04-14  Andy Wingo  <wingo@pobox.com>

	Fix R6RS imports of interfaces that use interfaces
	* module/ice-9/r6rs-libraries.scm (resolve-r6rs-interface): In Guile, a
	  module's public interface is just another module, and that means that
	  it can import other modules as well.  Allow for R6RS modules that
	  import module whose interfaces import other modules to access all
	  visible bindings.
	* test-suite/tests/rnrs-libraries.test ("import features"): Update
	  test.

	Fix scm_init_struct dependency on port conversion handlers
	* libguile/struct.c (scm_init_struct): Use scm_from_latin1_string to
	  avoid locale-dependency for what is really a latin1 string.  Also
	  avoids an early dependency on the default port conversion handler,
	  though I wonder if using port conversion handlers in strings is the
	  right thing.

2016-04-13  Andy Wingo  <wingo@pobox.com>

	Fix error in exception printer when bootstrapping
	* module/ice-9/boot-9.scm (exception-printers): Fix error in which, for
	  a pure bootstrap with no compiled files, the exception printer would
	  use false-with-exception before it has been defined, which doesn't
	  work for macros.  We wouldn't see this problem normally because,
	  oddly, the macro is indeed defined normally because of boot reasons.

2016-04-12  Andy Wingo  <wingo@pobox.com>

	Allow port "write" functions to only write a chunk
	* libguile/ports.c (scm_i_write_bytes_unlocked): Allow incomplete
	  writes from the implementation.
	  (scm_c_write_bytes_unlocked): Use scm_i_write_bytes_unlocked helper to
	  call the write function.
	* libguile/r6rs-ports.c (custom_binary_output_port_write): Don't loop;
	  core Guile will do that.

	Update port implementation documentation.
	* doc/ref/api-io.texi (I/O Extensions): Update read/write
	  documentation.

2016-04-11  Andy Wingo  <wingo@pobox.com>

	Port read/write functions take bytevectors
	This will allow better Scheme integration for ports.

	* libguile/ports.h (scm_t_port_buffer): Change "holder" member to be a
	  bytevector defined to have "buf" as its starting point.
	  (scm_t_ptob_descriptor): Change read and write functions to take
	  bytevectors as arguments and to return the number of octets read or
	  written.
	  (scm_make_port_type): Adapt accordingly.
	  (scm_c_read_bytes, scm_c_write_bytes): New functions that take
	  bytevectors.
	* libguile/ports.c (scm_make_port_type): Adapt to read/write function
	  prototype change.
	  (scm_c_make_port_buffer): Arrange to populate the "bytevector" field.
	  (scm_i_read_bytes_unlocked): New function.
	  (scm_i_read_unlocked): Use scm_i_read_bytes_unlocked.
	  (scm_c_read_bytes_unlocked): New function.
	  (scm_c_read_unlocked): Update comment, and always go through the
	  buffer.
	  (scm_c_read_bytes): New function.
	  (scm_flush_unlocked): Use scm_i_write_unlocked instead of the port's
	  write function.
	  (scm_i_write_bytes_unlocked): New function.
	  (scm_i_write_unlocked): Use scm_i_write_bytes_unlocked.
	  (scm_c_write_bytes_unlocked): New function.
	  (scm_c_write_unlocked): Always write through the buffer.
	  (scm_c_write_bytes): New function.
	  (scm_truncate_file): Remove unused variable.
	  (void_port_read, void_port_write): Adapt to read/write prototype
	  change.
	* libguile/fports.c (fport_read, fport_write):
	* libguile/r6rs-ports.c (bytevector_input_port_read)
	  (custom_binary_input_port_read, bytevector_output_port_write)
	  (custom_binary_output_port_write, transcoded_port_write)
	  (transcoded_port_read): Adapt to read/write prototype
	  change.
	  (scm_get_bytevector_n, scm_get_bytevector_n_x)
	  (scm_get_bytevector_all): Use scm_c_read_bytes.
	  (scm_put_bytevector): Use scm_c_write_bytes.
	* libguile/strports.c (string_port_read, string_port_write):
	* libguile/vports.c (soft_port_write, soft_port_read): Adapt to
	  read/write prototype change.
	* test-suite/standalone/test-scm-c-read.c (custom_port_read): Fix for
	  read API change.

2016-04-11  Andy Wingo  <wingo@pobox.com>

	make-chunked-output-port buffering fix
	* module/web/http.scm (make-chunked-output-port): Add #:buffering
	  argument, defaulting to 1200 (some random value under the MTU).  This
	  will force a flush every so often, and not every character as would
	  otherwise be the case after this port rewrite.

2016-04-08  Andy Wingo  <wingo@pobox.com>

	Fold 2.1.2 NEWS items into cumulative 2.2 NEWS
	* NEWS: Update.

	Update NEWS for changes to port buffering.
	* NEWS: Update.

2016-04-06  Andy Wingo  <wingo@pobox.com>

	Generic port facility provides buffering uniformly
	* libguile/ports.h (struct scm_t_port_buffer): New data type.
	  (struct scm_t_port): Refactor to use port buffers instead of
	  implementation-managed read and write pointers.  Add "read_buffering"
	  member.
	  (SCM_INITIAL_PUTBACK_BUF_SIZE, SCM_READ_BUFFER_EMPTY_P): Remove.
	  (scm_t_ptob_descriptor): Rename "fill_input" function to "read", and
	  take a port buffer, returning void.  Likewise "write" takes a port
	  buffer and returns void.  Remove "end_input"; instead if there is
	  buffered input and rw_random is true, then there must be a seek
	  function, so just seek back if needed.  Remove "flush"; instead all
	  calls to the "write" function implicitly include a "flush", since the
	  buffering happens in the generic port code now.  Remove "setvbuf", but
	  add "get_natural_buffer_sizes"; instead the generic port code can
	  buffer any port.
	  (scm_make_port_type): Adapt to read and write prototype changes.
	  (scm_set_port_flush, scm_set_port_end_input, scm_set_port_setvbuf):
	  Remove.
	  (scm_slow_get_byte_or_eof_unlocked)
	  (scm_slow_get_peek_or_eof_unlocked): Remove; the slow path is to call
	  scm_fill_input.
	  (scm_set_port_get_natural_buffer_sizes): New function.
	  (scm_c_make_port_buffer): New internal function.
	  (scm_port_non_buffer): Remove.  This was a function for
	  implementations that is no longer needed.  Instead open with BUF0 or
	  use (setvbuf port 'none).
	  (scm_fill_input, scm_fill_input_unlocked): Return the filled port
	  buffer.
	  (scm_get_byte_or_eof_unlocked, scm_peek_byte_or_eof_unlocked): Adapt
	  to changes in buffering and EOF management.
	* libguile/ports.c: Adapt to port interface changes.
	  (initialize_port_buffers): New function, using the port mode flags to
	  set up appropriate initial buffering for all ports.
	  (scm_c_make_port_with_encoding): Create port buffers here instead of
	  delegating to implementations.
	  (scm_close_port): Flush the port if needed instead of delegating to
	  the implementation.
	* libguile/filesys.c (set_element): Adapt to buffering changes.
	* libguile/fports.c (fport_get_natural_buffer_sizes): New function,
	  replacing scm_fport_buffer_add.
	  (fport_write, fport_read): Update to let the generic ports code do the
	  buffering.
	  (fport_flush, fport_end_input): Remove.
	  (fport_close): Don't flush in a dynwind; that's the core ports' job.
	  (scm_make_fptob): Adapt.
	* libguile/ioext.c (scm_redirect_port): Adapt to buffering changes.
	* libguile/poll.c (scm_primitive_poll): Adapt to buffering changes.
	* libguile/ports-internal.h (struct scm_port_internal): Remove
	  pending_eof flag; this is now set on the read buffer.
	* libguile/r6rs-ports.c (struct bytevector_input_port): New type.  The
	  new buffering arrangement means that there's now an intermediate
	  buffer between the bytevector and the user of the port; this could
	  lead to a perf degradation, but on the other hand there are some other
	  speedups enabled by the buffering refactor, so probably the memcpy
	  cost is dwarfed by the cost of the other parts of the ports
	  machinery.
	  (make_bytevector_input_port, bytevector_input_port_read):
	  (bytevector_input_port_seek, initialize_bytevector_input_ports): Adapt
	  to new buffering arrangement.
	  (struct custom_binary_port): Remove read buffer, as Guile handles that
	  now.
	  (custom_binary_input_port_setvbuf): Remove; now handled by Guile.
	  (make_custom_binary_input_port, custom_binary_input_port_read)
	  (initialize_custom_binary_input_ports): Adapt.
	  (scm_get_bytevector_some): Adapt to new EOF management.
	  (scm_t_bytevector_output_port_buffer): Hold on to the underlying port,
	  so we can flush it if it's open.
	  (make_bytevector_output_port, bytevector_output_port_write):
	  (bytevector_output_port_seek): Adapt.
	  (bytevector_output_port_procedure): Flush the port as appropriate, so
	  that we get all the bytes.
	  (make_custom_binary_output_port, custom_binary_output_port_write):
	  Adapt.
	  (make_transcoded_port): Don't muck with buffering.
	  (transcoded_port_write): Simply forward the write to the underlying
	  port.
	  (transcoded_port_read): Likewise.
	  (transcoded_port_close): No need to flush.
	  (initialize_transcoded_ports): Adapt.
	* libguile/read.c (scm_i_scan_for_encoding): Adapt to buffering
	  changes.
	* libguile/rw.c (scm_write_string_partial): Adapt to buffering changes.
	* libguile/strports.c: Adapt to the fact that we don't manage the
	  buffer.  Probably room for speed improvements here...
	* libguile/vports.c (soft_port_get_natural_buffer_sizes): New function.
	  Adapt the rest of the file for the new buffering regime.
	* test-suite/tests/r6rs-ports.test ("8.2.10 Output ports"): Custom
	  binary output ports need to be flushed before you can rely on the
	  write! procedure having been called.  Add necessary flush-port
	  invocations.
	  ("8.2.6  Input and output ports"): Transcoded ports now have an
	  internal buffer by default.  This test checks that the characters are
	  transcoded one at a time, so to do that, call setvbuf on the
	  transcoded port to remove the buffer.
	* test-suite/tests/web-client.test (run-with-http-transcript): Fix for
	  different flushing regime on soft ports.  (The vestigial flush
	  procedure is now called after each write, which is not what the test
	  was expecting.)
	* test-suite/standalone/test-scm-c-read.c: Update for changes to the C
	  interface for defining port types.
	* doc/ref/api-io.texi (Ports): Update to discuss buffering in a generic
	  way, and to remove a hand-wavey paragraph describing string ports as
	  "interesting and powerful".
	  (Reading, Writing): Remove placeholder comments.  Document
	  `scm_lfwrite'.
	  (Buffering): New section.
	  (File Ports): Link to buffering.
	  (I/O Extensions): Join subnodes into parent and describe new API,
	  including buffering API.
	* doc/ref/posix.texi (Ports and File Descriptors): Link to buffering.
	  Remove unread-char etc, as they are documented elsewhere.
	  (Pipes, Network Sockets and Communication): Link to buffering.

2016-04-05  Andy Wingo  <wingo@pobox.com>

	Port close functions return void
	* libguile/ports.h (scm_t_ptob_descriptor): The port close function now
	  returns void.
	  (scm_set_port_close): Adapt prototype.
	* libguile/ports.c (scm_close_port): Always return true if we managed to
	  call the close function.  There's no other sensible result; exceptions
	  are handled, well, exceptionally.

	* libguile/fports.c (fport_close)
	* libguile/r6rs-ports.c (custom_binary_port_close, transcoded_port_close):
	* libguile/vports.c (soft_port_close): Adapt.

	* doc/ref/api-io.texi (Port Implementation): Update.

2016-04-05  Andy Wingo  <wingo@pobox.com>

	When making soft port, parse handlers into struct
	* libguile/vports.c (struct soft_port): New data structure.
	  (scm_make_soft_port): Unpack vector into struct when making soft
	  port.
	  (soft_port_input_waiting, soft_port_close, soft_port_fill_input):
	  (soft_port_write, soft_port_flush): Adapt.  Remove an extraneous
	  errno=0 in soft_port_close.

2016-04-04  Andy Wingo  <wingo@pobox.com>

	Cosmetic changes to vports.c
	* libguile/vports.c (soft_port_flush): Rename from sf_flush, and similar
	  changes following.

	Fix POLLOUT assignment from port buffers
	* libguile/poll.c (scm_primitive_poll): A buffered port's buffer marks
	  it as writable only when writing a byte would not block, which is the
	  case only if there is more than one byte free in the buffer; writing
	  the last byte would block.

	Flush buffered reads / writes before seeking
	* libguile/ports.c (scm_seek): Flush before seeking on a buffered port.
	* libguile/fports.c (fport_seek):
	* libguile/strports.c (st_seek): Remove code to flush buffers.
	* test-suite/tests/ports.test: Update test expectations that the
	  putback buffer is flushed on a seek.  Previously there was a special
	  case for SEEK_CUR with an offset of 0 to avoid flushing buffers, but
	  that's an arbitrary choice that differs from all other combinations of
	  OFFSET and WHENCE.

	Whitespace fixes
	* libguile/ports.c: Fix whitespaces introduced when adding the port
	  lock.

	Refactor to rw_random / rw_active port flags
	* libguile/fports.c (fport_flush, fport_end_input): Move rw_active
	  handling to ports.c.
	* libguile/ioext.c (scm_redirect_port): Use scm_flush_unlocked instead
	  of calling the flush function directly.
	* libguile/ports.c (scm_c_make_port_with_encoding): Ports default to
	  "rw_random" mode when they have a seek function.
	  (scm_c_read_unlocked, scm_i_unget_bytes_unlocked)
	  (scm_slow_get_byte_or_eof_unlocked)
	  (scm_slow_peek_byte_or_eof_unlocked): Flush write buffer and set
	  rw_active always in the same way, and only if rw_random is true.
	  (scm_end_input_unlocked, scm_flush_unlocked): Clear rw_active here
	  unconditionally.
	  (scm_c_write_unlocked): Flush read buffer and set rw_active always in
	  the same way, but only if rw_random is true.
	  (scm_c_write, scm_lfwrite): Whitespace fixes.
	  (scm_lfwrite_substr): Don't flush read buffer; lower-level code will
	  do this.
	  (scm_truncate_file): Use scm_flush_unlocked instead of calling the
	  flush function directly.
	* libguile/r6rs-ports.c (transcoded_port_flush): Don't muck with
	  rw_active.
	* libguile/read.c (scm_i_scan_for_encoding): Flush write buffer if
	  needed in same way as ports.c.
	* libguile/strports.c (st_end_input): Don't muck with rw_active.
	  (scm_mkstrport): rw_random defaults to 1 now.

	Custom binary port internals refactor
	* libguile/r6rs-ports.c (struct custom_binary_port): Use a struct
	  instead of a vector as the state for a custom binary port.  Adapt all
	  callers.  Some whitespace fixes as well.

	Cosmetic changes to r6rs-ports.c
	* libguile/r6rs-ports.c: Expand out the acronyms "bip", "bop", "cbip",
	  "cbop", and "tp".  They always confused me, especially that the "b" in
	  cbip/cbop wasn't the same as the one in bip/bop.

	Remove port equal functions
	* doc/ref/api-io.texi (Port Implementation): Remove mention of port
	  equal functions.
	* NEWS: Update.
	* libguile/ports.c (scm_set_port_equalp): Remove.
	* libguile/ports.h (scm_t_ptob_descriptor): Remove equalp function.

	Remove port free functions; just close instead
	* libguile/ports.h (scm_t_port_type_flags): Replace
	  SCM_PORT_TYPE_HAS_FLUSH with SCM_PORT_TYPE_NEEDS_CLOSE_ON_GC.
	  (scm_t_ptob_descriptor): Remove free function.
	* libguile/ports.c (scm_set_port_needs_close_on_gc): New function.
	  (scm_set_port_flush): Don't set flags.
	  (scm_c_make_port_with_encoding, scm_close_port): Use the new flag to
	  determine when to add a finalizer and also when to include the port in
	  the weak set.
	  (scm_set_port_free): Remove.
	  (do_close, finalize_port): Close port instead of calling free
	  function.
	* libguile/r6rs-ports.c (initialize_transcoded_ports):
	* libguile/vports.c (scm_make_sfptob):
	* libguile/fports.c (scm_make_fptob): Mark these ports as needing close
	  on GC.
	* libguile/fports.c (fport_free): Remove.
	* NEWS: Update.
	* doc/ref/api-io.texi (Port Implementation): Update.

	Remove port mark functions
	* doc/ref/api-io.texi (Port Implementation): Remove documentation.
	* libguile/ports.c (scm_set_port_mark): Remove function.
	* libguile/ports.h (scm_t_ptob_descriptor): Remove mark function.
	* NEWS: Add entry.

	Move line-buffing machinery to ports.c
	* libguile/ports.c (scm_lfwrite_unlocked):
	* libguile/fports.c (fport_write): Move line-buffering from fport_write
	  to scm_lfwrite_unlocked.

	Use symbols instead of _IONBF values as args to setvbuf
	* libguile/ports.c (scm_setvbuf): Use the symbols `none', `line', and
	  `block' instead of the values `_IONBF', `_IOLBF', and `_IOFBF'.
	* NEWS: Update.
	* doc/ref/posix.texi (Ports and File Descriptors): Update setvbuf
	documentation.
	* module/ice-9/deprecated.scm (define-deprecated): New helper.
	(_IONBF, _IOLBF, _IOFBF): Define deprecated values.
	* benchmark-suite/benchmarks/read.bm ("read"):
	* benchmark-suite/benchmarks/uniform-vector-read.bm
	("uniform-vector-read!"):
	* libguile/r6rs-ports.c (cbip_fill_input):
	* module/system/base/types.scm (%ffi-memory-backend):
	* module/web/client.scm (open-socket-for-uri):
	* module/web/server/http.scm (http-read):
	* test-suite/tests/ports.test ("pipe, fdopen, and line buffering"):
	("setvbuf"):
	* test-suite/tests/r6rs-ports.test ("7.2.7 Input Ports"): Update to use
	non-deprecated interfaces.

	Move setvbuf impl to ports.[ch]
	* libguile/fports.h (scm_setbuf0): Remove extraneous declaration.
	* libguile/fports.c:
	* libguile/ports.c:
	* libguile/ports.c (scm_setvbuf): Move setvbuf to ports.[ch].
	  (scm_init_ports): Move _IONBF, _IOLBF, _IOFBF definitions here.

	display-{application,-backtrace} delegate to Scheme
	* libguile/backtrace.h:
	* libguile/backtrace.c (print_frame_var, kw_count, print_frames_var)
	(frame_to_stack_vector_var): New variables.
	(init_print_frame_var)
	(init_print_frames_var_and_frame_to_stack_vector_var): New functions.
	(scm_set_print_params_x): Remove function.
	(scm_display_application): Delegate to print-frame.
	(display_backtrace_body, scm_display_backtrace_with_highlights):
	Delegate to print-frames.

	Fix frame->stack-vector when no stack is active
	* module/system/repl/debug.scm (frame->stack-vector): Handle the case
	  where there is no active stack.

2016-03-14  Andy Wingo  <wingo@pobox.com>

	Fix lower-bound saturation in type inference
	* module/language/cps/types.scm (type-entry-saturating-union): Fix range
	  saturation in the negative direction.  Previously we were artificially
	  truncating negative range ends to zero.

2016-02-03  Andy Wingo  <wingo@pobox.com>

	Release v2.1.2
	* GUILE-VERSION (GUILE_MICRO_VERSION): Bump to 2.1.2.

2016-02-02  Andy Wingo  <wingo@pobox.com>

	Fix frame-call-representation for change to <binding>.
	* module/system/vm/frame.scm (frame-call-representation): Fix for change
	  to <binding>.

2016-02-01  Andy Wingo  <wingo@pobox.com>

	Document new VM instructions
	* doc/ref/vm.texi (Stack Layout): Add a note about unboxed values.
	  (Instruction Set): Update for new instructions.

	Update NEWS.
	* NEWS: Update.

2016-02-01  Andy Wingo  <wingo@pobox.com>

	Update statprof documentation; deprecate `with-statprof'
	* module/statprof.scm: Remove most of the commentary, as it was
	  duplicated in the manual and was getting out of date.
	  (stats): Remove self-secs-per-call and cum-secs-per-call fields as
	  they can be computed from the other fields.
	  (statprof-call-data->stats): Adapt.
	  (statprof-stats-self-secs-per-call):
	  (statprof-stats-cum-secs-per-call): New functions.
	  (statprof-display/flat): Don't print the seconds-per-call fields, as
	  we are no longer stopping the clock around call counters.  Anyway
	  these times were quite misleading.
	  (with-statprof): Deprecate.  It took its keyword arguments at the
	  beginning; very complicated!  Better to use the `statprof' function.
	  (`statprof' was introduced after `with-statprof' and then
	  `with-statprof' was adapted to use it.)

	* doc/ref/statprof.texi (Statprof): Port this documentation away from
	  the automatically generated text and update it for the new interfaces
	  like #:display-style.

	* module/system/base/syntax.scm (record-case): Remove comment that
	  referenced with-statprof.  Add comment indicating that record-case
	  should be replaced.

	* doc/ref/scheme-using.texi (Profile Commands): Update to mention
	  keyword arguments and to link to the statprof documentation.

2016-02-01  Andy Wingo  <wingo@pobox.com>

	Better call-counting profiles in statprof
	* module/statprof.scm: Update commentary.
	  (count-call): Don't bother stopping and starting the timer.  The
	  overhead of call counting perturbs timing too much already, and
	  somewhat paradoxically stopping and starting the timer takes too much
	  time.
	  (skip-count-call): New function.
	  (stack-samples->procedure-data, stack-samples->callee-lists): If we
	  are counting calls, skip any part of the stack that is inside
	  count-call.

